/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.test.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class EnumDiscriminatedTypeB extends EnumDiscriminatedType implements Message {

  // Accessors for discriminator values.
  public EnumType getDiscr() {
    return EnumType.UINT;
  }

  // Properties.
  protected final short simpB;

  public EnumDiscriminatedTypeB(short simpB) {
    super();
    this.simpB = simpB;
  }

  public short getSimpB() {
    return simpB;
  }

  @Override
  protected void serializeEnumDiscriminatedTypeChild(WriteBuffer writeBuffer)
      throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("EnumDiscriminatedTypeB");

    // Simple Field (simpB)
    writeSimpleField("simpB", simpB, writeUnsignedShort(writeBuffer, 8));

    writeBuffer.popContext("EnumDiscriminatedTypeB");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    EnumDiscriminatedTypeB _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (simpB)
    lengthInBits += 8;

    return lengthInBits;
  }

  public static EnumDiscriminatedTypeBuilder staticParseEnumDiscriminatedTypeBuilder(
      ReadBuffer readBuffer) throws ParseException {
    readBuffer.pullContext("EnumDiscriminatedTypeB");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    short simpB = readSimpleField("simpB", readUnsignedShort(readBuffer, 8));

    readBuffer.closeContext("EnumDiscriminatedTypeB");
    // Create the instance
    return new EnumDiscriminatedTypeBBuilderImpl(simpB);
  }

  public static class EnumDiscriminatedTypeBBuilderImpl
      implements EnumDiscriminatedType.EnumDiscriminatedTypeBuilder {
    private final short simpB;

    public EnumDiscriminatedTypeBBuilderImpl(short simpB) {
      this.simpB = simpB;
    }

    public EnumDiscriminatedTypeB build() {
      EnumDiscriminatedTypeB enumDiscriminatedTypeB = new EnumDiscriminatedTypeB(simpB);
      return enumDiscriminatedTypeB;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof EnumDiscriminatedTypeB)) {
      return false;
    }
    EnumDiscriminatedTypeB that = (EnumDiscriminatedTypeB) o;
    return (getSimpB() == that.getSimpB()) && super.equals(that) && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getSimpB());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
