/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

#ifndef PLC4C_MODBUS_READ_WRITE_MODBUS_DEVICE_INFORMATION_LEVEL_H_
#define PLC4C_MODBUS_READ_WRITE_MODBUS_DEVICE_INFORMATION_LEVEL_H_

#include <stdbool.h>
#include <stdint.h>
#include <plc4c/spi/context.h>
#include <plc4c/spi/read_buffer.h>
#include <plc4c/spi/write_buffer.h>

// Code generated by code-generation. DO NOT EDIT.


enum plc4c_modbus_read_write_modbus_device_information_level {
  plc4c_modbus_read_write_modbus_device_information_level_BASIC = 0x01,
  plc4c_modbus_read_write_modbus_device_information_level_REGULAR = 0x02,
  plc4c_modbus_read_write_modbus_device_information_level_EXTENDED = 0x03,
  plc4c_modbus_read_write_modbus_device_information_level_INDIVIDUAL = 0x04
};
typedef enum plc4c_modbus_read_write_modbus_device_information_level plc4c_modbus_read_write_modbus_device_information_level;

// Get an empty NULL-struct
plc4c_modbus_read_write_modbus_device_information_level plc4c_modbus_read_write_modbus_device_information_level_null();

plc4c_return_code plc4c_modbus_read_write_modbus_device_information_level_parse(plc4x_spi_context ctx, plc4c_spi_read_buffer* readBuffer, plc4c_modbus_read_write_modbus_device_information_level* message);

plc4c_return_code plc4c_modbus_read_write_modbus_device_information_level_serialize(plc4x_spi_context ctx, plc4c_spi_write_buffer* writeBuffer, plc4c_modbus_read_write_modbus_device_information_level* message);

plc4c_modbus_read_write_modbus_device_information_level plc4c_modbus_read_write_modbus_device_information_level_for_value(uint8_t value);

plc4c_modbus_read_write_modbus_device_information_level plc4c_modbus_read_write_modbus_device_information_level_value_of(char* value_string);

int plc4c_modbus_read_write_modbus_device_information_level_num_values();

plc4c_modbus_read_write_modbus_device_information_level plc4c_modbus_read_write_modbus_device_information_level_value_for_index(int index);

uint16_t plc4c_modbus_read_write_modbus_device_information_level_length_in_bytes(plc4x_spi_context ctx, plc4c_modbus_read_write_modbus_device_information_level* message);

uint16_t plc4c_modbus_read_write_modbus_device_information_level_length_in_bits(plc4x_spi_context ctx, plc4c_modbus_read_write_modbus_device_information_level* message);


#endif  // PLC4C_MODBUS_READ_WRITE_MODBUS_DEVICE_INFORMATION_LEVEL_H_
