/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

#include <string.h>
#include <plc4c/driver_s7_static.h>

#include "cpu_subscribe_events.h"

// Code generated by code-generation. DO NOT EDIT.


// Create an empty NULL-struct
static const plc4c_s7_read_write_cpu_subscribe_events plc4c_s7_read_write_cpu_subscribe_events_null_const;

plc4c_s7_read_write_cpu_subscribe_events plc4c_s7_read_write_cpu_subscribe_events_null() {
  return plc4c_s7_read_write_cpu_subscribe_events_null_const;
}

// Parse function.
plc4c_return_code plc4c_s7_read_write_cpu_subscribe_events_parse(plc4x_spi_context ctx, plc4c_spi_read_buffer* readBuffer, plc4c_s7_read_write_cpu_subscribe_events* _message) {
    plc4c_return_code _res = OK;

    uint8_t value;
    _res = plc4c_spi_read_unsigned_byte(readBuffer, 8, (uint8_t*) &value);
    *_message = plc4c_s7_read_write_cpu_subscribe_events_for_value(value);

    return _res;
}

plc4c_return_code plc4c_s7_read_write_cpu_subscribe_events_serialize(plc4x_spi_context ctx, plc4c_spi_write_buffer* writeBuffer, plc4c_s7_read_write_cpu_subscribe_events* _message) {
    plc4c_return_code _res = OK;

    _res = plc4c_spi_write_unsigned_byte(writeBuffer, 8, *_message);

    return _res;
}

plc4c_s7_read_write_cpu_subscribe_events plc4c_s7_read_write_cpu_subscribe_events_for_value(uint8_t value) {
    for(int i = 0; i < plc4c_s7_read_write_cpu_subscribe_events_num_values(); i++) {
        if(plc4c_s7_read_write_cpu_subscribe_events_value_for_index(i) == value) {
            return plc4c_s7_read_write_cpu_subscribe_events_value_for_index(i);
        }
    }
    return -1;
}

plc4c_s7_read_write_cpu_subscribe_events plc4c_s7_read_write_cpu_subscribe_events_value_of(char* value_string) {
    if(strcmp(value_string, "CPU") == 0) {
        return plc4c_s7_read_write_cpu_subscribe_events_CPU;
    }
    if(strcmp(value_string, "IM") == 0) {
        return plc4c_s7_read_write_cpu_subscribe_events_IM;
    }
    if(strcmp(value_string, "FM") == 0) {
        return plc4c_s7_read_write_cpu_subscribe_events_FM;
    }
    if(strcmp(value_string, "CP") == 0) {
        return plc4c_s7_read_write_cpu_subscribe_events_CP;
    }
    return -1;
}

int plc4c_s7_read_write_cpu_subscribe_events_num_values() {
  return 4;
}

plc4c_s7_read_write_cpu_subscribe_events plc4c_s7_read_write_cpu_subscribe_events_value_for_index(int index) {
    switch(index) {
      case 0: {
        return plc4c_s7_read_write_cpu_subscribe_events_CPU;
      }
      case 1: {
        return plc4c_s7_read_write_cpu_subscribe_events_IM;
      }
      case 2: {
        return plc4c_s7_read_write_cpu_subscribe_events_FM;
      }
      case 3: {
        return plc4c_s7_read_write_cpu_subscribe_events_CP;
      }
      default: {
        return -1;
      }
    }
}

uint16_t plc4c_s7_read_write_cpu_subscribe_events_length_in_bytes(plc4x_spi_context ctx, plc4c_s7_read_write_cpu_subscribe_events* _message) {
    return plc4c_s7_read_write_cpu_subscribe_events_length_in_bits(ctx, _message) / 8;
}

uint16_t plc4c_s7_read_write_cpu_subscribe_events_length_in_bits(plc4x_spi_context ctx, plc4c_s7_read_write_cpu_subscribe_events* _message) {
    return 8;
}
