/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package model

import (
	"context"
	"fmt"

	"github.com/apache/plc4x/plc4go/spi/utils"

	"github.com/pkg/errors"
	"github.com/rs/zerolog"
)

// Code generated by code-generation. DO NOT EDIT.

// OpcuaNodeIdServicesVariableGeneral is an enum
type OpcuaNodeIdServicesVariableGeneral int32

type IOpcuaNodeIdServicesVariableGeneral interface {
	fmt.Stringer
	utils.LengthAware
	utils.Serializable
}

const (
	OpcuaNodeIdServicesVariableGeneral_GeneralModelChangeEventType_Changes OpcuaNodeIdServicesVariableGeneral = 2134
)

var OpcuaNodeIdServicesVariableGeneralValues []OpcuaNodeIdServicesVariableGeneral

func init() {
	_ = errors.New
	OpcuaNodeIdServicesVariableGeneralValues = []OpcuaNodeIdServicesVariableGeneral{
		OpcuaNodeIdServicesVariableGeneral_GeneralModelChangeEventType_Changes,
	}
}

func OpcuaNodeIdServicesVariableGeneralByValue(value int32) (enum OpcuaNodeIdServicesVariableGeneral, ok bool) {
	switch value {
	case 2134:
		return OpcuaNodeIdServicesVariableGeneral_GeneralModelChangeEventType_Changes, true
	}
	return 0, false
}

func OpcuaNodeIdServicesVariableGeneralByName(value string) (enum OpcuaNodeIdServicesVariableGeneral, ok bool) {
	switch value {
	case "GeneralModelChangeEventType_Changes":
		return OpcuaNodeIdServicesVariableGeneral_GeneralModelChangeEventType_Changes, true
	}
	return 0, false
}

func OpcuaNodeIdServicesVariableGeneralKnows(value int32) bool {
	for _, typeValue := range OpcuaNodeIdServicesVariableGeneralValues {
		if int32(typeValue) == value {
			return true
		}
	}
	return false
}

func CastOpcuaNodeIdServicesVariableGeneral(structType any) OpcuaNodeIdServicesVariableGeneral {
	castFunc := func(typ any) OpcuaNodeIdServicesVariableGeneral {
		if sOpcuaNodeIdServicesVariableGeneral, ok := typ.(OpcuaNodeIdServicesVariableGeneral); ok {
			return sOpcuaNodeIdServicesVariableGeneral
		}
		return 0
	}
	return castFunc(structType)
}

func (m OpcuaNodeIdServicesVariableGeneral) GetLengthInBits(ctx context.Context) uint16 {
	return 32
}

func (m OpcuaNodeIdServicesVariableGeneral) GetLengthInBytes(ctx context.Context) uint16 {
	return m.GetLengthInBits(ctx) / 8
}

func OpcuaNodeIdServicesVariableGeneralParse(ctx context.Context, theBytes []byte) (OpcuaNodeIdServicesVariableGeneral, error) {
	return OpcuaNodeIdServicesVariableGeneralParseWithBuffer(ctx, utils.NewReadBufferByteBased(theBytes))
}

func OpcuaNodeIdServicesVariableGeneralParseWithBuffer(ctx context.Context, readBuffer utils.ReadBuffer) (OpcuaNodeIdServicesVariableGeneral, error) {
	log := zerolog.Ctx(ctx)
	_ = log
	val, err := readBuffer.ReadInt32("OpcuaNodeIdServicesVariableGeneral", 32)
	if err != nil {
		return 0, errors.Wrap(err, "error reading OpcuaNodeIdServicesVariableGeneral")
	}
	if enum, ok := OpcuaNodeIdServicesVariableGeneralByValue(val); !ok {
		log.Debug().Interface("val", val).Msg("no value val found for OpcuaNodeIdServicesVariableGeneral")
		return OpcuaNodeIdServicesVariableGeneral(val), nil
	} else {
		return enum, nil
	}
}

func (e OpcuaNodeIdServicesVariableGeneral) Serialize() ([]byte, error) {
	wb := utils.NewWriteBufferByteBased()
	if err := e.SerializeWithWriteBuffer(context.Background(), wb); err != nil {
		return nil, err
	}
	return wb.GetBytes(), nil
}

func (e OpcuaNodeIdServicesVariableGeneral) SerializeWithWriteBuffer(ctx context.Context, writeBuffer utils.WriteBuffer) error {
	log := zerolog.Ctx(ctx)
	_ = log
	return writeBuffer.WriteInt32("OpcuaNodeIdServicesVariableGeneral", 32, int32(int32(e)), utils.WithAdditionalStringRepresentation(e.PLC4XEnumName()))
}

// PLC4XEnumName returns the name that is used in code to identify this enum
func (e OpcuaNodeIdServicesVariableGeneral) PLC4XEnumName() string {
	switch e {
	case OpcuaNodeIdServicesVariableGeneral_GeneralModelChangeEventType_Changes:
		return "GeneralModelChangeEventType_Changes"
	}
	return fmt.Sprintf("Unknown(%v)", int32(e))
}

func (e OpcuaNodeIdServicesVariableGeneral) String() string {
	return e.PLC4XEnumName()
}
