/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum BACnetAccessCredentialDisableReason {
  DISABLED((int) 0),
  DISABLED_NEEDS_PROVISIONING((int) 1),
  DISABLED_UNASSIGNED((int) 2),
  DISABLED_NOT_YET_ACTIVE((int) 3),
  DISABLED_EXPIRED((int) 4),
  DISABLED_LOCKOUT((int) 5),
  DISABLED_MAX_DAYS((int) 6),
  DISABLED_MAX_USES((int) 7),
  DISABLED_INACTIVITY((int) 8),
  DISABLED_MANUAL((int) 9),
  VENDOR_PROPRIETARY_VALUE((int) 0XFFFF);
  private static final Map<Integer, BACnetAccessCredentialDisableReason> map;

  static {
    map = new HashMap<>();
    for (BACnetAccessCredentialDisableReason value : BACnetAccessCredentialDisableReason.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  BACnetAccessCredentialDisableReason(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static BACnetAccessCredentialDisableReason enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
