/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum BACnetConfirmedServiceRequestReinitializeDeviceReinitializedStateOfDevice {
  COLDSTART((short) 0x0),
  WARMSTART((short) 0x1),
  ACTIVATE_CHANGES((short) 0x2),
  STARTBACKUP((short) 0x3),
  ENDBACKUP((short) 0x4),
  STARTRESTORE((short) 0x5),
  ENDRESTORE((short) 0x6),
  ABORTRESTORE((short) 0x7),
  VENDOR_PROPRIETARY_VALUE((short) 0xFF);
  private static final Map<
          Short, BACnetConfirmedServiceRequestReinitializeDeviceReinitializedStateOfDevice>
      map;

  static {
    map = new HashMap<>();
    for (BACnetConfirmedServiceRequestReinitializeDeviceReinitializedStateOfDevice value :
        BACnetConfirmedServiceRequestReinitializeDeviceReinitializedStateOfDevice.values()) {
      map.put((short) value.getValue(), value);
    }
  }

  private final short value;

  BACnetConfirmedServiceRequestReinitializeDeviceReinitializedStateOfDevice(short value) {
    this.value = value;
  }

  public short getValue() {
    return value;
  }

  public static BACnetConfirmedServiceRequestReinitializeDeviceReinitializedStateOfDevice
      enumForValue(short value) {
    return map.get(value);
  }

  public static Boolean isDefined(short value) {
    return map.containsKey(value);
  }
}
