/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum BACnetDoorStatus {
  CLOSED((int) 0),
  OPENED((int) 1),
  UNKNOWN((int) 2),
  DOOR_FAULT((int) 3),
  UNUSED((int) 4),
  NONE((int) 5),
  CLOSING((int) 6),
  OPENING((int) 7),
  SAFETY_LOCKED((int) 8),
  LIMITED_OPENED((int) 9),
  VENDOR_PROPRIETARY_VALUE((int) 0XFFFF);
  private static final Map<Integer, BACnetDoorStatus> map;

  static {
    map = new HashMap<>();
    for (BACnetDoorStatus value : BACnetDoorStatus.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  BACnetDoorStatus(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static BACnetDoorStatus enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
