/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class BACnetOptionalBinaryPVValue extends BACnetOptionalBinaryPV implements Message {

  // Accessors for discriminator values.

  // Properties.
  protected final BACnetBinaryPVTagged binaryPv;

  public BACnetOptionalBinaryPVValue(
      BACnetTagHeader peekedTagHeader, BACnetBinaryPVTagged binaryPv) {
    super(peekedTagHeader);
    this.binaryPv = binaryPv;
  }

  public BACnetBinaryPVTagged getBinaryPv() {
    return binaryPv;
  }

  @Override
  protected void serializeBACnetOptionalBinaryPVChild(WriteBuffer writeBuffer)
      throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("BACnetOptionalBinaryPVValue");

    // Simple Field (binaryPv)
    writeSimpleField("binaryPv", binaryPv, new DataWriterComplexDefault<>(writeBuffer));

    writeBuffer.popContext("BACnetOptionalBinaryPVValue");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    BACnetOptionalBinaryPVValue _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (binaryPv)
    lengthInBits += binaryPv.getLengthInBits();

    return lengthInBits;
  }

  public static BACnetOptionalBinaryPVBuilder staticParseBACnetOptionalBinaryPVBuilder(
      ReadBuffer readBuffer) throws ParseException {
    readBuffer.pullContext("BACnetOptionalBinaryPVValue");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    BACnetBinaryPVTagged binaryPv =
        readSimpleField(
            "binaryPv",
            new DataReaderComplexDefault<>(
                () ->
                    BACnetBinaryPVTagged.staticParse(
                        readBuffer, (short) (0), (TagClass) (TagClass.APPLICATION_TAGS)),
                readBuffer));

    readBuffer.closeContext("BACnetOptionalBinaryPVValue");
    // Create the instance
    return new BACnetOptionalBinaryPVValueBuilderImpl(binaryPv);
  }

  public static class BACnetOptionalBinaryPVValueBuilderImpl
      implements BACnetOptionalBinaryPV.BACnetOptionalBinaryPVBuilder {
    private final BACnetBinaryPVTagged binaryPv;

    public BACnetOptionalBinaryPVValueBuilderImpl(BACnetBinaryPVTagged binaryPv) {
      this.binaryPv = binaryPv;
    }

    public BACnetOptionalBinaryPVValue build(BACnetTagHeader peekedTagHeader) {
      BACnetOptionalBinaryPVValue bACnetOptionalBinaryPVValue =
          new BACnetOptionalBinaryPVValue(peekedTagHeader, binaryPv);
      return bACnetOptionalBinaryPVValue;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof BACnetOptionalBinaryPVValue)) {
      return false;
    }
    BACnetOptionalBinaryPVValue that = (BACnetOptionalBinaryPVValue) o;
    return (getBinaryPv() == that.getBinaryPv()) && super.equals(that) && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getBinaryPv());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
