/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class BACnetPropertyStatesBacnetIpMode extends BACnetPropertyStates implements Message {

  // Accessors for discriminator values.

  // Properties.
  protected final BACnetIPModeTagged bacnetIpMode;

  public BACnetPropertyStatesBacnetIpMode(
      BACnetTagHeader peekedTagHeader, BACnetIPModeTagged bacnetIpMode) {
    super(peekedTagHeader);
    this.bacnetIpMode = bacnetIpMode;
  }

  public BACnetIPModeTagged getBacnetIpMode() {
    return bacnetIpMode;
  }

  @Override
  protected void serializeBACnetPropertyStatesChild(WriteBuffer writeBuffer)
      throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("BACnetPropertyStatesBacnetIpMode");

    // Simple Field (bacnetIpMode)
    writeSimpleField("bacnetIpMode", bacnetIpMode, new DataWriterComplexDefault<>(writeBuffer));

    writeBuffer.popContext("BACnetPropertyStatesBacnetIpMode");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    BACnetPropertyStatesBacnetIpMode _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (bacnetIpMode)
    lengthInBits += bacnetIpMode.getLengthInBits();

    return lengthInBits;
  }

  public static BACnetPropertyStatesBuilder staticParseBACnetPropertyStatesBuilder(
      ReadBuffer readBuffer, Short peekedTagNumber) throws ParseException {
    readBuffer.pullContext("BACnetPropertyStatesBacnetIpMode");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    BACnetIPModeTagged bacnetIpMode =
        readSimpleField(
            "bacnetIpMode",
            new DataReaderComplexDefault<>(
                () ->
                    BACnetIPModeTagged.staticParse(
                        readBuffer,
                        (short) (peekedTagNumber),
                        (TagClass) (TagClass.CONTEXT_SPECIFIC_TAGS)),
                readBuffer));

    readBuffer.closeContext("BACnetPropertyStatesBacnetIpMode");
    // Create the instance
    return new BACnetPropertyStatesBacnetIpModeBuilderImpl(bacnetIpMode);
  }

  public static class BACnetPropertyStatesBacnetIpModeBuilderImpl
      implements BACnetPropertyStates.BACnetPropertyStatesBuilder {
    private final BACnetIPModeTagged bacnetIpMode;

    public BACnetPropertyStatesBacnetIpModeBuilderImpl(BACnetIPModeTagged bacnetIpMode) {
      this.bacnetIpMode = bacnetIpMode;
    }

    public BACnetPropertyStatesBacnetIpMode build(BACnetTagHeader peekedTagHeader) {
      BACnetPropertyStatesBacnetIpMode bACnetPropertyStatesBacnetIpMode =
          new BACnetPropertyStatesBacnetIpMode(peekedTagHeader, bacnetIpMode);
      return bACnetPropertyStatesBacnetIpMode;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof BACnetPropertyStatesBacnetIpMode)) {
      return false;
    }
    BACnetPropertyStatesBacnetIpMode that = (BACnetPropertyStatesBacnetIpMode) o;
    return (getBacnetIpMode() == that.getBacnetIpMode()) && super.equals(that) && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getBacnetIpMode());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
