/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class BACnetPropertyStatesLifeSafetyOperations extends BACnetPropertyStates
    implements Message {

  // Accessors for discriminator values.

  // Properties.
  protected final BACnetLifeSafetyOperationTagged lifeSafetyOperations;

  public BACnetPropertyStatesLifeSafetyOperations(
      BACnetTagHeader peekedTagHeader, BACnetLifeSafetyOperationTagged lifeSafetyOperations) {
    super(peekedTagHeader);
    this.lifeSafetyOperations = lifeSafetyOperations;
  }

  public BACnetLifeSafetyOperationTagged getLifeSafetyOperations() {
    return lifeSafetyOperations;
  }

  @Override
  protected void serializeBACnetPropertyStatesChild(WriteBuffer writeBuffer)
      throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("BACnetPropertyStatesLifeSafetyOperations");

    // Simple Field (lifeSafetyOperations)
    writeSimpleField(
        "lifeSafetyOperations", lifeSafetyOperations, new DataWriterComplexDefault<>(writeBuffer));

    writeBuffer.popContext("BACnetPropertyStatesLifeSafetyOperations");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    BACnetPropertyStatesLifeSafetyOperations _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (lifeSafetyOperations)
    lengthInBits += lifeSafetyOperations.getLengthInBits();

    return lengthInBits;
  }

  public static BACnetPropertyStatesBuilder staticParseBACnetPropertyStatesBuilder(
      ReadBuffer readBuffer, Short peekedTagNumber) throws ParseException {
    readBuffer.pullContext("BACnetPropertyStatesLifeSafetyOperations");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    BACnetLifeSafetyOperationTagged lifeSafetyOperations =
        readSimpleField(
            "lifeSafetyOperations",
            new DataReaderComplexDefault<>(
                () ->
                    BACnetLifeSafetyOperationTagged.staticParse(
                        readBuffer,
                        (short) (peekedTagNumber),
                        (TagClass) (TagClass.CONTEXT_SPECIFIC_TAGS)),
                readBuffer));

    readBuffer.closeContext("BACnetPropertyStatesLifeSafetyOperations");
    // Create the instance
    return new BACnetPropertyStatesLifeSafetyOperationsBuilderImpl(lifeSafetyOperations);
  }

  public static class BACnetPropertyStatesLifeSafetyOperationsBuilderImpl
      implements BACnetPropertyStates.BACnetPropertyStatesBuilder {
    private final BACnetLifeSafetyOperationTagged lifeSafetyOperations;

    public BACnetPropertyStatesLifeSafetyOperationsBuilderImpl(
        BACnetLifeSafetyOperationTagged lifeSafetyOperations) {
      this.lifeSafetyOperations = lifeSafetyOperations;
    }

    public BACnetPropertyStatesLifeSafetyOperations build(BACnetTagHeader peekedTagHeader) {
      BACnetPropertyStatesLifeSafetyOperations bACnetPropertyStatesLifeSafetyOperations =
          new BACnetPropertyStatesLifeSafetyOperations(peekedTagHeader, lifeSafetyOperations);
      return bACnetPropertyStatesLifeSafetyOperations;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof BACnetPropertyStatesLifeSafetyOperations)) {
      return false;
    }
    BACnetPropertyStatesLifeSafetyOperations that = (BACnetPropertyStatesLifeSafetyOperations) o;
    return (getLifeSafetyOperations() == that.getLifeSafetyOperations())
        && super.equals(that)
        && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getLifeSafetyOperations());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
