/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class BACnetValueSourceObject extends BACnetValueSource implements Message {

  // Accessors for discriminator values.

  // Properties.
  protected final BACnetDeviceObjectReferenceEnclosed object;

  public BACnetValueSourceObject(
      BACnetTagHeader peekedTagHeader, BACnetDeviceObjectReferenceEnclosed object) {
    super(peekedTagHeader);
    this.object = object;
  }

  public BACnetDeviceObjectReferenceEnclosed getObject() {
    return object;
  }

  @Override
  protected void serializeBACnetValueSourceChild(WriteBuffer writeBuffer)
      throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("BACnetValueSourceObject");

    // Simple Field (object)
    writeSimpleField("object", object, new DataWriterComplexDefault<>(writeBuffer));

    writeBuffer.popContext("BACnetValueSourceObject");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    BACnetValueSourceObject _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (object)
    lengthInBits += object.getLengthInBits();

    return lengthInBits;
  }

  public static BACnetValueSourceBuilder staticParseBACnetValueSourceBuilder(ReadBuffer readBuffer)
      throws ParseException {
    readBuffer.pullContext("BACnetValueSourceObject");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    BACnetDeviceObjectReferenceEnclosed object =
        readSimpleField(
            "object",
            new DataReaderComplexDefault<>(
                () -> BACnetDeviceObjectReferenceEnclosed.staticParse(readBuffer, (short) (1)),
                readBuffer));

    readBuffer.closeContext("BACnetValueSourceObject");
    // Create the instance
    return new BACnetValueSourceObjectBuilderImpl(object);
  }

  public static class BACnetValueSourceObjectBuilderImpl
      implements BACnetValueSource.BACnetValueSourceBuilder {
    private final BACnetDeviceObjectReferenceEnclosed object;

    public BACnetValueSourceObjectBuilderImpl(BACnetDeviceObjectReferenceEnclosed object) {
      this.object = object;
    }

    public BACnetValueSourceObject build(BACnetTagHeader peekedTagHeader) {
      BACnetValueSourceObject bACnetValueSourceObject =
          new BACnetValueSourceObject(peekedTagHeader, object);
      return bACnetValueSourceObject;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof BACnetValueSourceObject)) {
      return false;
    }
    BACnetValueSourceObject that = (BACnetValueSourceObject) o;
    return (getObject() == that.getObject()) && super.equals(that) && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getObject());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
