/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class NLMSetMasterKey extends NLM implements Message {

  // Accessors for discriminator values.
  public Short getMessageType() {
    return (short) 0x11;
  }

  // Properties.
  protected final NLMUpdateKeyUpdateKeyEntry key;

  // Arguments.
  protected final Integer apduLength;

  public NLMSetMasterKey(NLMUpdateKeyUpdateKeyEntry key, Integer apduLength) {
    super(apduLength);
    this.key = key;
    this.apduLength = apduLength;
  }

  public NLMUpdateKeyUpdateKeyEntry getKey() {
    return key;
  }

  @Override
  protected void serializeNLMChild(WriteBuffer writeBuffer) throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("NLMSetMasterKey");

    // Simple Field (key)
    writeSimpleField("key", key, new DataWriterComplexDefault<>(writeBuffer));

    writeBuffer.popContext("NLMSetMasterKey");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    NLMSetMasterKey _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (key)
    lengthInBits += key.getLengthInBits();

    return lengthInBits;
  }

  public static NLMBuilder staticParseNLMBuilder(ReadBuffer readBuffer, Integer apduLength)
      throws ParseException {
    readBuffer.pullContext("NLMSetMasterKey");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    NLMUpdateKeyUpdateKeyEntry key =
        readSimpleField(
            "key",
            new DataReaderComplexDefault<>(
                () -> NLMUpdateKeyUpdateKeyEntry.staticParse(readBuffer), readBuffer));

    readBuffer.closeContext("NLMSetMasterKey");
    // Create the instance
    return new NLMSetMasterKeyBuilderImpl(key, apduLength);
  }

  public static class NLMSetMasterKeyBuilderImpl implements NLM.NLMBuilder {
    private final NLMUpdateKeyUpdateKeyEntry key;
    private final Integer apduLength;

    public NLMSetMasterKeyBuilderImpl(NLMUpdateKeyUpdateKeyEntry key, Integer apduLength) {
      this.key = key;
      this.apduLength = apduLength;
    }

    public NLMSetMasterKey build(Integer apduLength) {

      NLMSetMasterKey nLMSetMasterKey = new NLMSetMasterKey(key, apduLength);
      return nLMSetMasterKey;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof NLMSetMasterKey)) {
      return false;
    }
    NLMSetMasterKey that = (NLMSetMasterKey) o;
    return (getKey() == that.getKey()) && super.equals(that) && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getKey());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
