/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.bacnetip.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class SubscribeCOVPropertyMultipleError extends BACnetError implements Message {

  // Accessors for discriminator values.
  public BACnetConfirmedServiceChoice getErrorChoice() {
    return BACnetConfirmedServiceChoice.SUBSCRIBE_COV_PROPERTY_MULTIPLE;
  }

  // Properties.
  protected final ErrorEnclosed errorType;
  protected final SubscribeCOVPropertyMultipleErrorFirstFailedSubscription firstFailedSubscription;

  public SubscribeCOVPropertyMultipleError(
      ErrorEnclosed errorType,
      SubscribeCOVPropertyMultipleErrorFirstFailedSubscription firstFailedSubscription) {
    super();
    this.errorType = errorType;
    this.firstFailedSubscription = firstFailedSubscription;
  }

  public ErrorEnclosed getErrorType() {
    return errorType;
  }

  public SubscribeCOVPropertyMultipleErrorFirstFailedSubscription getFirstFailedSubscription() {
    return firstFailedSubscription;
  }

  @Override
  protected void serializeBACnetErrorChild(WriteBuffer writeBuffer) throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("SubscribeCOVPropertyMultipleError");

    // Simple Field (errorType)
    writeSimpleField("errorType", errorType, new DataWriterComplexDefault<>(writeBuffer));

    // Simple Field (firstFailedSubscription)
    writeSimpleField(
        "firstFailedSubscription",
        firstFailedSubscription,
        new DataWriterComplexDefault<>(writeBuffer));

    writeBuffer.popContext("SubscribeCOVPropertyMultipleError");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    SubscribeCOVPropertyMultipleError _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (errorType)
    lengthInBits += errorType.getLengthInBits();

    // Simple field (firstFailedSubscription)
    lengthInBits += firstFailedSubscription.getLengthInBits();

    return lengthInBits;
  }

  public static BACnetErrorBuilder staticParseBACnetErrorBuilder(
      ReadBuffer readBuffer, BACnetConfirmedServiceChoice errorChoice) throws ParseException {
    readBuffer.pullContext("SubscribeCOVPropertyMultipleError");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    ErrorEnclosed errorType =
        readSimpleField(
            "errorType",
            new DataReaderComplexDefault<>(
                () -> ErrorEnclosed.staticParse(readBuffer, (short) (0)), readBuffer));

    SubscribeCOVPropertyMultipleErrorFirstFailedSubscription firstFailedSubscription =
        readSimpleField(
            "firstFailedSubscription",
            new DataReaderComplexDefault<>(
                () ->
                    SubscribeCOVPropertyMultipleErrorFirstFailedSubscription.staticParse(
                        readBuffer, (short) (1)),
                readBuffer));

    readBuffer.closeContext("SubscribeCOVPropertyMultipleError");
    // Create the instance
    return new SubscribeCOVPropertyMultipleErrorBuilderImpl(errorType, firstFailedSubscription);
  }

  public static class SubscribeCOVPropertyMultipleErrorBuilderImpl
      implements BACnetError.BACnetErrorBuilder {
    private final ErrorEnclosed errorType;
    private final SubscribeCOVPropertyMultipleErrorFirstFailedSubscription firstFailedSubscription;

    public SubscribeCOVPropertyMultipleErrorBuilderImpl(
        ErrorEnclosed errorType,
        SubscribeCOVPropertyMultipleErrorFirstFailedSubscription firstFailedSubscription) {
      this.errorType = errorType;
      this.firstFailedSubscription = firstFailedSubscription;
    }

    public SubscribeCOVPropertyMultipleError build() {
      SubscribeCOVPropertyMultipleError subscribeCOVPropertyMultipleError =
          new SubscribeCOVPropertyMultipleError(errorType, firstFailedSubscription);
      return subscribeCOVPropertyMultipleError;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof SubscribeCOVPropertyMultipleError)) {
      return false;
    }
    SubscribeCOVPropertyMultipleError that = (SubscribeCOVPropertyMultipleError) o;
    return (getErrorType() == that.getErrorType())
        && (getFirstFailedSubscription() == that.getFirstFailedSubscription())
        && super.equals(that)
        && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getErrorType(), getFirstFailedSubscription());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
