/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.cbus.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum ErrorReportingSystemCategoryTypeForOutputUnits {
  LE_MONOBLOCK_DIMMERS((byte) 0x0),
  TE_MONOBLOCK_DIMMERS((byte) 0x1),
  RESERVED_2((byte) 0x2),
  RESERVED_3((byte) 0x3),
  RELAYS_AND_OTHER_ON_OFF_SWITCHING_DEVICES((byte) 0x4),
  RESERVED_5((byte) 0x5),
  PWM_DIMMERS_INCLUDES_LED_CONTROL((byte) 0x6),
  SINEWAVE_MONOBLOCK_DIMMERS((byte) 0x7),
  RESERVED_8((byte) 0x8),
  RESERVED_9((byte) 0x9),
  DALI_DSI_AND_OTHER_BALLAST_CONTROL_GATEWAYS((byte) 0xA),
  MODULAR_DIMMERS((byte) 0xB),
  RESERVED_12((byte) 0xC),
  UNIVERSAL_MONOBLOCK_DIMMERS((byte) 0xD),
  DEVICE_CONTROLLERS_IR_RS_232_etc((byte) 0xE),
  RESERVED_15((byte) 0xF);
  private static final Map<Byte, ErrorReportingSystemCategoryTypeForOutputUnits> map;

  static {
    map = new HashMap<>();
    for (ErrorReportingSystemCategoryTypeForOutputUnits value :
        ErrorReportingSystemCategoryTypeForOutputUnits.values()) {
      map.put((byte) value.getValue(), value);
    }
  }

  private final byte value;

  ErrorReportingSystemCategoryTypeForOutputUnits(byte value) {
    this.value = value;
  }

  public byte getValue() {
    return value;
  }

  public static ErrorReportingSystemCategoryTypeForOutputUnits enumForValue(byte value) {
    return map.get(value);
  }

  public static Boolean isDefined(byte value) {
    return map.containsKey(value);
  }
}
