/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.cbus.readwrite;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum MeteringCommandTypeContainer {
  MeteringCommandEvent_0Bytes((short) 0x08, (byte) 0, MeteringCommandType.EVENT),
  MeteringCommandEvent_1Bytes((short) 0x09, (byte) 1, MeteringCommandType.EVENT),
  MeteringCommandEvent_2Bytes((short) 0x0A, (byte) 2, MeteringCommandType.EVENT),
  MeteringCommandEvent_3Bytes((short) 0x0B, (byte) 3, MeteringCommandType.EVENT),
  MeteringCommandEvent_4Bytes((short) 0x0C, (byte) 4, MeteringCommandType.EVENT),
  MeteringCommandEvent_5Bytes((short) 0x0D, (byte) 5, MeteringCommandType.EVENT),
  MeteringCommandEvent_6Bytes((short) 0x0E, (byte) 6, MeteringCommandType.EVENT),
  MeteringCommandEvent_7Bytes((short) 0x0F, (byte) 7, MeteringCommandType.EVENT);
  private static final Map<Short, MeteringCommandTypeContainer> map;

  static {
    map = new HashMap<>();
    for (MeteringCommandTypeContainer value : MeteringCommandTypeContainer.values()) {
      map.put((short) value.getValue(), value);
    }
  }

  private final short value;
  private final byte numBytes;
  private final MeteringCommandType commandType;

  MeteringCommandTypeContainer(short value, byte numBytes, MeteringCommandType commandType) {
    this.value = value;
    this.numBytes = numBytes;
    this.commandType = commandType;
  }

  public short getValue() {
    return value;
  }

  public byte getNumBytes() {
    return numBytes;
  }

  public static MeteringCommandTypeContainer firstEnumForFieldNumBytes(byte fieldValue) {
    for (MeteringCommandTypeContainer _val : MeteringCommandTypeContainer.values()) {
      if (_val.getNumBytes() == fieldValue) {
        return _val;
      }
    }
    return null;
  }

  public static List<MeteringCommandTypeContainer> enumsForFieldNumBytes(byte fieldValue) {
    List<MeteringCommandTypeContainer> _values = new ArrayList<>();
    for (MeteringCommandTypeContainer _val : MeteringCommandTypeContainer.values()) {
      if (_val.getNumBytes() == fieldValue) {
        _values.add(_val);
      }
    }
    return _values;
  }

  public MeteringCommandType getCommandType() {
    return commandType;
  }

  public static MeteringCommandTypeContainer firstEnumForFieldCommandType(
      MeteringCommandType fieldValue) {
    for (MeteringCommandTypeContainer _val : MeteringCommandTypeContainer.values()) {
      if (_val.getCommandType() == fieldValue) {
        return _val;
      }
    }
    return null;
  }

  public static List<MeteringCommandTypeContainer> enumsForFieldCommandType(
      MeteringCommandType fieldValue) {
    List<MeteringCommandTypeContainer> _values = new ArrayList<>();
    for (MeteringCommandTypeContainer _val : MeteringCommandTypeContainer.values()) {
      if (_val.getCommandType() == fieldValue) {
        _values.add(_val);
      }
    }
    return _values;
  }

  public static MeteringCommandTypeContainer enumForValue(short value) {
    return map.get(value);
  }

  public static Boolean isDefined(short value) {
    return map.containsKey(value);
  }
}
