/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.cbus.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class RequestContext implements Message {

  // Properties.
  protected final boolean sendIdentifyRequestBefore;

  public RequestContext(boolean sendIdentifyRequestBefore) {
    super();
    this.sendIdentifyRequestBefore = sendIdentifyRequestBefore;
  }

  public boolean getSendIdentifyRequestBefore() {
    return sendIdentifyRequestBefore;
  }

  public void serialize(WriteBuffer writeBuffer) throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("RequestContext");

    // Simple Field (sendIdentifyRequestBefore)
    writeSimpleField(
        "sendIdentifyRequestBefore", sendIdentifyRequestBefore, writeBoolean(writeBuffer));

    writeBuffer.popContext("RequestContext");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = 0;
    RequestContext _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (sendIdentifyRequestBefore)
    lengthInBits += 1;

    return lengthInBits;
  }

  public static RequestContext staticParse(ReadBuffer readBuffer, Object... args)
      throws ParseException {
    PositionAware positionAware = readBuffer;
    return staticParse(readBuffer);
  }

  public static RequestContext staticParse(ReadBuffer readBuffer) throws ParseException {
    readBuffer.pullContext("RequestContext");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    boolean sendIdentifyRequestBefore =
        readSimpleField("sendIdentifyRequestBefore", readBoolean(readBuffer));

    readBuffer.closeContext("RequestContext");
    // Create the instance
    RequestContext _requestContext;
    _requestContext = new RequestContext(sendIdentifyRequestBefore);
    return _requestContext;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof RequestContext)) {
      return false;
    }
    RequestContext that = (RequestContext) o;
    return (getSendIdentifyRequestBefore() == that.getSendIdentifyRequestBefore()) && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(getSendIdentifyRequestBefore());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
