/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.iec608705104.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE
    extends InformationObjectWithTreeByteTime implements Message {

  // Accessors for discriminator values.
  public TypeIdentification getTypeIdentification() {
    return TypeIdentification.MEASURED_VALUE_SCALED_VALUE_WITH_TIME_TAG;
  }

  // Properties.
  protected final ScaledValue sva;
  protected final QualityDescriptor qds;
  protected final ThreeOctetBinaryTime cp24Time2a;

  public InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE(
      int address, ScaledValue sva, QualityDescriptor qds, ThreeOctetBinaryTime cp24Time2a) {
    super(address);
    this.sva = sva;
    this.qds = qds;
    this.cp24Time2a = cp24Time2a;
  }

  public ScaledValue getSva() {
    return sva;
  }

  public QualityDescriptor getQds() {
    return qds;
  }

  public ThreeOctetBinaryTime getCp24Time2a() {
    return cp24Time2a;
  }

  @Override
  protected void serializeInformationObjectWithTreeByteTimeChild(WriteBuffer writeBuffer)
      throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE");

    // Simple Field (sva)
    writeSimpleField(
        "sva",
        sva,
        new DataWriterComplexDefault<>(writeBuffer),
        WithOption.WithByteOrder(ByteOrder.LITTLE_ENDIAN));

    // Simple Field (qds)
    writeSimpleField(
        "qds",
        qds,
        new DataWriterComplexDefault<>(writeBuffer),
        WithOption.WithByteOrder(ByteOrder.LITTLE_ENDIAN));

    // Simple Field (cp24Time2a)
    writeSimpleField(
        "cp24Time2a",
        cp24Time2a,
        new DataWriterComplexDefault<>(writeBuffer),
        WithOption.WithByteOrder(ByteOrder.LITTLE_ENDIAN));

    writeBuffer.popContext("InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = super.getLengthInBits();
    InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (sva)
    lengthInBits += sva.getLengthInBits();

    // Simple field (qds)
    lengthInBits += qds.getLengthInBits();

    // Simple field (cp24Time2a)
    lengthInBits += cp24Time2a.getLengthInBits();

    return lengthInBits;
  }

  public static InformationObjectWithTreeByteTimeBuilder
      staticParseInformationObjectWithTreeByteTimeBuilder(
          ReadBuffer readBuffer, TypeIdentification typeIdentification, Byte numTimeByte)
          throws ParseException {
    readBuffer.pullContext("InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    ScaledValue sva =
        readSimpleField(
            "sva",
            new DataReaderComplexDefault<>(() -> ScaledValue.staticParse(readBuffer), readBuffer),
            WithOption.WithByteOrder(ByteOrder.LITTLE_ENDIAN));

    QualityDescriptor qds =
        readSimpleField(
            "qds",
            new DataReaderComplexDefault<>(
                () -> QualityDescriptor.staticParse(readBuffer), readBuffer),
            WithOption.WithByteOrder(ByteOrder.LITTLE_ENDIAN));

    ThreeOctetBinaryTime cp24Time2a =
        readSimpleField(
            "cp24Time2a",
            new DataReaderComplexDefault<>(
                () -> ThreeOctetBinaryTime.staticParse(readBuffer), readBuffer),
            WithOption.WithByteOrder(ByteOrder.LITTLE_ENDIAN));

    readBuffer.closeContext("InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE");
    // Create the instance
    return new InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUEBuilderImpl(
        sva, qds, cp24Time2a);
  }

  public static class InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUEBuilderImpl
      implements InformationObjectWithTreeByteTime.InformationObjectWithTreeByteTimeBuilder {
    private final ScaledValue sva;
    private final QualityDescriptor qds;
    private final ThreeOctetBinaryTime cp24Time2a;

    public InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUEBuilderImpl(
        ScaledValue sva, QualityDescriptor qds, ThreeOctetBinaryTime cp24Time2a) {
      this.sva = sva;
      this.qds = qds;
      this.cp24Time2a = cp24Time2a;
    }

    public InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE build(int address) {
      InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE
          informationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE =
              new InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE(
                  address, sva, qds, cp24Time2a);
      return informationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE)) {
      return false;
    }
    InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE that =
        (InformationObjectWithTreeByteTime_MEASURED_VALUE_SCALED_VALUE) o;
    return (getSva() == that.getSva())
        && (getQds() == that.getQds())
        && (getCp24Time2a() == that.getCp24Time2a())
        && super.equals(that)
        && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), getSva(), getQds(), getCp24Time2a());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
