/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.knxnetip.readwrite;

import static org.apache.plc4x.java.spi.codegen.fields.FieldReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.fields.FieldWriterFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataReaderFactory.*;
import static org.apache.plc4x.java.spi.codegen.io.DataWriterFactory.*;
import static org.apache.plc4x.java.spi.generation.StaticHelper.*;

import java.time.*;
import java.util.*;
import org.apache.plc4x.java.api.exceptions.*;
import org.apache.plc4x.java.api.value.*;
import org.apache.plc4x.java.spi.codegen.*;
import org.apache.plc4x.java.spi.codegen.fields.*;
import org.apache.plc4x.java.spi.codegen.io.*;
import org.apache.plc4x.java.spi.generation.*;

// Code generated by code-generation. DO NOT EDIT.

public class ChannelInformation implements Message {

  // Properties.
  protected final byte numChannels;
  protected final short channelCode;

  public ChannelInformation(byte numChannels, short channelCode) {
    super();
    this.numChannels = numChannels;
    this.channelCode = channelCode;
  }

  public byte getNumChannels() {
    return numChannels;
  }

  public short getChannelCode() {
    return channelCode;
  }

  public void serialize(WriteBuffer writeBuffer) throws SerializationException {
    PositionAware positionAware = writeBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();
    writeBuffer.pushContext("ChannelInformation");

    // Simple Field (numChannels)
    writeSimpleField("numChannels", numChannels, writeUnsignedByte(writeBuffer, 3));

    // Simple Field (channelCode)
    writeSimpleField("channelCode", channelCode, writeUnsignedShort(writeBuffer, 13));

    writeBuffer.popContext("ChannelInformation");
  }

  @Override
  public int getLengthInBytes() {
    return (int) Math.ceil((float) getLengthInBits() / 8.0);
  }

  @Override
  public int getLengthInBits() {
    int lengthInBits = 0;
    ChannelInformation _value = this;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    // Simple field (numChannels)
    lengthInBits += 3;

    // Simple field (channelCode)
    lengthInBits += 13;

    return lengthInBits;
  }

  public static ChannelInformation staticParse(ReadBuffer readBuffer, Object... args)
      throws ParseException {
    PositionAware positionAware = readBuffer;
    return staticParse(readBuffer);
  }

  public static ChannelInformation staticParse(ReadBuffer readBuffer) throws ParseException {
    readBuffer.pullContext("ChannelInformation");
    PositionAware positionAware = readBuffer;
    boolean _lastItem = ThreadLocalHelper.lastItemThreadLocal.get();

    byte numChannels = readSimpleField("numChannels", readUnsignedByte(readBuffer, 3));

    short channelCode = readSimpleField("channelCode", readUnsignedShort(readBuffer, 13));

    readBuffer.closeContext("ChannelInformation");
    // Create the instance
    ChannelInformation _channelInformation;
    _channelInformation = new ChannelInformation(numChannels, channelCode);
    return _channelInformation;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof ChannelInformation)) {
      return false;
    }
    ChannelInformation that = (ChannelInformation) o;
    return (getNumChannels() == that.getNumChannels())
        && (getChannelCode() == that.getChannelCode())
        && true;
  }

  @Override
  public int hashCode() {
    return Objects.hash(getNumChannels(), getChannelCode());
  }

  @Override
  public String toString() {
    WriteBufferBoxBased writeBufferBoxBased = new WriteBufferBoxBased(true, true);
    try {
      writeBufferBoxBased.writeSerializable(this);
    } catch (SerializationException e) {
      throw new RuntimeException(e);
    }
    return "\n" + writeBufferBoxBased.getBox().toString() + "\n";
  }
}
