/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.knxnetip.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum Status {
  NO_ERROR((short) 0x00),
  PROTOCOL_TYPE_NOT_SUPPORTED((short) 0x01),
  UNSUPPORTED_PROTOCOL_VERSION((short) 0x02),
  OUT_OF_ORDER_SEQUENCE_NUMBER((short) 0x04),
  INVALID_CONNECTION_ID((short) 0x21),
  CONNECTION_TYPE_NOT_SUPPORTED((short) 0x22),
  CONNECTION_OPTION_NOT_SUPPORTED((short) 0x23),
  NO_MORE_CONNECTIONS((short) 0x24),
  NO_MORE_UNIQUE_CONNECTIONS((short) 0x25),
  DATA_CONNECTION((short) 0x26),
  KNX_CONNECTION((short) 0x27),
  TUNNELLING_LAYER_NOT_SUPPORTED((short) 0x29);
  private static final Map<Short, Status> map;

  static {
    map = new HashMap<>();
    for (Status value : Status.values()) {
      map.put((short) value.getValue(), value);
    }
  }

  private final short value;

  Status(short value) {
    this.value = value;
  }

  public short getValue() {
    return value;
  }

  public static Status enumForValue(short value) {
    return map.get(value);
  }

  public static Boolean isDefined(short value) {
    return map.containsKey(value);
  }
}
