/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesObject {
  ModellingRule_Mandatory((int) 78L),
  ModellingRule_Optional((int) 80L),
  ModellingRule_ExposesItsArray((int) 83L),
  RootFolder((int) 84L),
  ObjectsFolder((int) 85L),
  TypesFolder((int) 86L),
  ViewsFolder((int) 87L),
  ObjectTypesFolder((int) 88L),
  VariableTypesFolder((int) 89L),
  DataTypesFolder((int) 90L),
  ReferenceTypesFolder((int) 91L),
  XmlSchema_TypeSystem((int) 92L),
  OPCBinarySchema_TypeSystem((int) 93L),
  DataTypeDefinition_Encoding_DefaultBinary((int) 121L),
  StructureDefinition_Encoding_DefaultBinary((int) 122L),
  EnumDefinition_Encoding_DefaultBinary((int) 123L),
  DataSetMetaDataType_Encoding_DefaultBinary((int) 124L),
  DataTypeDescription_Encoding_DefaultBinary((int) 125L),
  StructureDescription_Encoding_DefaultBinary((int) 126L),
  EnumDescription_Encoding_DefaultBinary((int) 127L),
  RolePermissionType_Encoding_DefaultBinary((int) 128L),
  Node_Encoding_DefaultXml((int) 259L),
  Node_Encoding_DefaultBinary((int) 260L),
  ObjectNode_Encoding_DefaultXml((int) 262L),
  ObjectNode_Encoding_DefaultBinary((int) 263L),
  ObjectTypeNode_Encoding_DefaultXml((int) 265L),
  ObjectTypeNode_Encoding_DefaultBinary((int) 266L),
  VariableNode_Encoding_DefaultXml((int) 268L),
  VariableNode_Encoding_DefaultBinary((int) 269L),
  VariableTypeNode_Encoding_DefaultXml((int) 271L),
  VariableTypeNode_Encoding_DefaultBinary((int) 272L),
  ReferenceTypeNode_Encoding_DefaultXml((int) 274L),
  ReferenceTypeNode_Encoding_DefaultBinary((int) 275L),
  MethodNode_Encoding_DefaultXml((int) 277L),
  MethodNode_Encoding_DefaultBinary((int) 278L),
  ViewNode_Encoding_DefaultXml((int) 280L),
  ViewNode_Encoding_DefaultBinary((int) 281L),
  DataTypeNode_Encoding_DefaultXml((int) 283L),
  DataTypeNode_Encoding_DefaultBinary((int) 284L),
  ReferenceNode_Encoding_DefaultXml((int) 286L),
  ReferenceNode_Encoding_DefaultBinary((int) 287L),
  Argument_Encoding_DefaultXml((int) 297L),
  Argument_Encoding_DefaultBinary((int) 298L),
  StatusResult_Encoding_DefaultXml((int) 300L),
  StatusResult_Encoding_DefaultBinary((int) 301L),
  UserTokenPolicy_Encoding_DefaultXml((int) 305L),
  UserTokenPolicy_Encoding_DefaultBinary((int) 306L),
  ApplicationDescription_Encoding_DefaultXml((int) 309L),
  ApplicationDescription_Encoding_DefaultBinary((int) 310L),
  EndpointDescription_Encoding_DefaultXml((int) 313L),
  EndpointDescription_Encoding_DefaultBinary((int) 314L),
  UserIdentityToken_Encoding_DefaultXml((int) 317L),
  UserIdentityToken_Encoding_DefaultBinary((int) 318L),
  AnonymousIdentityToken_Encoding_DefaultXml((int) 320L),
  AnonymousIdentityToken_Encoding_DefaultBinary((int) 321L),
  UserNameIdentityToken_Encoding_DefaultXml((int) 323L),
  UserNameIdentityToken_Encoding_DefaultBinary((int) 324L),
  X509IdentityToken_Encoding_DefaultXml((int) 326L),
  X509IdentityToken_Encoding_DefaultBinary((int) 327L),
  EndpointConfiguration_Encoding_DefaultXml((int) 332L),
  EndpointConfiguration_Encoding_DefaultBinary((int) 333L),
  BuildInfo_Encoding_DefaultXml((int) 339L),
  BuildInfo_Encoding_DefaultBinary((int) 340L),
  SignedSoftwareCertificate_Encoding_DefaultXml((int) 345L),
  SignedSoftwareCertificate_Encoding_DefaultBinary((int) 346L),
  NodeAttributes_Encoding_DefaultXml((int) 350L),
  NodeAttributes_Encoding_DefaultBinary((int) 351L),
  ObjectAttributes_Encoding_DefaultXml((int) 353L),
  ObjectAttributes_Encoding_DefaultBinary((int) 354L),
  VariableAttributes_Encoding_DefaultXml((int) 356L),
  VariableAttributes_Encoding_DefaultBinary((int) 357L),
  MethodAttributes_Encoding_DefaultXml((int) 359L),
  MethodAttributes_Encoding_DefaultBinary((int) 360L),
  ObjectTypeAttributes_Encoding_DefaultXml((int) 362L),
  ObjectTypeAttributes_Encoding_DefaultBinary((int) 363L),
  VariableTypeAttributes_Encoding_DefaultXml((int) 365L),
  VariableTypeAttributes_Encoding_DefaultBinary((int) 366L),
  ReferenceTypeAttributes_Encoding_DefaultXml((int) 368L),
  ReferenceTypeAttributes_Encoding_DefaultBinary((int) 369L),
  DataTypeAttributes_Encoding_DefaultXml((int) 371L),
  DataTypeAttributes_Encoding_DefaultBinary((int) 372L),
  ViewAttributes_Encoding_DefaultXml((int) 374L),
  ViewAttributes_Encoding_DefaultBinary((int) 375L),
  AddNodesItem_Encoding_DefaultXml((int) 377L),
  AddNodesItem_Encoding_DefaultBinary((int) 378L),
  AddReferencesItem_Encoding_DefaultXml((int) 380L),
  AddReferencesItem_Encoding_DefaultBinary((int) 381L),
  DeleteNodesItem_Encoding_DefaultXml((int) 383L),
  DeleteNodesItem_Encoding_DefaultBinary((int) 384L),
  DeleteReferencesItem_Encoding_DefaultXml((int) 386L),
  DeleteReferencesItem_Encoding_DefaultBinary((int) 387L),
  RequestHeader_Encoding_DefaultXml((int) 390L),
  RequestHeader_Encoding_DefaultBinary((int) 391L),
  ResponseHeader_Encoding_DefaultXml((int) 393L),
  ResponseHeader_Encoding_DefaultBinary((int) 394L),
  ServiceFault_Encoding_DefaultXml((int) 396L),
  ServiceFault_Encoding_DefaultBinary((int) 397L),
  FindServersRequest_Encoding_DefaultXml((int) 421L),
  FindServersRequest_Encoding_DefaultBinary((int) 422L),
  FindServersResponse_Encoding_DefaultXml((int) 424L),
  FindServersResponse_Encoding_DefaultBinary((int) 425L),
  GetEndpointsRequest_Encoding_DefaultXml((int) 427L),
  GetEndpointsRequest_Encoding_DefaultBinary((int) 428L),
  GetEndpointsResponse_Encoding_DefaultXml((int) 430L),
  GetEndpointsResponse_Encoding_DefaultBinary((int) 431L),
  RegisteredServer_Encoding_DefaultXml((int) 433L),
  RegisteredServer_Encoding_DefaultBinary((int) 434L),
  RegisterServerRequest_Encoding_DefaultXml((int) 436L),
  RegisterServerRequest_Encoding_DefaultBinary((int) 437L),
  RegisterServerResponse_Encoding_DefaultXml((int) 439L),
  RegisterServerResponse_Encoding_DefaultBinary((int) 440L),
  ChannelSecurityToken_Encoding_DefaultXml((int) 442L),
  ChannelSecurityToken_Encoding_DefaultBinary((int) 443L),
  OpenSecureChannelRequest_Encoding_DefaultXml((int) 445L),
  OpenSecureChannelRequest_Encoding_DefaultBinary((int) 446L),
  OpenSecureChannelResponse_Encoding_DefaultXml((int) 448L),
  OpenSecureChannelResponse_Encoding_DefaultBinary((int) 449L),
  CloseSecureChannelRequest_Encoding_DefaultXml((int) 451L),
  CloseSecureChannelRequest_Encoding_DefaultBinary((int) 452L),
  CloseSecureChannelResponse_Encoding_DefaultXml((int) 454L),
  CloseSecureChannelResponse_Encoding_DefaultBinary((int) 455L),
  SignatureData_Encoding_DefaultXml((int) 457L),
  SignatureData_Encoding_DefaultBinary((int) 458L),
  CreateSessionRequest_Encoding_DefaultXml((int) 460L),
  CreateSessionRequest_Encoding_DefaultBinary((int) 461L),
  CreateSessionResponse_Encoding_DefaultXml((int) 463L),
  CreateSessionResponse_Encoding_DefaultBinary((int) 464L),
  ActivateSessionRequest_Encoding_DefaultXml((int) 466L),
  ActivateSessionRequest_Encoding_DefaultBinary((int) 467L),
  ActivateSessionResponse_Encoding_DefaultXml((int) 469L),
  ActivateSessionResponse_Encoding_DefaultBinary((int) 470L),
  CloseSessionRequest_Encoding_DefaultXml((int) 472L),
  CloseSessionRequest_Encoding_DefaultBinary((int) 473L),
  CloseSessionResponse_Encoding_DefaultXml((int) 475L),
  CloseSessionResponse_Encoding_DefaultBinary((int) 476L),
  CancelRequest_Encoding_DefaultXml((int) 478L),
  CancelRequest_Encoding_DefaultBinary((int) 479L),
  CancelResponse_Encoding_DefaultXml((int) 481L),
  CancelResponse_Encoding_DefaultBinary((int) 482L),
  AddNodesResult_Encoding_DefaultXml((int) 484L),
  AddNodesResult_Encoding_DefaultBinary((int) 485L),
  AddNodesRequest_Encoding_DefaultXml((int) 487L),
  AddNodesRequest_Encoding_DefaultBinary((int) 488L),
  AddNodesResponse_Encoding_DefaultXml((int) 490L),
  AddNodesResponse_Encoding_DefaultBinary((int) 491L),
  AddReferencesRequest_Encoding_DefaultXml((int) 493L),
  AddReferencesRequest_Encoding_DefaultBinary((int) 494L),
  AddReferencesResponse_Encoding_DefaultXml((int) 496L),
  AddReferencesResponse_Encoding_DefaultBinary((int) 497L),
  DeleteNodesRequest_Encoding_DefaultXml((int) 499L),
  DeleteNodesRequest_Encoding_DefaultBinary((int) 500L),
  DeleteNodesResponse_Encoding_DefaultXml((int) 502L),
  DeleteNodesResponse_Encoding_DefaultBinary((int) 503L),
  DeleteReferencesRequest_Encoding_DefaultXml((int) 505L),
  DeleteReferencesRequest_Encoding_DefaultBinary((int) 506L),
  DeleteReferencesResponse_Encoding_DefaultXml((int) 508L),
  DeleteReferencesResponse_Encoding_DefaultBinary((int) 509L),
  ViewDescription_Encoding_DefaultXml((int) 512L),
  ViewDescription_Encoding_DefaultBinary((int) 513L),
  BrowseDescription_Encoding_DefaultXml((int) 515L),
  BrowseDescription_Encoding_DefaultBinary((int) 516L),
  ReferenceDescription_Encoding_DefaultXml((int) 519L),
  ReferenceDescription_Encoding_DefaultBinary((int) 520L),
  BrowseResult_Encoding_DefaultXml((int) 523L),
  BrowseResult_Encoding_DefaultBinary((int) 524L),
  BrowseRequest_Encoding_DefaultXml((int) 526L),
  BrowseRequest_Encoding_DefaultBinary((int) 527L),
  BrowseResponse_Encoding_DefaultXml((int) 529L),
  BrowseResponse_Encoding_DefaultBinary((int) 530L),
  BrowseNextRequest_Encoding_DefaultXml((int) 532L),
  BrowseNextRequest_Encoding_DefaultBinary((int) 533L),
  BrowseNextResponse_Encoding_DefaultXml((int) 535L),
  BrowseNextResponse_Encoding_DefaultBinary((int) 536L),
  RelativePathElement_Encoding_DefaultXml((int) 538L),
  RelativePathElement_Encoding_DefaultBinary((int) 539L),
  RelativePath_Encoding_DefaultXml((int) 541L),
  RelativePath_Encoding_DefaultBinary((int) 542L),
  BrowsePath_Encoding_DefaultXml((int) 544L),
  BrowsePath_Encoding_DefaultBinary((int) 545L),
  BrowsePathTarget_Encoding_DefaultXml((int) 547L),
  BrowsePathTarget_Encoding_DefaultBinary((int) 548L),
  BrowsePathResult_Encoding_DefaultXml((int) 550L),
  BrowsePathResult_Encoding_DefaultBinary((int) 551L),
  TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultXml((int) 553L),
  TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultBinary((int) 554L),
  TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultXml((int) 556L),
  TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultBinary((int) 557L),
  RegisterNodesRequest_Encoding_DefaultXml((int) 559L),
  RegisterNodesRequest_Encoding_DefaultBinary((int) 560L),
  RegisterNodesResponse_Encoding_DefaultXml((int) 562L),
  RegisterNodesResponse_Encoding_DefaultBinary((int) 563L),
  UnregisterNodesRequest_Encoding_DefaultXml((int) 565L),
  UnregisterNodesRequest_Encoding_DefaultBinary((int) 566L),
  UnregisterNodesResponse_Encoding_DefaultXml((int) 568L),
  UnregisterNodesResponse_Encoding_DefaultBinary((int) 569L),
  QueryDataDescription_Encoding_DefaultXml((int) 571L),
  QueryDataDescription_Encoding_DefaultBinary((int) 572L),
  NodeTypeDescription_Encoding_DefaultXml((int) 574L),
  NodeTypeDescription_Encoding_DefaultBinary((int) 575L),
  QueryDataSet_Encoding_DefaultXml((int) 578L),
  QueryDataSet_Encoding_DefaultBinary((int) 579L),
  NodeReference_Encoding_DefaultXml((int) 581L),
  NodeReference_Encoding_DefaultBinary((int) 582L),
  ContentFilterElement_Encoding_DefaultXml((int) 584L),
  ContentFilterElement_Encoding_DefaultBinary((int) 585L),
  ContentFilter_Encoding_DefaultXml((int) 587L),
  ContentFilter_Encoding_DefaultBinary((int) 588L),
  FilterOperand_Encoding_DefaultXml((int) 590L),
  FilterOperand_Encoding_DefaultBinary((int) 591L),
  ElementOperand_Encoding_DefaultXml((int) 593L),
  ElementOperand_Encoding_DefaultBinary((int) 594L),
  LiteralOperand_Encoding_DefaultXml((int) 596L),
  LiteralOperand_Encoding_DefaultBinary((int) 597L),
  AttributeOperand_Encoding_DefaultXml((int) 599L),
  AttributeOperand_Encoding_DefaultBinary((int) 600L),
  SimpleAttributeOperand_Encoding_DefaultXml((int) 602L),
  SimpleAttributeOperand_Encoding_DefaultBinary((int) 603L),
  ContentFilterElementResult_Encoding_DefaultXml((int) 605L),
  ContentFilterElementResult_Encoding_DefaultBinary((int) 606L),
  ContentFilterResult_Encoding_DefaultXml((int) 608L),
  ContentFilterResult_Encoding_DefaultBinary((int) 609L),
  ParsingResult_Encoding_DefaultXml((int) 611L),
  ParsingResult_Encoding_DefaultBinary((int) 612L),
  QueryFirstRequest_Encoding_DefaultXml((int) 614L),
  QueryFirstRequest_Encoding_DefaultBinary((int) 615L),
  QueryFirstResponse_Encoding_DefaultXml((int) 617L),
  QueryFirstResponse_Encoding_DefaultBinary((int) 618L),
  QueryNextRequest_Encoding_DefaultXml((int) 620L),
  QueryNextRequest_Encoding_DefaultBinary((int) 621L),
  QueryNextResponse_Encoding_DefaultXml((int) 623L),
  QueryNextResponse_Encoding_DefaultBinary((int) 624L),
  ReadValueId_Encoding_DefaultXml((int) 627L),
  ReadValueId_Encoding_DefaultBinary((int) 628L),
  ReadRequest_Encoding_DefaultXml((int) 630L),
  ReadRequest_Encoding_DefaultBinary((int) 631L),
  ReadResponse_Encoding_DefaultXml((int) 633L),
  ReadResponse_Encoding_DefaultBinary((int) 634L),
  HistoryReadValueId_Encoding_DefaultXml((int) 636L),
  HistoryReadValueId_Encoding_DefaultBinary((int) 637L),
  HistoryReadResult_Encoding_DefaultXml((int) 639L),
  HistoryReadResult_Encoding_DefaultBinary((int) 640L),
  HistoryReadDetails_Encoding_DefaultXml((int) 642L),
  HistoryReadDetails_Encoding_DefaultBinary((int) 643L),
  ReadEventDetails_Encoding_DefaultXml((int) 645L),
  ReadEventDetails_Encoding_DefaultBinary((int) 646L),
  ReadRawModifiedDetails_Encoding_DefaultXml((int) 648L),
  ReadRawModifiedDetails_Encoding_DefaultBinary((int) 649L),
  ReadProcessedDetails_Encoding_DefaultXml((int) 651L),
  ReadProcessedDetails_Encoding_DefaultBinary((int) 652L),
  ReadAtTimeDetails_Encoding_DefaultXml((int) 654L),
  ReadAtTimeDetails_Encoding_DefaultBinary((int) 655L),
  HistoryData_Encoding_DefaultXml((int) 657L),
  HistoryData_Encoding_DefaultBinary((int) 658L),
  HistoryEvent_Encoding_DefaultXml((int) 660L),
  HistoryEvent_Encoding_DefaultBinary((int) 661L),
  HistoryReadRequest_Encoding_DefaultXml((int) 663L),
  HistoryReadRequest_Encoding_DefaultBinary((int) 664L),
  HistoryReadResponse_Encoding_DefaultXml((int) 666L),
  HistoryReadResponse_Encoding_DefaultBinary((int) 667L),
  WriteValue_Encoding_DefaultXml((int) 669L),
  WriteValue_Encoding_DefaultBinary((int) 670L),
  WriteRequest_Encoding_DefaultXml((int) 672L),
  WriteRequest_Encoding_DefaultBinary((int) 673L),
  WriteResponse_Encoding_DefaultXml((int) 675L),
  WriteResponse_Encoding_DefaultBinary((int) 676L),
  HistoryUpdateDetails_Encoding_DefaultXml((int) 678L),
  HistoryUpdateDetails_Encoding_DefaultBinary((int) 679L),
  UpdateDataDetails_Encoding_DefaultXml((int) 681L),
  UpdateDataDetails_Encoding_DefaultBinary((int) 682L),
  UpdateEventDetails_Encoding_DefaultXml((int) 684L),
  UpdateEventDetails_Encoding_DefaultBinary((int) 685L),
  DeleteRawModifiedDetails_Encoding_DefaultXml((int) 687L),
  DeleteRawModifiedDetails_Encoding_DefaultBinary((int) 688L),
  DeleteAtTimeDetails_Encoding_DefaultXml((int) 690L),
  DeleteAtTimeDetails_Encoding_DefaultBinary((int) 691L),
  DeleteEventDetails_Encoding_DefaultXml((int) 693L),
  DeleteEventDetails_Encoding_DefaultBinary((int) 694L),
  HistoryUpdateResult_Encoding_DefaultXml((int) 696L),
  HistoryUpdateResult_Encoding_DefaultBinary((int) 697L),
  HistoryUpdateRequest_Encoding_DefaultXml((int) 699L),
  HistoryUpdateRequest_Encoding_DefaultBinary((int) 700L),
  HistoryUpdateResponse_Encoding_DefaultXml((int) 702L),
  HistoryUpdateResponse_Encoding_DefaultBinary((int) 703L),
  CallMethodRequest_Encoding_DefaultXml((int) 705L),
  CallMethodRequest_Encoding_DefaultBinary((int) 706L),
  CallMethodResult_Encoding_DefaultXml((int) 708L),
  CallMethodResult_Encoding_DefaultBinary((int) 709L),
  CallRequest_Encoding_DefaultXml((int) 711L),
  CallRequest_Encoding_DefaultBinary((int) 712L),
  CallResponse_Encoding_DefaultXml((int) 714L),
  CallResponse_Encoding_DefaultBinary((int) 715L),
  MonitoringFilter_Encoding_DefaultXml((int) 720L),
  MonitoringFilter_Encoding_DefaultBinary((int) 721L),
  DataChangeFilter_Encoding_DefaultXml((int) 723L),
  DataChangeFilter_Encoding_DefaultBinary((int) 724L),
  EventFilter_Encoding_DefaultXml((int) 726L),
  EventFilter_Encoding_DefaultBinary((int) 727L),
  AggregateFilter_Encoding_DefaultXml((int) 729L),
  AggregateFilter_Encoding_DefaultBinary((int) 730L),
  MonitoringFilterResult_Encoding_DefaultXml((int) 732L),
  MonitoringFilterResult_Encoding_DefaultBinary((int) 733L),
  EventFilterResult_Encoding_DefaultXml((int) 735L),
  EventFilterResult_Encoding_DefaultBinary((int) 736L),
  AggregateFilterResult_Encoding_DefaultXml((int) 738L),
  AggregateFilterResult_Encoding_DefaultBinary((int) 739L),
  MonitoringParameters_Encoding_DefaultXml((int) 741L),
  MonitoringParameters_Encoding_DefaultBinary((int) 742L),
  MonitoredItemCreateRequest_Encoding_DefaultXml((int) 744L),
  MonitoredItemCreateRequest_Encoding_DefaultBinary((int) 745L),
  MonitoredItemCreateResult_Encoding_DefaultXml((int) 747L),
  MonitoredItemCreateResult_Encoding_DefaultBinary((int) 748L),
  CreateMonitoredItemsRequest_Encoding_DefaultXml((int) 750L),
  CreateMonitoredItemsRequest_Encoding_DefaultBinary((int) 751L),
  CreateMonitoredItemsResponse_Encoding_DefaultXml((int) 753L),
  CreateMonitoredItemsResponse_Encoding_DefaultBinary((int) 754L),
  MonitoredItemModifyRequest_Encoding_DefaultXml((int) 756L),
  MonitoredItemModifyRequest_Encoding_DefaultBinary((int) 757L),
  MonitoredItemModifyResult_Encoding_DefaultXml((int) 759L),
  MonitoredItemModifyResult_Encoding_DefaultBinary((int) 760L),
  ModifyMonitoredItemsRequest_Encoding_DefaultXml((int) 762L),
  ModifyMonitoredItemsRequest_Encoding_DefaultBinary((int) 763L),
  ModifyMonitoredItemsResponse_Encoding_DefaultXml((int) 765L),
  ModifyMonitoredItemsResponse_Encoding_DefaultBinary((int) 766L),
  SetMonitoringModeRequest_Encoding_DefaultXml((int) 768L),
  SetMonitoringModeRequest_Encoding_DefaultBinary((int) 769L),
  SetMonitoringModeResponse_Encoding_DefaultXml((int) 771L),
  SetMonitoringModeResponse_Encoding_DefaultBinary((int) 772L),
  SetTriggeringRequest_Encoding_DefaultXml((int) 774L),
  SetTriggeringRequest_Encoding_DefaultBinary((int) 775L),
  SetTriggeringResponse_Encoding_DefaultXml((int) 777L),
  SetTriggeringResponse_Encoding_DefaultBinary((int) 778L),
  DeleteMonitoredItemsRequest_Encoding_DefaultXml((int) 780L),
  DeleteMonitoredItemsRequest_Encoding_DefaultBinary((int) 781L),
  DeleteMonitoredItemsResponse_Encoding_DefaultXml((int) 783L),
  DeleteMonitoredItemsResponse_Encoding_DefaultBinary((int) 784L),
  CreateSubscriptionRequest_Encoding_DefaultXml((int) 786L),
  CreateSubscriptionRequest_Encoding_DefaultBinary((int) 787L),
  CreateSubscriptionResponse_Encoding_DefaultXml((int) 789L),
  CreateSubscriptionResponse_Encoding_DefaultBinary((int) 790L),
  ModifySubscriptionRequest_Encoding_DefaultXml((int) 792L),
  ModifySubscriptionRequest_Encoding_DefaultBinary((int) 793L),
  ModifySubscriptionResponse_Encoding_DefaultXml((int) 795L),
  ModifySubscriptionResponse_Encoding_DefaultBinary((int) 796L),
  SetPublishingModeRequest_Encoding_DefaultXml((int) 798L),
  SetPublishingModeRequest_Encoding_DefaultBinary((int) 799L),
  SetPublishingModeResponse_Encoding_DefaultXml((int) 801L),
  SetPublishingModeResponse_Encoding_DefaultBinary((int) 802L),
  NotificationMessage_Encoding_DefaultXml((int) 804L),
  NotificationMessage_Encoding_DefaultBinary((int) 805L),
  MonitoredItemNotification_Encoding_DefaultXml((int) 807L),
  MonitoredItemNotification_Encoding_DefaultBinary((int) 808L),
  DataChangeNotification_Encoding_DefaultXml((int) 810L),
  DataChangeNotification_Encoding_DefaultBinary((int) 811L),
  StatusChangeNotification_Encoding_DefaultXml((int) 819L),
  StatusChangeNotification_Encoding_DefaultBinary((int) 820L),
  SubscriptionAcknowledgement_Encoding_DefaultXml((int) 822L),
  SubscriptionAcknowledgement_Encoding_DefaultBinary((int) 823L),
  PublishRequest_Encoding_DefaultXml((int) 825L),
  PublishRequest_Encoding_DefaultBinary((int) 826L),
  PublishResponse_Encoding_DefaultXml((int) 828L),
  PublishResponse_Encoding_DefaultBinary((int) 829L),
  RepublishRequest_Encoding_DefaultXml((int) 831L),
  RepublishRequest_Encoding_DefaultBinary((int) 832L),
  RepublishResponse_Encoding_DefaultXml((int) 834L),
  RepublishResponse_Encoding_DefaultBinary((int) 835L),
  TransferResult_Encoding_DefaultXml((int) 837L),
  TransferResult_Encoding_DefaultBinary((int) 838L),
  TransferSubscriptionsRequest_Encoding_DefaultXml((int) 840L),
  TransferSubscriptionsRequest_Encoding_DefaultBinary((int) 841L),
  TransferSubscriptionsResponse_Encoding_DefaultXml((int) 843L),
  TransferSubscriptionsResponse_Encoding_DefaultBinary((int) 844L),
  DeleteSubscriptionsRequest_Encoding_DefaultXml((int) 846L),
  DeleteSubscriptionsRequest_Encoding_DefaultBinary((int) 847L),
  DeleteSubscriptionsResponse_Encoding_DefaultXml((int) 849L),
  DeleteSubscriptionsResponse_Encoding_DefaultBinary((int) 850L),
  RedundantServerDataType_Encoding_DefaultXml((int) 854L),
  RedundantServerDataType_Encoding_DefaultBinary((int) 855L),
  SamplingIntervalDiagnosticsDataType_Encoding_DefaultXml((int) 857L),
  SamplingIntervalDiagnosticsDataType_Encoding_DefaultBinary((int) 858L),
  ServerDiagnosticsSummaryDataType_Encoding_DefaultXml((int) 860L),
  ServerDiagnosticsSummaryDataType_Encoding_DefaultBinary((int) 861L),
  ServerStatusDataType_Encoding_DefaultXml((int) 863L),
  ServerStatusDataType_Encoding_DefaultBinary((int) 864L),
  SessionDiagnosticsDataType_Encoding_DefaultXml((int) 866L),
  SessionDiagnosticsDataType_Encoding_DefaultBinary((int) 867L),
  SessionSecurityDiagnosticsDataType_Encoding_DefaultXml((int) 869L),
  SessionSecurityDiagnosticsDataType_Encoding_DefaultBinary((int) 870L),
  ServiceCounterDataType_Encoding_DefaultXml((int) 872L),
  ServiceCounterDataType_Encoding_DefaultBinary((int) 873L),
  SubscriptionDiagnosticsDataType_Encoding_DefaultXml((int) 875L),
  SubscriptionDiagnosticsDataType_Encoding_DefaultBinary((int) 876L),
  ModelChangeStructureDataType_Encoding_DefaultXml((int) 878L),
  ModelChangeStructureDataType_Encoding_DefaultBinary((int) 879L),
  Range_Encoding_DefaultXml((int) 885L),
  Range_Encoding_DefaultBinary((int) 886L),
  EUInformation_Encoding_DefaultXml((int) 888L),
  EUInformation_Encoding_DefaultBinary((int) 889L),
  Annotation_Encoding_DefaultXml((int) 892L),
  Annotation_Encoding_DefaultBinary((int) 893L),
  ProgramDiagnosticDataType_Encoding_DefaultXml((int) 895L),
  ProgramDiagnosticDataType_Encoding_DefaultBinary((int) 896L),
  SemanticChangeStructureDataType_Encoding_DefaultXml((int) 898L),
  SemanticChangeStructureDataType_Encoding_DefaultBinary((int) 899L),
  EventNotificationList_Encoding_DefaultXml((int) 915L),
  EventNotificationList_Encoding_DefaultBinary((int) 916L),
  EventFieldList_Encoding_DefaultXml((int) 918L),
  EventFieldList_Encoding_DefaultBinary((int) 919L),
  HistoryEventFieldList_Encoding_DefaultXml((int) 921L),
  HistoryEventFieldList_Encoding_DefaultBinary((int) 922L),
  IssuedIdentityToken_Encoding_DefaultXml((int) 939L),
  IssuedIdentityToken_Encoding_DefaultBinary((int) 940L),
  NotificationData_Encoding_DefaultXml((int) 946L),
  NotificationData_Encoding_DefaultBinary((int) 947L),
  AggregateConfiguration_Encoding_DefaultXml((int) 949L),
  AggregateConfiguration_Encoding_DefaultBinary((int) 950L),
  ServerType_ServerCapabilities((int) 2009L),
  ServerType_ServerDiagnostics((int) 2010L),
  ServerType_VendorServerInfo((int) 2011L),
  ServerType_ServerRedundancy((int) 2012L),
  ServerCapabilitiesType_ModellingRules((int) 2019L),
  Server((int) 2253L),
  Server_ServerCapabilities((int) 2268L),
  Server_ServerDiagnostics((int) 2274L),
  Server_VendorServerInfo((int) 2295L),
  Server_ServerRedundancy((int) 2296L),
  AggregateFunction_Interpolative((int) 2341L),
  AggregateFunction_Average((int) 2342L),
  AggregateFunction_TimeAverage((int) 2343L),
  AggregateFunction_Total((int) 2344L),
  AggregateFunction_Minimum((int) 2346L),
  AggregateFunction_Maximum((int) 2347L),
  AggregateFunction_MinimumActualTime((int) 2348L),
  AggregateFunction_MaximumActualTime((int) 2349L),
  AggregateFunction_Range((int) 2350L),
  AggregateFunction_AnnotationCount((int) 2351L),
  AggregateFunction_Count((int) 2352L),
  AggregateFunction_NumberOfTransitions((int) 2355L),
  AggregateFunction_Start((int) 2357L),
  AggregateFunction_End((int) 2358L),
  AggregateFunction_Delta((int) 2359L),
  AggregateFunction_DurationGood((int) 2360L),
  AggregateFunction_DurationBad((int) 2361L),
  AggregateFunction_PercentGood((int) 2362L),
  AggregateFunction_PercentBad((int) 2363L),
  AggregateFunction_WorstQuality((int) 2364L),
  ProgramStateMachineType_Ready((int) 2400L),
  ProgramStateMachineType_Running((int) 2402L),
  ProgramStateMachineType_Suspended((int) 2404L),
  ProgramStateMachineType_Halted((int) 2406L),
  ProgramStateMachineType_HaltedToReady((int) 2408L),
  ProgramStateMachineType_ReadyToRunning((int) 2410L),
  ProgramStateMachineType_RunningToHalted((int) 2412L),
  ProgramStateMachineType_RunningToReady((int) 2414L),
  ProgramStateMachineType_RunningToSuspended((int) 2416L),
  ProgramStateMachineType_SuspendedToRunning((int) 2418L),
  ProgramStateMachineType_SuspendedToHalted((int) 2420L),
  ProgramStateMachineType_SuspendedToReady((int) 2422L),
  ProgramStateMachineType_ReadyToHalted((int) 2424L),
  ServerDiagnosticsType_SessionsDiagnosticsSummary((int) 2744L),
  ServerCapabilitiesType_AggregateFunctions((int) 2754L),
  ShelvedStateMachineType_Unshelved((int) 2930L),
  ShelvedStateMachineType_TimedShelved((int) 2932L),
  ShelvedStateMachineType_OneShotShelved((int) 2933L),
  ShelvedStateMachineType_UnshelvedToTimedShelved((int) 2935L),
  ShelvedStateMachineType_UnshelvedToOneShotShelved((int) 2936L),
  ShelvedStateMachineType_TimedShelvedToUnshelved((int) 2940L),
  ShelvedStateMachineType_TimedShelvedToOneShotShelved((int) 2942L),
  ShelvedStateMachineType_OneShotShelvedToUnshelved((int) 2943L),
  ShelvedStateMachineType_OneShotShelvedToTimedShelved((int) 2945L),
  Server_ServerCapabilities_ModellingRules((int) 2996L),
  Server_ServerCapabilities_AggregateFunctions((int) 2997L),
  EventTypesFolder((int) 3048L),
  HistoricalDataConfigurationType_AggregateConfiguration((int) 3059L),
  DefaultBinary((int) 3062L),
  DefaultXml((int) 3063L),
  ServerType_ServerCapabilities_ModellingRules((int) 3093L),
  ServerType_ServerCapabilities_AggregateFunctions((int) 3094L),
  ServerType_ServerDiagnostics_SessionsDiagnosticsSummary((int) 3111L),
  Server_ServerDiagnostics_SessionsDiagnosticsSummary((int) 3706L),
  ProgramStateMachineType_FinalResultData((int) 3850L),
  EnumValueType_Encoding_DefaultXml((int) 7616L),
  EnumValueType_Encoding_DefaultBinary((int) 8251L),
  TimeZoneDataType_Encoding_DefaultXml((int) 8913L),
  TimeZoneDataType_Encoding_DefaultBinary((int) 8917L),
  AlarmConditionType_ShelvingState((int) 9178L),
  ExclusiveLimitStateMachineType_HighHigh((int) 9329L),
  ExclusiveLimitStateMachineType_High((int) 9331L),
  ExclusiveLimitStateMachineType_Low((int) 9333L),
  ExclusiveLimitStateMachineType_LowLow((int) 9335L),
  ExclusiveLimitStateMachineType_LowLowToLow((int) 9337L),
  ExclusiveLimitStateMachineType_LowToLowLow((int) 9338L),
  ExclusiveLimitStateMachineType_HighHighToHigh((int) 9339L),
  ExclusiveLimitStateMachineType_HighToHighHigh((int) 9340L),
  ExclusiveLimitAlarmType_LimitState((int) 9455L),
  HistoryServerCapabilitiesType_AggregateFunctions((int) 11172L),
  HistoryServerCapabilities((int) 11192L),
  HistoryServerCapabilities_AggregateFunctions((int) 11201L),
  HAConfiguration((int) 11202L),
  HAConfiguration_AggregateConfiguration((int) 11203L),
  ModificationInfo_Encoding_DefaultXml((int) 11218L),
  HistoryModifiedData_Encoding_DefaultXml((int) 11219L),
  ModificationInfo_Encoding_DefaultBinary((int) 11226L),
  HistoryModifiedData_Encoding_DefaultBinary((int) 11227L),
  AggregateFunction_TimeAverage2((int) 11285L),
  AggregateFunction_Minimum2((int) 11286L),
  AggregateFunction_Maximum2((int) 11287L),
  AggregateFunction_Range2((int) 11288L),
  AggregateFunction_WorstQuality2((int) 11292L),
  UpdateStructureDataDetails_Encoding_DefaultXml((int) 11296L),
  UpdateStructureDataDetails_Encoding_DefaultBinary((int) 11300L),
  AggregateFunction_Total2((int) 11304L),
  AggregateFunction_MinimumActualTime2((int) 11305L),
  AggregateFunction_MaximumActualTime2((int) 11306L),
  AggregateFunction_DurationInStateZero((int) 11307L),
  AggregateFunction_DurationInStateNonZero((int) 11308L),
  AggregateFunction_StandardDeviationSample((int) 11426L),
  AggregateFunction_StandardDeviationPopulation((int) 11427L),
  AggregateFunction_VarianceSample((int) 11428L),
  AggregateFunction_VariancePopulation((int) 11429L),
  AggregateFunction_StartBound((int) 11505L),
  AggregateFunction_EndBound((int) 11506L),
  AggregateFunction_DeltaBounds((int) 11507L),
  ModellingRule_OptionalPlaceholder((int) 11508L),
  ModellingRule_MandatoryPlaceholder((int) 11510L),
  ServerType_ServerCapabilities_OperationLimits((int) 11516L),
  ServerType_Namespaces((int) 11527L),
  ServerCapabilitiesType_OperationLimits((int) 11551L),
  NamespaceMetadataType_NamespaceFile((int) 11624L),
  NamespacesType_NamespaceIdentifier_Placeholder((int) 11646L),
  NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile((int) 11654L),
  Server_ServerCapabilities_OperationLimits((int) 11704L),
  Server_Namespaces((int) 11715L),
  HistoricalDataConfigurationType_AggregateFunctions((int) 11876L),
  HAConfiguration_AggregateFunctions((int) 11877L),
  InstanceNode_Encoding_DefaultXml((int) 11887L),
  TypeNode_Encoding_DefaultXml((int) 11888L),
  InstanceNode_Encoding_DefaultBinary((int) 11889L),
  TypeNode_Encoding_DefaultBinary((int) 11890L),
  EndpointUrlListDataType_Encoding_DefaultXml((int) 11949L),
  NetworkGroupDataType_Encoding_DefaultXml((int) 11950L),
  EndpointUrlListDataType_Encoding_DefaultBinary((int) 11957L),
  NetworkGroupDataType_Encoding_DefaultBinary((int) 11958L),
  AxisInformation_Encoding_DefaultXml((int) 12081L),
  XVType_Encoding_DefaultXml((int) 12082L),
  AxisInformation_Encoding_DefaultBinary((int) 12089L),
  XVType_Encoding_DefaultBinary((int) 12090L),
  SessionsDiagnosticsSummaryType_ClientName_Placeholder((int) 12097L),
  ComplexNumberType_Encoding_DefaultXml((int) 12173L),
  DoubleComplexNumberType_Encoding_DefaultXml((int) 12174L),
  ComplexNumberType_Encoding_DefaultBinary((int) 12181L),
  DoubleComplexNumberType_Encoding_DefaultBinary((int) 12182L),
  ServerOnNetwork_Encoding_DefaultXml((int) 12195L),
  FindServersOnNetworkRequest_Encoding_DefaultXml((int) 12196L),
  FindServersOnNetworkResponse_Encoding_DefaultXml((int) 12197L),
  RegisterServer2Request_Encoding_DefaultXml((int) 12199L),
  RegisterServer2Response_Encoding_DefaultXml((int) 12200L),
  ServerOnNetwork_Encoding_DefaultBinary((int) 12207L),
  FindServersOnNetworkRequest_Encoding_DefaultBinary((int) 12208L),
  FindServersOnNetworkResponse_Encoding_DefaultBinary((int) 12209L),
  RegisterServer2Request_Encoding_DefaultBinary((int) 12211L),
  RegisterServer2Response_Encoding_DefaultBinary((int) 12212L),
  ServerConfiguration((int) 12637L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList((int) 12642L),
  TrustListDataType_Encoding_DefaultXml((int) 12676L),
  TrustListDataType_Encoding_DefaultBinary((int) 12680L),
  OptionSet_Encoding_DefaultXml((int) 12757L),
  Union_Encoding_DefaultXml((int) 12758L),
  OptionSet_Encoding_DefaultBinary((int) 12765L),
  Union_Encoding_DefaultBinary((int) 12766L),
  DiscoveryConfiguration_Encoding_DefaultXml((int) 12892L),
  MdnsDiscoveryConfiguration_Encoding_DefaultXml((int) 12893L),
  DiscoveryConfiguration_Encoding_DefaultBinary((int) 12900L),
  MdnsDiscoveryConfiguration_Encoding_DefaultBinary((int) 12901L),
  FileDirectoryType_FileDirectoryName_Placeholder((int) 13354L),
  FileDirectoryType_FileName_Placeholder((int) 13366L),
  CertificateGroupType_TrustList((int) 13599L),
  CertificateGroupFolderType_DefaultApplicationGroup((int) 13814L),
  CertificateGroupFolderType_DefaultApplicationGroup_TrustList((int) 13815L),
  CertificateGroupFolderType_DefaultHttpsGroup((int) 13848L),
  CertificateGroupFolderType_DefaultHttpsGroup_TrustList((int) 13849L),
  CertificateGroupFolderType_DefaultUserTokenGroup((int) 13882L),
  CertificateGroupFolderType_DefaultUserTokenGroup_TrustList((int) 13883L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder((int) 13916L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList((int) 13917L),
  ServerConfigurationType_CertificateGroups((int) 13950L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup((int) 13951L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList((int) 13952L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup((int) 13985L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList((int) 13986L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup((int) 14019L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList((int) 14020L),
  ServerConfiguration_CertificateGroups((int) 14053L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup((int) 14088L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList((int) 14089L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup((int) 14122L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList((int) 14123L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup((int) 14156L),
  PubSubConnectionType_Address((int) 14221L),
  PublishedVariableDataType_Encoding_DefaultXml((int) 14319L),
  PublishedVariableDataType_Encoding_DefaultBinary((int) 14323L),
  PublishSubscribeType_ConnectionName_Placeholder((int) 14417L),
  PublishSubscribeType_ConnectionName_Placeholder_Status((int) 14419L),
  PublishSubscribeType_ConnectionName_Placeholder_Address((int) 14423L),
  PublishSubscribeType_PublishedDataSets((int) 14434L),
  PublishSubscribe((int) 14443L),
  DataSetFolderType_DataSetFolderName_Placeholder((int) 14478L),
  DataSetFolderType_PublishedDataSetName_Placeholder((int) 14487L),
  PubSubConnectionType_Status((int) 14600L),
  DataSetMetaDataType_Encoding_DefaultXml((int) 14794L),
  FieldMetaData_Encoding_DefaultXml((int) 14795L),
  DataTypeDescription_Encoding_DefaultXml((int) 14796L),
  DataTypeDefinition_Encoding_DefaultXml((int) 14797L),
  StructureDefinition_Encoding_DefaultXml((int) 14798L),
  EnumDefinition_Encoding_DefaultXml((int) 14799L),
  StructureField_Encoding_DefaultXml((int) 14800L),
  EnumField_Encoding_DefaultXml((int) 14801L),
  KeyValuePair_Encoding_DefaultXml((int) 14802L),
  ConfigurationVersionDataType_Encoding_DefaultXml((int) 14803L),
  FieldTargetDataType_Encoding_DefaultXml((int) 14804L),
  FieldMetaData_Encoding_DefaultBinary((int) 14839L),
  StructureField_Encoding_DefaultBinary((int) 14844L),
  EnumField_Encoding_DefaultBinary((int) 14845L),
  KeyValuePair_Encoding_DefaultBinary((int) 14846L),
  ConfigurationVersionDataType_Encoding_DefaultBinary((int) 14847L),
  FieldTargetDataType_Encoding_DefaultBinary((int) 14848L),
  KeyValuePair_Encoding_DefaultJson((int) 15041L),
  IdentityMappingRuleType_Encoding_DefaultJson((int) 15042L),
  TrustListDataType_Encoding_DefaultJson((int) 15044L),
  DecimalDataType_Encoding_DefaultJson((int) 15045L),
  ConfigurationVersionDataType_Encoding_DefaultJson((int) 15049L),
  DataSetMetaDataType_Encoding_DefaultJson((int) 15050L),
  FieldMetaData_Encoding_DefaultJson((int) 15051L),
  DataTypeDescription_Encoding_DefaultJson((int) 15057L),
  StructureDescription_Encoding_DefaultJson((int) 15058L),
  EnumDescription_Encoding_DefaultJson((int) 15059L),
  PublishedVariableDataType_Encoding_DefaultJson((int) 15060L),
  FieldTargetDataType_Encoding_DefaultJson((int) 15061L),
  RolePermissionType_Encoding_DefaultJson((int) 15062L),
  DataTypeDefinition_Encoding_DefaultJson((int) 15063L),
  StructureField_Encoding_DefaultJson((int) 15065L),
  StructureDefinition_Encoding_DefaultJson((int) 15066L),
  EnumDefinition_Encoding_DefaultJson((int) 15067L),
  Node_Encoding_DefaultJson((int) 15068L),
  InstanceNode_Encoding_DefaultJson((int) 15069L),
  TypeNode_Encoding_DefaultJson((int) 15070L),
  ObjectNode_Encoding_DefaultJson((int) 15071L),
  DatagramConnectionTransportType_DiscoveryAddress((int) 15072L),
  ObjectTypeNode_Encoding_DefaultJson((int) 15073L),
  VariableNode_Encoding_DefaultJson((int) 15074L),
  VariableTypeNode_Encoding_DefaultJson((int) 15075L),
  ReferenceTypeNode_Encoding_DefaultJson((int) 15076L),
  MethodNode_Encoding_DefaultJson((int) 15077L),
  ViewNode_Encoding_DefaultJson((int) 15078L),
  DataTypeNode_Encoding_DefaultJson((int) 15079L),
  ReferenceNode_Encoding_DefaultJson((int) 15080L),
  Argument_Encoding_DefaultJson((int) 15081L),
  EnumValueType_Encoding_DefaultJson((int) 15082L),
  EnumField_Encoding_DefaultJson((int) 15083L),
  OptionSet_Encoding_DefaultJson((int) 15084L),
  Union_Encoding_DefaultJson((int) 15085L),
  TimeZoneDataType_Encoding_DefaultJson((int) 15086L),
  ApplicationDescription_Encoding_DefaultJson((int) 15087L),
  RequestHeader_Encoding_DefaultJson((int) 15088L),
  ResponseHeader_Encoding_DefaultJson((int) 15089L),
  ServiceFault_Encoding_DefaultJson((int) 15090L),
  SessionlessInvokeRequestType_Encoding_DefaultJson((int) 15091L),
  SessionlessInvokeResponseType_Encoding_DefaultJson((int) 15092L),
  FindServersRequest_Encoding_DefaultJson((int) 15093L),
  FindServersResponse_Encoding_DefaultJson((int) 15094L),
  ServerOnNetwork_Encoding_DefaultJson((int) 15095L),
  FindServersOnNetworkRequest_Encoding_DefaultJson((int) 15096L),
  FindServersOnNetworkResponse_Encoding_DefaultJson((int) 15097L),
  UserTokenPolicy_Encoding_DefaultJson((int) 15098L),
  EndpointDescription_Encoding_DefaultJson((int) 15099L),
  GetEndpointsRequest_Encoding_DefaultJson((int) 15100L),
  GetEndpointsResponse_Encoding_DefaultJson((int) 15101L),
  RegisteredServer_Encoding_DefaultJson((int) 15102L),
  RegisterServerRequest_Encoding_DefaultJson((int) 15103L),
  RegisterServerResponse_Encoding_DefaultJson((int) 15104L),
  DiscoveryConfiguration_Encoding_DefaultJson((int) 15105L),
  MdnsDiscoveryConfiguration_Encoding_DefaultJson((int) 15106L),
  RegisterServer2Request_Encoding_DefaultJson((int) 15107L),
  RegisterServer2Response_Encoding_DefaultJson((int) 15130L),
  ChannelSecurityToken_Encoding_DefaultJson((int) 15131L),
  OpenSecureChannelRequest_Encoding_DefaultJson((int) 15132L),
  OpenSecureChannelResponse_Encoding_DefaultJson((int) 15133L),
  CloseSecureChannelRequest_Encoding_DefaultJson((int) 15134L),
  CloseSecureChannelResponse_Encoding_DefaultJson((int) 15135L),
  SignedSoftwareCertificate_Encoding_DefaultJson((int) 15136L),
  SignatureData_Encoding_DefaultJson((int) 15137L),
  CreateSessionRequest_Encoding_DefaultJson((int) 15138L),
  CreateSessionResponse_Encoding_DefaultJson((int) 15139L),
  UserIdentityToken_Encoding_DefaultJson((int) 15140L),
  AnonymousIdentityToken_Encoding_DefaultJson((int) 15141L),
  UserNameIdentityToken_Encoding_DefaultJson((int) 15142L),
  X509IdentityToken_Encoding_DefaultJson((int) 15143L),
  IssuedIdentityToken_Encoding_DefaultJson((int) 15144L),
  ActivateSessionRequest_Encoding_DefaultJson((int) 15145L),
  ActivateSessionResponse_Encoding_DefaultJson((int) 15146L),
  CloseSessionRequest_Encoding_DefaultJson((int) 15147L),
  CloseSessionResponse_Encoding_DefaultJson((int) 15148L),
  CancelRequest_Encoding_DefaultJson((int) 15149L),
  CancelResponse_Encoding_DefaultJson((int) 15150L),
  NodeAttributes_Encoding_DefaultJson((int) 15151L),
  ObjectAttributes_Encoding_DefaultJson((int) 15152L),
  VariableAttributes_Encoding_DefaultJson((int) 15153L),
  MethodAttributes_Encoding_DefaultJson((int) 15157L),
  ObjectTypeAttributes_Encoding_DefaultJson((int) 15158L),
  VariableTypeAttributes_Encoding_DefaultJson((int) 15159L),
  ReferenceTypeAttributes_Encoding_DefaultJson((int) 15160L),
  DataTypeAttributes_Encoding_DefaultJson((int) 15161L),
  ViewAttributes_Encoding_DefaultJson((int) 15162L),
  GenericAttributeValue_Encoding_DefaultJson((int) 15163L),
  GenericAttributes_Encoding_DefaultJson((int) 15164L),
  AddNodesItem_Encoding_DefaultJson((int) 15165L),
  AddNodesResult_Encoding_DefaultJson((int) 15166L),
  AddNodesRequest_Encoding_DefaultJson((int) 15167L),
  AddNodesResponse_Encoding_DefaultJson((int) 15168L),
  AddReferencesItem_Encoding_DefaultJson((int) 15169L),
  AddReferencesRequest_Encoding_DefaultJson((int) 15170L),
  AddReferencesResponse_Encoding_DefaultJson((int) 15171L),
  DeleteNodesItem_Encoding_DefaultJson((int) 15172L),
  DeleteNodesRequest_Encoding_DefaultJson((int) 15173L),
  DeleteNodesResponse_Encoding_DefaultJson((int) 15174L),
  DeleteReferencesItem_Encoding_DefaultJson((int) 15175L),
  DeleteReferencesRequest_Encoding_DefaultJson((int) 15176L),
  DeleteReferencesResponse_Encoding_DefaultJson((int) 15177L),
  ViewDescription_Encoding_DefaultJson((int) 15179L),
  BrowseDescription_Encoding_DefaultJson((int) 15180L),
  ReferenceDescription_Encoding_DefaultJson((int) 15182L),
  BrowseResult_Encoding_DefaultJson((int) 15183L),
  BrowseRequest_Encoding_DefaultJson((int) 15184L),
  BrowseResponse_Encoding_DefaultJson((int) 15185L),
  BrowseNextRequest_Encoding_DefaultJson((int) 15186L),
  BrowseNextResponse_Encoding_DefaultJson((int) 15187L),
  RelativePathElement_Encoding_DefaultJson((int) 15188L),
  RelativePath_Encoding_DefaultJson((int) 15189L),
  BrowsePath_Encoding_DefaultJson((int) 15190L),
  BrowsePathTarget_Encoding_DefaultJson((int) 15191L),
  BrowsePathResult_Encoding_DefaultJson((int) 15192L),
  TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultJson((int) 15193L),
  TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultJson((int) 15194L),
  RegisterNodesRequest_Encoding_DefaultJson((int) 15195L),
  RegisterNodesResponse_Encoding_DefaultJson((int) 15196L),
  UnregisterNodesRequest_Encoding_DefaultJson((int) 15197L),
  UnregisterNodesResponse_Encoding_DefaultJson((int) 15198L),
  EndpointConfiguration_Encoding_DefaultJson((int) 15199L),
  QueryDataDescription_Encoding_DefaultJson((int) 15200L),
  NodeTypeDescription_Encoding_DefaultJson((int) 15201L),
  QueryDataSet_Encoding_DefaultJson((int) 15202L),
  NodeReference_Encoding_DefaultJson((int) 15203L),
  ContentFilterElement_Encoding_DefaultJson((int) 15204L),
  ContentFilter_Encoding_DefaultJson((int) 15205L),
  FilterOperand_Encoding_DefaultJson((int) 15206L),
  ElementOperand_Encoding_DefaultJson((int) 15207L),
  LiteralOperand_Encoding_DefaultJson((int) 15208L),
  AttributeOperand_Encoding_DefaultJson((int) 15209L),
  SimpleAttributeOperand_Encoding_DefaultJson((int) 15210L),
  ContentFilterElementResult_Encoding_DefaultJson((int) 15211L),
  PublishedDataSetType_DataSetWriterName_Placeholder((int) 15222L),
  PublishedDataSetType_DataSetWriterName_Placeholder_Status((int) 15223L),
  PublishedDataSetType_DataSetWriterName_Placeholder_TransportSettings((int) 15227L),
  ContentFilterResult_Encoding_DefaultJson((int) 15228L),
  ParsingResult_Encoding_DefaultJson((int) 15236L),
  QueryFirstRequest_Encoding_DefaultJson((int) 15244L),
  QueryFirstResponse_Encoding_DefaultJson((int) 15252L),
  QueryNextRequest_Encoding_DefaultJson((int) 15254L),
  QueryNextResponse_Encoding_DefaultJson((int) 15255L),
  ReadValueId_Encoding_DefaultJson((int) 15256L),
  ReadRequest_Encoding_DefaultJson((int) 15257L),
  ReadResponse_Encoding_DefaultJson((int) 15258L),
  HistoryReadValueId_Encoding_DefaultJson((int) 15259L),
  HistoryReadResult_Encoding_DefaultJson((int) 15260L),
  HistoryReadDetails_Encoding_DefaultJson((int) 15261L),
  ReadEventDetails_Encoding_DefaultJson((int) 15262L),
  ReadRawModifiedDetails_Encoding_DefaultJson((int) 15263L),
  ReadProcessedDetails_Encoding_DefaultJson((int) 15264L),
  PubSubGroupType_Status((int) 15265L),
  ReadAtTimeDetails_Encoding_DefaultJson((int) 15269L),
  HistoryData_Encoding_DefaultJson((int) 15270L),
  ModificationInfo_Encoding_DefaultJson((int) 15271L),
  HistoryModifiedData_Encoding_DefaultJson((int) 15272L),
  HistoryEvent_Encoding_DefaultJson((int) 15273L),
  HistoryReadRequest_Encoding_DefaultJson((int) 15274L),
  HistoryReadResponse_Encoding_DefaultJson((int) 15275L),
  WriteValue_Encoding_DefaultJson((int) 15276L),
  WriteRequest_Encoding_DefaultJson((int) 15277L),
  WriteResponse_Encoding_DefaultJson((int) 15278L),
  HistoryUpdateDetails_Encoding_DefaultJson((int) 15279L),
  UpdateDataDetails_Encoding_DefaultJson((int) 15280L),
  UpdateStructureDataDetails_Encoding_DefaultJson((int) 15281L),
  UpdateEventDetails_Encoding_DefaultJson((int) 15282L),
  DeleteRawModifiedDetails_Encoding_DefaultJson((int) 15283L),
  DeleteAtTimeDetails_Encoding_DefaultJson((int) 15284L),
  DeleteEventDetails_Encoding_DefaultJson((int) 15285L),
  HistoryUpdateResult_Encoding_DefaultJson((int) 15286L),
  HistoryUpdateRequest_Encoding_DefaultJson((int) 15287L),
  HistoryUpdateResponse_Encoding_DefaultJson((int) 15288L),
  CallMethodRequest_Encoding_DefaultJson((int) 15289L),
  CallMethodResult_Encoding_DefaultJson((int) 15290L),
  CallRequest_Encoding_DefaultJson((int) 15291L),
  CallResponse_Encoding_DefaultJson((int) 15292L),
  MonitoringFilter_Encoding_DefaultJson((int) 15293L),
  DataChangeFilter_Encoding_DefaultJson((int) 15294L),
  EventFilter_Encoding_DefaultJson((int) 15295L),
  DataSetWriterType_Status((int) 15299L),
  DataSetWriterType_TransportSettings((int) 15303L),
  AggregateConfiguration_Encoding_DefaultJson((int) 15304L),
  DataSetReaderType_Status((int) 15307L),
  DataSetReaderType_TransportSettings((int) 15311L),
  AggregateFilter_Encoding_DefaultJson((int) 15312L),
  MonitoringFilterResult_Encoding_DefaultJson((int) 15313L),
  EventFilterResult_Encoding_DefaultJson((int) 15314L),
  AggregateFilterResult_Encoding_DefaultJson((int) 15315L),
  DataSetReaderType_SubscribedDataSet((int) 15316L),
  MonitoringParameters_Encoding_DefaultJson((int) 15320L),
  MonitoredItemCreateRequest_Encoding_DefaultJson((int) 15321L),
  MonitoredItemCreateResult_Encoding_DefaultJson((int) 15322L),
  CreateMonitoredItemsRequest_Encoding_DefaultJson((int) 15323L),
  CreateMonitoredItemsResponse_Encoding_DefaultJson((int) 15324L),
  MonitoredItemModifyRequest_Encoding_DefaultJson((int) 15325L),
  MonitoredItemModifyResult_Encoding_DefaultJson((int) 15326L),
  ModifyMonitoredItemsRequest_Encoding_DefaultJson((int) 15327L),
  ModifyMonitoredItemsResponse_Encoding_DefaultJson((int) 15328L),
  SetMonitoringModeRequest_Encoding_DefaultJson((int) 15329L),
  SetMonitoringModeResponse_Encoding_DefaultJson((int) 15331L),
  SetTriggeringRequest_Encoding_DefaultJson((int) 15332L),
  SetTriggeringResponse_Encoding_DefaultJson((int) 15333L),
  DeleteMonitoredItemsRequest_Encoding_DefaultJson((int) 15335L),
  DeleteMonitoredItemsResponse_Encoding_DefaultJson((int) 15336L),
  CreateSubscriptionRequest_Encoding_DefaultJson((int) 15337L),
  CreateSubscriptionResponse_Encoding_DefaultJson((int) 15338L),
  ModifySubscriptionRequest_Encoding_DefaultJson((int) 15339L),
  ModifySubscriptionResponse_Encoding_DefaultJson((int) 15340L),
  SetPublishingModeRequest_Encoding_DefaultJson((int) 15341L),
  SetPublishingModeResponse_Encoding_DefaultJson((int) 15342L),
  NotificationMessage_Encoding_DefaultJson((int) 15343L),
  NotificationData_Encoding_DefaultJson((int) 15344L),
  DataChangeNotification_Encoding_DefaultJson((int) 15345L),
  MonitoredItemNotification_Encoding_DefaultJson((int) 15346L),
  EventNotificationList_Encoding_DefaultJson((int) 15347L),
  EventFieldList_Encoding_DefaultJson((int) 15348L),
  HistoryEventFieldList_Encoding_DefaultJson((int) 15349L),
  StatusChangeNotification_Encoding_DefaultJson((int) 15350L),
  SubscriptionAcknowledgement_Encoding_DefaultJson((int) 15351L),
  PublishRequest_Encoding_DefaultJson((int) 15352L),
  PublishResponse_Encoding_DefaultJson((int) 15353L),
  RepublishRequest_Encoding_DefaultJson((int) 15354L),
  RepublishResponse_Encoding_DefaultJson((int) 15355L),
  TransferResult_Encoding_DefaultJson((int) 15356L),
  TransferSubscriptionsRequest_Encoding_DefaultJson((int) 15357L),
  TransferSubscriptionsResponse_Encoding_DefaultJson((int) 15358L),
  DeleteSubscriptionsRequest_Encoding_DefaultJson((int) 15359L),
  DeleteSubscriptionsResponse_Encoding_DefaultJson((int) 15360L),
  BuildInfo_Encoding_DefaultJson((int) 15361L),
  RedundantServerDataType_Encoding_DefaultJson((int) 15362L),
  EndpointUrlListDataType_Encoding_DefaultJson((int) 15363L),
  NetworkGroupDataType_Encoding_DefaultJson((int) 15364L),
  SamplingIntervalDiagnosticsDataType_Encoding_DefaultJson((int) 15365L),
  ServerDiagnosticsSummaryDataType_Encoding_DefaultJson((int) 15366L),
  ServerStatusDataType_Encoding_DefaultJson((int) 15367L),
  SessionDiagnosticsDataType_Encoding_DefaultJson((int) 15368L),
  SessionSecurityDiagnosticsDataType_Encoding_DefaultJson((int) 15369L),
  ServiceCounterDataType_Encoding_DefaultJson((int) 15370L),
  StatusResult_Encoding_DefaultJson((int) 15371L),
  SubscriptionDiagnosticsDataType_Encoding_DefaultJson((int) 15372L),
  ModelChangeStructureDataType_Encoding_DefaultJson((int) 15373L),
  SemanticChangeStructureDataType_Encoding_DefaultJson((int) 15374L),
  Range_Encoding_DefaultJson((int) 15375L),
  EUInformation_Encoding_DefaultJson((int) 15376L),
  ComplexNumberType_Encoding_DefaultJson((int) 15377L),
  DoubleComplexNumberType_Encoding_DefaultJson((int) 15378L),
  AxisInformation_Encoding_DefaultJson((int) 15379L),
  XVType_Encoding_DefaultJson((int) 15380L),
  ProgramDiagnosticDataType_Encoding_DefaultJson((int) 15381L),
  Annotation_Encoding_DefaultJson((int) 15382L),
  SimpleTypeDescription_Encoding_DefaultBinary((int) 15421L),
  UABinaryFileDataType_Encoding_DefaultBinary((int) 15422L),
  PublishSubscribe_SecurityGroups((int) 15443L),
  SecurityGroupFolderType_SecurityGroupFolderName_Placeholder((int) 15453L),
  SecurityGroupFolderType_SecurityGroupName_Placeholder((int) 15459L),
  DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields((int) 15473L),
  BrokerConnectionTransportDataType_Encoding_DefaultBinary((int) 15479L),
  PublishedDataSetType_ExtensionFields((int) 15481L),
  SimpleTypeDescription_Encoding_DefaultXml((int) 15529L),
  UABinaryFileDataType_Encoding_DefaultXml((int) 15531L),
  BrokerConnectionTransportDataType_Encoding_DefaultXml((int) 15579L),
  StructureDescription_Encoding_DefaultXml((int) 15589L),
  EnumDescription_Encoding_DefaultXml((int) 15590L),
  Server_ServerCapabilities_RoleSet((int) 15606L),
  RoleSetType_RoleName_Placeholder((int) 15608L),
  WellKnownRole_Anonymous((int) 15644L),
  WellKnownRole_AuthenticatedUser((int) 15656L),
  WellKnownRole_Observer((int) 15668L),
  EndpointType_Encoding_DefaultBinary((int) 15671L),
  DataTypeSchemaHeader_Encoding_DefaultBinary((int) 15676L),
  PublishedDataSetDataType_Encoding_DefaultBinary((int) 15677L),
  PublishedDataSetSourceDataType_Encoding_DefaultBinary((int) 15678L),
  PublishedDataItemsDataType_Encoding_DefaultBinary((int) 15679L),
  WellKnownRole_Operator((int) 15680L),
  PublishedEventsDataType_Encoding_DefaultBinary((int) 15681L),
  DataSetWriterDataType_Encoding_DefaultBinary((int) 15682L),
  DataSetWriterTransportDataType_Encoding_DefaultBinary((int) 15683L),
  DataSetWriterMessageDataType_Encoding_DefaultBinary((int) 15688L),
  PubSubGroupDataType_Encoding_DefaultBinary((int) 15689L),
  WriterGroupTransportDataType_Encoding_DefaultBinary((int) 15691L),
  WellKnownRole_Supervisor((int) 15692L),
  WriterGroupMessageDataType_Encoding_DefaultBinary((int) 15693L),
  PubSubConnectionDataType_Encoding_DefaultBinary((int) 15694L),
  ConnectionTransportDataType_Encoding_DefaultBinary((int) 15695L),
  SimpleTypeDescription_Encoding_DefaultJson((int) 15700L),
  ReaderGroupTransportDataType_Encoding_DefaultBinary((int) 15701L),
  ReaderGroupMessageDataType_Encoding_DefaultBinary((int) 15702L),
  DataSetReaderDataType_Encoding_DefaultBinary((int) 15703L),
  WellKnownRole_SecurityAdmin((int) 15704L),
  DataSetReaderTransportDataType_Encoding_DefaultBinary((int) 15705L),
  DataSetReaderMessageDataType_Encoding_DefaultBinary((int) 15706L),
  SubscribedDataSetDataType_Encoding_DefaultBinary((int) 15707L),
  TargetVariablesDataType_Encoding_DefaultBinary((int) 15712L),
  SubscribedDataSetMirrorDataType_Encoding_DefaultBinary((int) 15713L),
  UABinaryFileDataType_Encoding_DefaultJson((int) 15714L),
  UadpWriterGroupMessageDataType_Encoding_DefaultBinary((int) 15715L),
  WellKnownRole_ConfigureAdmin((int) 15716L),
  UadpDataSetWriterMessageDataType_Encoding_DefaultBinary((int) 15717L),
  UadpDataSetReaderMessageDataType_Encoding_DefaultBinary((int) 15718L),
  JsonWriterGroupMessageDataType_Encoding_DefaultBinary((int) 15719L),
  JsonDataSetWriterMessageDataType_Encoding_DefaultBinary((int) 15724L),
  JsonDataSetReaderMessageDataType_Encoding_DefaultBinary((int) 15725L),
  BrokerConnectionTransportDataType_Encoding_DefaultJson((int) 15726L),
  BrokerWriterGroupTransportDataType_Encoding_DefaultBinary((int) 15727L),
  IdentityMappingRuleType_Encoding_DefaultXml((int) 15728L),
  BrokerDataSetWriterTransportDataType_Encoding_DefaultBinary((int) 15729L),
  BrokerDataSetReaderTransportDataType_Encoding_DefaultBinary((int) 15733L),
  IdentityMappingRuleType_Encoding_DefaultBinary((int) 15736L),
  TemporaryFileTransferType_TransferState_Placeholder((int) 15754L),
  FileTransferStateMachineType_Idle((int) 15815L),
  FileTransferStateMachineType_ReadPrepare((int) 15817L),
  FileTransferStateMachineType_ReadTransfer((int) 15819L),
  FileTransferStateMachineType_ApplyWrite((int) 15821L),
  FileTransferStateMachineType_Error((int) 15823L),
  FileTransferStateMachineType_IdleToReadPrepare((int) 15825L),
  FileTransferStateMachineType_ReadPrepareToReadTransfer((int) 15827L),
  FileTransferStateMachineType_ReadTransferToIdle((int) 15829L),
  FileTransferStateMachineType_IdleToApplyWrite((int) 15831L),
  FileTransferStateMachineType_ApplyWriteToIdle((int) 15833L),
  FileTransferStateMachineType_ReadPrepareToError((int) 15835L),
  FileTransferStateMachineType_ReadTransferToError((int) 15837L),
  FileTransferStateMachineType_ApplyWriteToError((int) 15839L),
  FileTransferStateMachineType_ErrorToIdle((int) 15841L),
  PublishSubscribeType_Status((int) 15844L),
  SessionlessInvokeRequestType_Encoding_DefaultXml((int) 15902L),
  SessionlessInvokeRequestType_Encoding_DefaultBinary((int) 15903L),
  PublishSubscribeType_ConnectionName_Placeholder_TransportSettings((int) 15905L),
  PubSubKeyServiceType_SecurityGroups((int) 15913L),
  EndpointType_Encoding_DefaultXml((int) 15949L),
  DataTypeSchemaHeader_Encoding_DefaultXml((int) 15950L),
  PublishedDataSetDataType_Encoding_DefaultXml((int) 15951L),
  PublishedDataSetSourceDataType_Encoding_DefaultXml((int) 15952L),
  PublishedDataItemsDataType_Encoding_DefaultXml((int) 15953L),
  PublishedEventsDataType_Encoding_DefaultXml((int) 15954L),
  DataSetWriterDataType_Encoding_DefaultXml((int) 15955L),
  DataSetWriterTransportDataType_Encoding_DefaultXml((int) 15956L),
  OPCUANamespaceMetadata((int) 15957L),
  OPCUANamespaceMetadata_NamespaceFile((int) 15965L),
  DataSetWriterMessageDataType_Encoding_DefaultXml((int) 15987L),
  PubSubGroupDataType_Encoding_DefaultXml((int) 15988L),
  WriterGroupTransportDataType_Encoding_DefaultXml((int) 15990L),
  WriterGroupMessageDataType_Encoding_DefaultXml((int) 15991L),
  PubSubConnectionDataType_Encoding_DefaultXml((int) 15992L),
  ConnectionTransportDataType_Encoding_DefaultXml((int) 15993L),
  ReaderGroupTransportDataType_Encoding_DefaultXml((int) 15995L),
  ReaderGroupMessageDataType_Encoding_DefaultXml((int) 15996L),
  DataSetReaderDataType_Encoding_DefaultXml((int) 16007L),
  DataSetReaderTransportDataType_Encoding_DefaultXml((int) 16008L),
  DataSetReaderMessageDataType_Encoding_DefaultXml((int) 16009L),
  SubscribedDataSetDataType_Encoding_DefaultXml((int) 16010L),
  TargetVariablesDataType_Encoding_DefaultXml((int) 16011L),
  SubscribedDataSetMirrorDataType_Encoding_DefaultXml((int) 16012L),
  UadpWriterGroupMessageDataType_Encoding_DefaultXml((int) 16014L),
  UadpDataSetWriterMessageDataType_Encoding_DefaultXml((int) 16015L),
  UadpDataSetReaderMessageDataType_Encoding_DefaultXml((int) 16016L),
  JsonWriterGroupMessageDataType_Encoding_DefaultXml((int) 16017L),
  JsonDataSetWriterMessageDataType_Encoding_DefaultXml((int) 16018L),
  JsonDataSetReaderMessageDataType_Encoding_DefaultXml((int) 16019L),
  BrokerWriterGroupTransportDataType_Encoding_DefaultXml((int) 16021L),
  BrokerDataSetWriterTransportDataType_Encoding_DefaultXml((int) 16022L),
  BrokerDataSetReaderTransportDataType_Encoding_DefaultXml((int) 16023L),
  WellKnownRole_Engineer((int) 16036L),
  RolePermissionType_Encoding_DefaultXml((int) 16126L),
  EndpointType_Encoding_DefaultJson((int) 16150L),
  DataTypeSchemaHeader_Encoding_DefaultJson((int) 16151L),
  PublishedDataSetDataType_Encoding_DefaultJson((int) 16152L),
  PublishedDataSetSourceDataType_Encoding_DefaultJson((int) 16153L),
  PublishedDataItemsDataType_Encoding_DefaultJson((int) 16154L),
  PublishedEventsDataType_Encoding_DefaultJson((int) 16155L),
  DataSetWriterDataType_Encoding_DefaultJson((int) 16156L),
  DataSetWriterTransportDataType_Encoding_DefaultJson((int) 16157L),
  DataSetWriterMessageDataType_Encoding_DefaultJson((int) 16158L),
  PubSubGroupDataType_Encoding_DefaultJson((int) 16159L),
  WriterGroupTransportDataType_Encoding_DefaultJson((int) 16161L),
  WriterGroupMessageDataType_Encoding_DefaultJson((int) 16280L),
  PubSubConnectionDataType_Encoding_DefaultJson((int) 16281L),
  ConnectionTransportDataType_Encoding_DefaultJson((int) 16282L),
  ReaderGroupTransportDataType_Encoding_DefaultJson((int) 16284L),
  ReaderGroupMessageDataType_Encoding_DefaultJson((int) 16285L),
  DataSetReaderDataType_Encoding_DefaultJson((int) 16286L),
  DataSetReaderTransportDataType_Encoding_DefaultJson((int) 16287L),
  DataSetReaderMessageDataType_Encoding_DefaultJson((int) 16288L),
  ServerType_ServerCapabilities_RoleSet((int) 16289L),
  ServerCapabilitiesType_RoleSet((int) 16295L),
  SubscribedDataSetDataType_Encoding_DefaultJson((int) 16308L),
  TargetVariablesDataType_Encoding_DefaultJson((int) 16310L),
  SubscribedDataSetMirrorDataType_Encoding_DefaultJson((int) 16311L),
  FileSystem((int) 16314L),
  UadpWriterGroupMessageDataType_Encoding_DefaultJson((int) 16323L),
  UadpDataSetWriterMessageDataType_Encoding_DefaultJson((int) 16391L),
  UadpDataSetReaderMessageDataType_Encoding_DefaultJson((int) 16392L),
  JsonWriterGroupMessageDataType_Encoding_DefaultJson((int) 16393L),
  JsonDataSetWriterMessageDataType_Encoding_DefaultJson((int) 16394L),
  AlarmConditionType_FirstInGroup((int) 16398L),
  AlarmConditionType_AlarmGroup_Placeholder((int) 16399L),
  JsonDataSetReaderMessageDataType_Encoding_DefaultJson((int) 16404L),
  AlarmGroupType_AlarmConditionInstance_Placeholder((int) 16406L),
  AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState((int) 16502L),
  BrokerWriterGroupTransportDataType_Encoding_DefaultJson((int) 16524L),
  BrokerDataSetWriterTransportDataType_Encoding_DefaultJson((int) 16525L),
  BrokerDataSetReaderTransportDataType_Encoding_DefaultJson((int) 16526L),
  AlarmGroupType_AlarmConditionInstance_Placeholder_FirstInGroup((int) 16530L),
  PublishedDataSetType_DataSetWriterName_Placeholder_MessageSettings((int) 16758L),
  PubSubConnectionType_TransportSettings((int) 17203L),
  PubSubConnectionType_WriterGroupName_Placeholder_TransportSettings((int) 17290L),
  PubSubConnectionType_WriterGroupName_Placeholder_MessageSettings((int) 17291L),
  PubSubConnectionType_ReaderGroupName_Placeholder_TransportSettings((int) 17307L),
  PubSubConnectionType_ReaderGroupName_Placeholder_MessageSettings((int) 17308L),
  PubSubConnectionType_WriterGroupName_Placeholder((int) 17310L),
  PubSubConnectionType_WriterGroupName_Placeholder_Status((int) 17314L),
  PubSubConnectionType_ReaderGroupName_Placeholder((int) 17325L),
  PubSubConnectionType_ReaderGroupName_Placeholder_Status((int) 17329L),
  PublishSubscribe_PublishedDataSets((int) 17371L),
  PublishSubscribe_Status((int) 17405L),
  PublishSubscribe_Diagnostics((int) 17409L),
  PublishSubscribe_Diagnostics_Counters((int) 17423L),
  PublishSubscribe_Diagnostics_LiveValues((int) 17457L),
  DatagramConnectionTransportDataType_Encoding_DefaultBinary((int) 17468L),
  DatagramConnectionTransportDataType_Encoding_DefaultXml((int) 17472L),
  DatagramConnectionTransportDataType_Encoding_DefaultJson((int) 17476L),
  KeyCredentialConfigurationFolderType_ServiceName_Placeholder((int) 17511L),
  AdditionalParametersType_Encoding_DefaultBinary((int) 17537L),
  AdditionalParametersType_Encoding_DefaultXml((int) 17541L),
  AdditionalParametersType_Encoding_DefaultJson((int) 17547L),
  EphemeralKeyType_Encoding_DefaultBinary((int) 17549L),
  EphemeralKeyType_Encoding_DefaultXml((int) 17553L),
  EphemeralKeyType_Encoding_DefaultJson((int) 17557L),
  DictionaryEntryType_DictionaryEntryName_Placeholder((int) 17590L),
  DictionaryFolderType_DictionaryFolderName_Placeholder((int) 17592L),
  DictionaryFolderType_DictionaryEntryName_Placeholder((int) 17593L),
  Dictionaries((int) 17594L),
  GenericAttributeValue_Encoding_DefaultXml((int) 17608L),
  GenericAttributes_Encoding_DefaultXml((int) 17609L),
  GenericAttributeValue_Encoding_DefaultBinary((int) 17610L),
  GenericAttributes_Encoding_DefaultBinary((int) 17611L),
  InterfaceTypes((int) 17708L),
  AuthorizationServices((int) 17732L),
  WriterGroupType_TransportSettings((int) 17741L),
  WriterGroupType_MessageSettings((int) 17742L),
  WriterGroupType_DataSetWriterName_Placeholder((int) 17743L),
  WriterGroupType_DataSetWriterName_Placeholder_TransportSettings((int) 17747L),
  WriterGroupType_DataSetWriterName_Placeholder_MessageSettings((int) 17748L),
  WriterGroupType_DataSetWriterName_Placeholder_Status((int) 17749L),
  WriterGroupType_DataSetWriterName_Placeholder_Diagnostics((int) 17753L),
  WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters((int) 17767L),
  WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues((int) 17798L),
  WriterGroupType_Diagnostics((int) 17812L),
  WriterGroupType_Diagnostics_Counters((int) 17826L),
  WriterGroupType_Diagnostics_LiveValues((int) 17858L),
  DecimalDataType_Encoding_DefaultXml((int) 17862L),
  DecimalDataType_Encoding_DefaultBinary((int) 17863L),
  ReaderGroupType_DataSetReaderName_Placeholder((int) 18076L),
  ReaderGroupType_DataSetReaderName_Placeholder_TransportSettings((int) 18086L),
  ReaderGroupType_DataSetReaderName_Placeholder_MessageSettings((int) 18087L),
  ReaderGroupType_DataSetReaderName_Placeholder_Status((int) 18088L),
  ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics((int) 18092L),
  ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters((int) 18106L),
  ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues((int) 18137L),
  KeyCredentialConfiguration((int) 18155L),
  PublishSubscribeType_ConnectionName_Placeholder_Diagnostics((int) 18667L),
  PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters((int) 18681L),
  PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_LiveValues((int) 18712L),
  PublishSubscribeType_Diagnostics((int) 18715L),
  PublishSubscribeType_Diagnostics_Counters((int) 18729L),
  PublishSubscribeType_Diagnostics_LiveValues((int) 18760L),
  RationalNumber_Encoding_DefaultBinary((int) 18815L),
  Vector_Encoding_DefaultBinary((int) 18816L),
  ThreeDVector_Encoding_DefaultBinary((int) 18817L),
  CartesianCoordinates_Encoding_DefaultBinary((int) 18818L),
  ThreeDCartesianCoordinates_Encoding_DefaultBinary((int) 18819L),
  Orientation_Encoding_DefaultBinary((int) 18820L),
  ThreeDOrientation_Encoding_DefaultBinary((int) 18821L),
  Frame_Encoding_DefaultBinary((int) 18822L),
  ThreeDFrame_Encoding_DefaultBinary((int) 18823L),
  RationalNumber_Encoding_DefaultXml((int) 18851L),
  Vector_Encoding_DefaultXml((int) 18852L),
  ThreeDVector_Encoding_DefaultXml((int) 18853L),
  CartesianCoordinates_Encoding_DefaultXml((int) 18854L),
  ThreeDCartesianCoordinates_Encoding_DefaultXml((int) 18855L),
  Orientation_Encoding_DefaultXml((int) 18856L),
  ThreeDOrientation_Encoding_DefaultXml((int) 18857L),
  Frame_Encoding_DefaultXml((int) 18858L),
  ThreeDFrame_Encoding_DefaultXml((int) 18859L),
  PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics((int) 18871L),
  PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters((int) 18885L),
  PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues((int) 18916L),
  RationalNumber_Encoding_DefaultJson((int) 19064L),
  Vector_Encoding_DefaultJson((int) 19065L),
  ThreeDVector_Encoding_DefaultJson((int) 19066L),
  CartesianCoordinates_Encoding_DefaultJson((int) 19067L),
  ThreeDCartesianCoordinates_Encoding_DefaultJson((int) 19068L),
  Orientation_Encoding_DefaultJson((int) 19069L),
  ThreeDOrientation_Encoding_DefaultJson((int) 19070L),
  Frame_Encoding_DefaultJson((int) 19071L),
  ThreeDFrame_Encoding_DefaultJson((int) 19072L),
  PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics((int) 19107L),
  PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters((int) 19121L),
  PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues((int) 19152L),
  PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics((int) 19176L),
  PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters((int) 19190L),
  PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues((int) 19221L),
  PubSubConnectionType_Diagnostics((int) 19241L),
  PubSubConnectionType_Diagnostics_Counters((int) 19255L),
  PubSubConnectionType_Diagnostics_LiveValues((int) 19286L),
  CertificateGroupType_CertificateExpired((int) 19450L),
  CertificateGroupType_CertificateExpired_ShelvingState((int) 19537L),
  DataSetWriterType_Diagnostics((int) 19550L),
  DataSetWriterType_Diagnostics_Counters((int) 19564L),
  DataSetWriterType_Diagnostics_LiveValues((int) 19595L),
  DataSetReaderType_Diagnostics((int) 19609L),
  DataSetReaderType_Diagnostics_Counters((int) 19623L),
  DataSetReaderType_Diagnostics_LiveValues((int) 19654L),
  PubSubDiagnosticsType_Counters((int) 19691L),
  PubSubDiagnosticsType_LiveValues((int) 19722L),
  PubSubDiagnosticsRootType_LiveValues((int) 19777L),
  PubSubDiagnosticsConnectionType_LiveValues((int) 19831L),
  PubSubDiagnosticsWriterGroupType_Counters((int) 19848L),
  PubSubDiagnosticsWriterGroupType_LiveValues((int) 19879L),
  PubSubDiagnosticsReaderGroupType_Counters((int) 19917L),
  PubSubDiagnosticsReaderGroupType_LiveValues((int) 19948L),
  PubSubDiagnosticsDataSetWriterType_Counters((int) 19982L),
  PubSubDiagnosticsDataSetWriterType_LiveValues((int) 20013L),
  PubSubDiagnosticsDataSetReaderType_Counters((int) 20041L),
  PubSubDiagnosticsDataSetReaderType_LiveValues((int) 20072L),
  CertificateGroupType_CertificateExpired_FirstInGroup((int) 20120L),
  CertificateGroupType_TrustListOutOfDate((int) 20143L),
  CertificateGroupType_TrustListOutOfDate_ShelvingState((int) 20230L),
  CertificateGroupType_TrustListOutOfDate_FirstInGroup((int) 20268L),
  CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired((int) 20291L),
  CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState((int) 20378L),
  CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_FirstInGroup((int) 20418L),
  CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate((int) 20441L),
  CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState((int) 20528L),
  CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup((int) 20566L),
  CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired((int) 20589L),
  CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState((int) 20676L),
  CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_FirstInGroup((int) 20714L),
  CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate((int) 20737L),
  CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState((int) 20824L),
  CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup((int) 20862L),
  CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired((int) 20885L),
  CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState((int) 20972L),
  SessionlessInvokeResponseType_Encoding_DefaultXml((int) 21000L),
  SessionlessInvokeResponseType_Encoding_DefaultBinary((int) 21001L),
  ReaderGroupType_DataSetReaderName_Placeholder_SubscribedDataSet((int) 21006L),
  ReaderGroupType_Diagnostics((int) 21015L),
  ReaderGroupType_Diagnostics_Counters((int) 21029L),
  ReaderGroupType_Diagnostics_LiveValues((int) 21060L),
  ReaderGroupType_TransportSettings((int) 21080L),
  ReaderGroupType_MessageSettings((int) 21081L),
  DataSetWriterType_MessageSettings((int) 21095L),
  DataSetReaderType_MessageSettings((int) 21103L),
  WriterGroupDataType_Encoding_DefaultBinary((int) 21150L),
  NetworkAddressDataType_Encoding_DefaultBinary((int) 21151L),
  NetworkAddressUrlDataType_Encoding_DefaultBinary((int) 21152L),
  ReaderGroupDataType_Encoding_DefaultBinary((int) 21153L),
  PubSubConfigurationDataType_Encoding_DefaultBinary((int) 21154L),
  DatagramWriterGroupTransportDataType_Encoding_DefaultBinary((int) 21155L),
  WriterGroupDataType_Encoding_DefaultXml((int) 21174L),
  NetworkAddressDataType_Encoding_DefaultXml((int) 21175L),
  NetworkAddressUrlDataType_Encoding_DefaultXml((int) 21176L),
  ReaderGroupDataType_Encoding_DefaultXml((int) 21177L),
  PubSubConfigurationDataType_Encoding_DefaultXml((int) 21178L),
  DatagramWriterGroupTransportDataType_Encoding_DefaultXml((int) 21179L),
  WriterGroupDataType_Encoding_DefaultJson((int) 21198L),
  NetworkAddressDataType_Encoding_DefaultJson((int) 21199L),
  NetworkAddressUrlDataType_Encoding_DefaultJson((int) 21200L),
  ReaderGroupDataType_Encoding_DefaultJson((int) 21201L),
  PubSubConfigurationDataType_Encoding_DefaultJson((int) 21202L),
  DatagramWriterGroupTransportDataType_Encoding_DefaultJson((int) 21203L),
  CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_FirstInGroup((int) 21213L),
  CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate((int) 21236L),
  CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState((int) 21323L),
  CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup((int) 21361L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired((int) 21384L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState(
      (int) 21471L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_FirstInGroup(
      (int) 21509L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate((int) 21532L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState(
      (int) 21619L),
  CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_FirstInGroup(
      (int) 21657L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired(
      (int) 21680L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState(
      (int) 21767L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup(
      (int) 21805L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate(
      (int) 21828L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState(
      (int) 21915L),
  ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup(
      (int) 21953L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired((int) 21976L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState(
      (int) 22063L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup(
      (int) 22101L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate((int) 22124L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState(
      (int) 22211L),
  ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup(
      (int) 22249L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired((int) 22272L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState(
      (int) 22359L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup(
      (int) 22397L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate((int) 22420L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState(
      (int) 22507L),
  ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup(
      (int) 22545L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired((int) 22568L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState(
      (int) 22655L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup(
      (int) 22693L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate((int) 22716L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState(
      (int) 22803L),
  ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup(
      (int) 22841L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired((int) 22864L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState(
      (int) 22951L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup(
      (int) 22989L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate((int) 23012L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState(
      (int) 23099L),
  ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup(
      (int) 23137L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired((int) 23160L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState(
      (int) 23247L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup(
      (int) 23285L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate((int) 23308L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState(
      (int) 23395L),
  ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup(
      (int) 23433L),
  AliasNameCategoryType_Alias_Placeholder((int) 23457L),
  AliasNameCategoryType_SubAliasNameCategories_Placeholder((int) 23458L),
  Aliases((int) 23470L),
  TagVariables((int) 23479L),
  Topics((int) 23488L),
  AliasNameDataType_Encoding_DefaultBinary((int) 23499L),
  ReadAnnotationDataDetails_Encoding_DefaultBinary((int) 23500L),
  AliasNameDataType_Encoding_DefaultXml((int) 23505L),
  ReadAnnotationDataDetails_Encoding_DefaultXml((int) 23506L),
  CurrencyUnitType_Encoding_DefaultBinary((int) 23507L),
  AliasNameDataType_Encoding_DefaultJson((int) 23511L),
  ReadAnnotationDataDetails_Encoding_DefaultJson((int) 23512L),
  OrderedListType_OrderedObject_Placeholder((int) 23519L),
  CurrencyUnitType_Encoding_DefaultXml((int) 23520L),
  CurrencyUnitType_Encoding_DefaultJson((int) 23528L),
  AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder((int) 23557L),
  PublishSubscribeType_SubscribedDataSets((int) 23622L),
  PublishSubscribeType_PubSubCapablities((int) 23642L),
  PublishSubscribeType_DataSetClasses((int) 23649L),
  PublishSubscribe_SubscribedDataSets((int) 23658L),
  PublishSubscribe_PubSubCapablities((int) 23678L),
  PublishSubscribe_DataSetClasses((int) 23685L),
  SubscribedDataSetFolderType_SubscribedDataSetFolderName_Placeholder((int) 23796L),
  SubscribedDataSetFolderType_StandaloneSubscribedDataSetName_Placeholder((int) 23807L),
  SubscribedDataSetFolderType_StandaloneSubscribedDataSetName_Placeholder_SubscribedDataSet(
      (int) 23808L),
  StandaloneSubscribedDataSetType_SubscribedDataSet((int) 23829L),
  DatagramWriterGroupTransportType_Address((int) 23842L),
  StandaloneSubscribedDataSetRefDataType_Encoding_DefaultBinary((int) 23851L),
  StandaloneSubscribedDataSetDataType_Encoding_DefaultBinary((int) 23852L),
  SecurityGroupDataType_Encoding_DefaultBinary((int) 23853L),
  PubSubConfiguration2DataType_Encoding_DefaultBinary((int) 23854L),
  QosDataType_Encoding_DefaultBinary((int) 23855L),
  TransmitQosDataType_Encoding_DefaultBinary((int) 23856L),
  TransmitQosPriorityDataType_Encoding_DefaultBinary((int) 23857L),
  ReceiveQosDataType_Encoding_DefaultBinary((int) 23860L),
  ReceiveQosPriorityDataType_Encoding_DefaultBinary((int) 23861L),
  DatagramConnectionTransport2DataType_Encoding_DefaultBinary((int) 23864L),
  DatagramWriterGroupTransport2DataType_Encoding_DefaultBinary((int) 23865L),
  DatagramDataSetReaderTransportDataType_Encoding_DefaultBinary((int) 23866L),
  StandaloneSubscribedDataSetRefDataType_Encoding_DefaultXml((int) 23919L),
  StandaloneSubscribedDataSetDataType_Encoding_DefaultXml((int) 23920L),
  SecurityGroupDataType_Encoding_DefaultXml((int) 23921L),
  PubSubConfiguration2DataType_Encoding_DefaultXml((int) 23922L),
  QosDataType_Encoding_DefaultXml((int) 23923L),
  TransmitQosDataType_Encoding_DefaultXml((int) 23924L),
  TransmitQosPriorityDataType_Encoding_DefaultXml((int) 23925L),
  ReceiveQosDataType_Encoding_DefaultXml((int) 23928L),
  ReceiveQosPriorityDataType_Encoding_DefaultXml((int) 23929L),
  DatagramConnectionTransport2DataType_Encoding_DefaultXml((int) 23932L),
  DatagramWriterGroupTransport2DataType_Encoding_DefaultXml((int) 23933L),
  DatagramDataSetReaderTransportDataType_Encoding_DefaultXml((int) 23934L),
  StandaloneSubscribedDataSetRefDataType_Encoding_DefaultJson((int) 23987L),
  StandaloneSubscribedDataSetDataType_Encoding_DefaultJson((int) 23988L),
  SecurityGroupDataType_Encoding_DefaultJson((int) 23989L),
  PubSubConfiguration2DataType_Encoding_DefaultJson((int) 23990L),
  QosDataType_Encoding_DefaultJson((int) 23991L),
  TransmitQosDataType_Encoding_DefaultJson((int) 23992L),
  TransmitQosPriorityDataType_Encoding_DefaultJson((int) 23993L),
  ReceiveQosDataType_Encoding_DefaultJson((int) 23996L),
  ReceiveQosPriorityDataType_Encoding_DefaultJson((int) 23997L),
  DatagramConnectionTransport2DataType_Encoding_DefaultJson((int) 24000L),
  DatagramWriterGroupTransport2DataType_Encoding_DefaultJson((int) 24001L),
  DatagramDataSetReaderTransportDataType_Encoding_DefaultJson((int) 24002L),
  DatagramDataSetReaderTransportType_Address((int) 24017L),
  ProgramDiagnostic2DataType_Encoding_DefaultBinary((int) 24034L),
  ProgramDiagnostic2DataType_Encoding_DefaultXml((int) 24038L),
  ProgramDiagnostic2DataType_Encoding_DefaultJson((int) 24042L),
  PortableQualifiedName_Encoding_DefaultBinary((int) 24108L),
  PortableNodeId_Encoding_DefaultBinary((int) 24109L),
  UnsignedRationalNumber_Encoding_DefaultBinary((int) 24110L),
  PortableQualifiedName_Encoding_DefaultXml((int) 24120L),
  PortableNodeId_Encoding_DefaultXml((int) 24121L),
  UnsignedRationalNumber_Encoding_DefaultXml((int) 24122L),
  PortableQualifiedName_Encoding_DefaultJson((int) 24132L),
  PortableNodeId_Encoding_DefaultJson((int) 24133L),
  UnsignedRationalNumber_Encoding_DefaultJson((int) 24134L),
  Resources((int) 24226L),
  Communication((int) 24227L),
  MappingTables((int) 24228L),
  NetworkInterfaces((int) 24229L),
  Streams((int) 24230L),
  TalkerStreams((int) 24231L),
  ListenerStreams((int) 24232L),
  UserManagement((int) 24290L),
  UserManagementDataType_Encoding_DefaultBinary((int) 24292L),
  UserManagementDataType_Encoding_DefaultXml((int) 24296L),
  UserManagementDataType_Encoding_DefaultJson((int) 24300L),
  IetfBaseNetworkInterfaceType_InterfaceName_Placeholder((int) 25226L),
  PriorityMappingEntryType_Encoding_DefaultBinary((int) 25239L),
  PriorityMappingEntryType_Encoding_DefaultXml((int) 25243L),
  PriorityMappingEntryType_Encoding_DefaultJson((int) 25247L),
  PubSubKeyServiceType_KeyPushTargets((int) 25277L),
  PubSubKeyPushTargetFolderType_PushTargetFolderName_Placeholder((int) 25347L),
  PubSubKeyPushTargetFolderType_PushTargetName_Placeholder((int) 25358L),
  PublishSubscribeType_PubSubConfiguration((int) 25403L),
  PublishSubscribe_KeyPushTargets((int) 25440L),
  PublishSubscribe_PubSubConfiguration((int) 25451L),
  PublishedDataSetCustomSourceDataType_Encoding_DefaultBinary((int) 25529L),
  PubSubKeyPushTargetDataType_Encoding_DefaultBinary((int) 25530L),
  PubSubConfigurationRefDataType_Encoding_DefaultBinary((int) 25531L),
  PubSubConfigurationValueDataType_Encoding_DefaultBinary((int) 25532L),
  PublishedDataSetCustomSourceDataType_Encoding_DefaultXml((int) 25545L),
  PubSubKeyPushTargetDataType_Encoding_DefaultXml((int) 25546L),
  PubSubConfigurationRefDataType_Encoding_DefaultXml((int) 25547L),
  PubSubConfigurationValueDataType_Encoding_DefaultXml((int) 25548L),
  PublishedDataSetCustomSourceDataType_Encoding_DefaultJson((int) 25561L),
  PubSubKeyPushTargetDataType_Encoding_DefaultJson((int) 25562L),
  PubSubConfigurationRefDataType_Encoding_DefaultJson((int) 25563L),
  PubSubConfigurationValueDataType_Encoding_DefaultJson((int) 25564L),
  WellKnownRole_SecurityKeyServerAdmin((int) 25565L),
  WellKnownRole_SecurityKeyServerPush((int) 25584L),
  WellKnownRole_SecurityKeyServerAccess((int) 25603L),
  PubSubKeyPushTargetType_SecurityGroupName_Placeholder((int) 25626L),
  ProvisionableDeviceType_ApplicationName_Placeholder((int) 26878L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups((int) 26879L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup(
      (int) 26880L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup_TrustList(
      (int) 26881L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup_CertificateExpired(
      (int) 26921L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState(
      (int) 27008L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup(
      (int) 27052L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate(
      (int) 27087L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState(
      (int) 27174L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup(
      (int) 27218L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup(
      (int) 27252L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup_TrustList(
      (int) 27253L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup_CertificateExpired(
      (int) 27293L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState(
      (int) 27380L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup(
      (int) 27424L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate(
      (int) 27459L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState(
      (int) 27546L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup(
      (int) 27590L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup(
      (int) 27624L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup_TrustList(
      (int) 27625L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup_CertificateExpired(
      (int) 27665L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState(
      (int) 27752L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup(
      (int) 27796L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate(
      (int) 27831L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState(
      (int) 27918L),
  ProvisionableDeviceType_ApplicationName_Placeholder_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup(
      (int) 27962L),
  ProvisionableDevice((int) 29878L),
  Locations((int) 31915L),
  ServerConfigurationType_TransactionDiagnostics((int) 32299L),
  ServerConfiguration_TransactionDiagnostics((int) 32336L),
  ProvisionableDeviceType_ApplicationName_Placeholder_TransactionDiagnostics((int) 32362L),
  TransactionErrorType_Encoding_DefaultBinary((int) 32382L),
  TransactionErrorType_Encoding_DefaultXml((int) 32386L),
  TransactionErrorType_Encoding_DefaultJson((int) 32390L),
  BitFieldDefinition_Encoding_DefaultBinary((int) 32422L),
  BitFieldDefinition_Encoding_DefaultXml((int) 32426L),
  BitFieldDefinition_Encoding_DefaultJson((int) 32430L),
  ServerUnitType_AlternativeUnits((int) 32452L),
  ServerUnitType_CoherentUnit((int) 32462L),
  QuantityType_ServerUnits((int) 32481L),
  QuantityType_ServerUnits_ServerUnit_Placeholder((int) 32482L),
  QuantityType_ServerUnits_ServerUnit_Placeholder_AlternativeUnits((int) 32487L),
  QuantityType_ServerUnits_ServerUnit_Placeholder_CoherentUnit((int) 32497L),
  QuantitiesFolderType_Quantity_Placeholder((int) 32503L),
  QuantitiesFolderType_Quantity_Placeholder_ServerUnits((int) 32509L),
  Quantities((int) 32530L),
  AnnotationDataType_Encoding_DefaultBinary((int) 32560L),
  LinearConversionDataType_Encoding_DefaultBinary((int) 32561L),
  QuantityDimension_Encoding_DefaultBinary((int) 32562L),
  AnnotationDataType_Encoding_DefaultXml((int) 32572L),
  LinearConversionDataType_Encoding_DefaultXml((int) 32573L),
  QuantityDimension_Encoding_DefaultXml((int) 32574L),
  AnnotationDataType_Encoding_DefaultJson((int) 32584L),
  LinearConversionDataType_Encoding_DefaultJson((int) 32585L),
  QuantityDimension_Encoding_DefaultJson((int) 32586L),
  ServerUnitType_AlternativeUnits_AlternativeUnit_Placeholder((int) 32587L),
  HistoricalEventConfigurationType_EventTypes((int) 32622L),
  DefaultHAConfiguration((int) 32637L),
  DefaultHAConfiguration_AggregateConfiguration((int) 32638L),
  DefaultHAConfiguration_AggregateFunctions((int) 32643L),
  ReferenceDescriptionDataType_Encoding_DefaultBinary((int) 32661L),
  ReferenceListEntryDataType_Encoding_DefaultBinary((int) 32662L),
  ReferenceDescriptionDataType_Encoding_DefaultXml((int) 32669L),
  ReferenceListEntryDataType_Encoding_DefaultXml((int) 32670L),
  ReferenceDescriptionDataType_Encoding_DefaultJson((int) 32677L),
  ReferenceListEntryDataType_Encoding_DefaultJson((int) 32678L),
  DefaultHEConfiguration((int) 32754L),
  DefaultHEConfiguration_EventTypes((int) 32755L),
  ReadEventDetails2_Encoding_DefaultBinary((int) 32800L),
  ReadEventDetails2_Encoding_DefaultXml((int) 32801L),
  ReadEventDetails2_Encoding_DefaultJson((int) 32802L),
  HistoryModifiedEvent_Encoding_DefaultBinary((int) 32825L),
  HistoryModifiedEvent_Encoding_DefaultXml((int) 32829L),
  HistoryModifiedEvent_Encoding_DefaultJson((int) 32833L);
  private static final Map<Integer, OpcuaNodeIdServicesObject> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesObject value : OpcuaNodeIdServicesObject.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesObject(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesObject enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
