/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableBroker {
  BrokerTransportQualityOfService_EnumStrings((int) 15009L),
  BrokerConnectionTransportType_ResourceUri((int) 15156L),
  BrokerConnectionTransportType_AuthenticationProfileUri((int) 15178L),
  BrokerWriterGroupTransportType_ResourceUri((int) 15246L),
  BrokerWriterGroupTransportType_AuthenticationProfileUri((int) 15247L),
  BrokerWriterGroupTransportType_RequestedDeliveryGuarantee((int) 15249L),
  BrokerDataSetWriterTransportType_ResourceUri((int) 15250L),
  BrokerDataSetWriterTransportType_AuthenticationProfileUri((int) 15251L),
  BrokerDataSetWriterTransportType_RequestedDeliveryGuarantee((int) 15330L),
  BrokerDataSetReaderTransportType_ResourceUri((int) 15334L),
  BrokerDataSetReaderTransportType_AuthenticationProfileUri((int) 15419L),
  BrokerDataSetReaderTransportType_RequestedDeliveryGuarantee((int) 15420L),
  BrokerWriterGroupTransportType_QueueName((int) 21137L),
  BrokerDataSetWriterTransportType_QueueName((int) 21139L),
  BrokerDataSetWriterTransportType_MetaDataQueueName((int) 21140L),
  BrokerDataSetWriterTransportType_MetaDataUpdateTime((int) 21141L),
  BrokerDataSetReaderTransportType_QueueName((int) 21143L),
  BrokerDataSetReaderTransportType_MetaDataQueueName((int) 21144L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableBroker> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableBroker value : OpcuaNodeIdServicesVariableBroker.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableBroker(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableBroker enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
