/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableDefault {
  DefaultInstanceBrowseName((int) 17605L),
  DefaultHAConfiguration_AggregateConfiguration_TreatUncertainAsBad((int) 32639L),
  DefaultHAConfiguration_AggregateConfiguration_PercentDataBad((int) 32640L),
  DefaultHAConfiguration_AggregateConfiguration_PercentDataGood((int) 32641L),
  DefaultHAConfiguration_AggregateConfiguration_UseSlopedExtrapolation((int) 32642L),
  DefaultHAConfiguration_Stepped((int) 32644L),
  DefaultHAConfiguration_Definition((int) 32645L),
  DefaultHAConfiguration_MaxTimeInterval((int) 32646L),
  DefaultHAConfiguration_MinTimeInterval((int) 32647L),
  DefaultHAConfiguration_ExceptionDeviation((int) 32648L),
  DefaultHAConfiguration_ExceptionDeviationFormat((int) 32649L),
  DefaultHAConfiguration_StartOfArchive((int) 32650L),
  DefaultHAConfiguration_StartOfOnlineArchive((int) 32656L),
  DefaultHAConfiguration_ServerTimestampSupported((int) 32682L),
  DefaultHAConfiguration_MaxTimeStoredValues((int) 32752L),
  DefaultHAConfiguration_MaxCountStoredValues((int) 32753L),
  DefaultHEConfiguration_StartOfArchive((int) 32756L),
  DefaultHEConfiguration_StartOfOnlineArchive((int) 32757L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableDefault> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableDefault value : OpcuaNodeIdServicesVariableDefault.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableDefault(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableDefault enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
