/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableFinite {
  FiniteStateVariableType_Id((int) 2761L),
  FiniteTransitionVariableType_Id((int) 2768L),
  FiniteStateMachineType_CurrentState((int) 2772L),
  FiniteStateMachineType_LastTransition((int) 2773L),
  FiniteStateMachineType_CurrentState_Id((int) 3728L),
  FiniteStateMachineType_CurrentState_Name((int) 3729L),
  FiniteStateMachineType_CurrentState_Number((int) 3730L),
  FiniteStateMachineType_CurrentState_EffectiveDisplayName((int) 3731L),
  FiniteStateMachineType_LastTransition_Id((int) 3732L),
  FiniteStateMachineType_LastTransition_Name((int) 3733L),
  FiniteStateMachineType_LastTransition_Number((int) 3734L),
  FiniteStateMachineType_LastTransition_TransitionTime((int) 3735L),
  FiniteStateMachineType_LastTransition_EffectiveTransitionTime((int) 11459L),
  FiniteStateMachineType_AvailableStates((int) 17635L),
  FiniteStateMachineType_AvailableTransitions((int) 17636L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableFinite> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableFinite value : OpcuaNodeIdServicesVariableFinite.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableFinite(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableFinite enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
