/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableLimit {
  LimitAlarmType_HighHighLimit((int) 11124L),
  LimitAlarmType_HighLimit((int) 11125L),
  LimitAlarmType_LowLimit((int) 11126L),
  LimitAlarmType_LowLowLimit((int) 11127L),
  LimitAlarmType_BaseHighHighLimit((int) 16572L),
  LimitAlarmType_BaseHighLimit((int) 16573L),
  LimitAlarmType_BaseLowLimit((int) 16574L),
  LimitAlarmType_BaseLowLowLimit((int) 16575L),
  LimitAlarmType_SeverityHighHigh((int) 24770L),
  LimitAlarmType_SeverityHigh((int) 24771L),
  LimitAlarmType_SeverityLow((int) 24772L),
  LimitAlarmType_SeverityLowLow((int) 24773L),
  LimitAlarmType_HighHighDeadband((int) 24774L),
  LimitAlarmType_HighDeadband((int) 24775L),
  LimitAlarmType_LowDeadband((int) 24776L),
  LimitAlarmType_LowLowDeadband((int) 24777L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableLimit> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableLimit value : OpcuaNodeIdServicesVariableLimit.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableLimit(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableLimit enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
