/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableNon {
  NonTransparentRedundancyType_ServerUriArray((int) 2040L),
  NonExclusiveLimitAlarmType_ActiveState((int) 9963L),
  NonExclusiveLimitAlarmType_ActiveState_Id((int) 9964L),
  NonExclusiveLimitAlarmType_ActiveState_Name((int) 9965L),
  NonExclusiveLimitAlarmType_ActiveState_Number((int) 9966L),
  NonExclusiveLimitAlarmType_ActiveState_EffectiveDisplayName((int) 9967L),
  NonExclusiveLimitAlarmType_ActiveState_TransitionTime((int) 9968L),
  NonExclusiveLimitAlarmType_ActiveState_EffectiveTransitionTime((int) 9969L),
  NonExclusiveLimitAlarmType_ActiveState_TrueState((int) 9970L),
  NonExclusiveLimitAlarmType_ActiveState_FalseState((int) 9971L),
  NonExclusiveLimitAlarmType_HighHighState((int) 10020L),
  NonExclusiveLimitAlarmType_HighHighState_Id((int) 10021L),
  NonExclusiveLimitAlarmType_HighHighState_Name((int) 10022L),
  NonExclusiveLimitAlarmType_HighHighState_Number((int) 10023L),
  NonExclusiveLimitAlarmType_HighHighState_EffectiveDisplayName((int) 10024L),
  NonExclusiveLimitAlarmType_HighHighState_TransitionTime((int) 10025L),
  NonExclusiveLimitAlarmType_HighHighState_EffectiveTransitionTime((int) 10026L),
  NonExclusiveLimitAlarmType_HighHighState_TrueState((int) 10027L),
  NonExclusiveLimitAlarmType_HighHighState_FalseState((int) 10028L),
  NonExclusiveLimitAlarmType_HighState((int) 10029L),
  NonExclusiveLimitAlarmType_HighState_Id((int) 10030L),
  NonExclusiveLimitAlarmType_HighState_Name((int) 10031L),
  NonExclusiveLimitAlarmType_HighState_Number((int) 10032L),
  NonExclusiveLimitAlarmType_HighState_EffectiveDisplayName((int) 10033L),
  NonExclusiveLimitAlarmType_HighState_TransitionTime((int) 10034L),
  NonExclusiveLimitAlarmType_HighState_EffectiveTransitionTime((int) 10035L),
  NonExclusiveLimitAlarmType_HighState_TrueState((int) 10036L),
  NonExclusiveLimitAlarmType_HighState_FalseState((int) 10037L),
  NonExclusiveLimitAlarmType_LowState((int) 10038L),
  NonExclusiveLimitAlarmType_LowState_Id((int) 10039L),
  NonExclusiveLimitAlarmType_LowState_Name((int) 10040L),
  NonExclusiveLimitAlarmType_LowState_Number((int) 10041L),
  NonExclusiveLimitAlarmType_LowState_EffectiveDisplayName((int) 10042L),
  NonExclusiveLimitAlarmType_LowState_TransitionTime((int) 10043L),
  NonExclusiveLimitAlarmType_LowState_EffectiveTransitionTime((int) 10044L),
  NonExclusiveLimitAlarmType_LowState_TrueState((int) 10045L),
  NonExclusiveLimitAlarmType_LowState_FalseState((int) 10046L),
  NonExclusiveLimitAlarmType_LowLowState((int) 10047L),
  NonExclusiveLimitAlarmType_LowLowState_Id((int) 10048L),
  NonExclusiveLimitAlarmType_LowLowState_Name((int) 10049L),
  NonExclusiveLimitAlarmType_LowLowState_Number((int) 10050L),
  NonExclusiveLimitAlarmType_LowLowState_EffectiveDisplayName((int) 10051L),
  NonExclusiveLimitAlarmType_LowLowState_TransitionTime((int) 10052L),
  NonExclusiveLimitAlarmType_LowLowState_EffectiveTransitionTime((int) 10053L),
  NonExclusiveLimitAlarmType_LowLowState_TrueState((int) 10054L),
  NonExclusiveLimitAlarmType_LowLowState_FalseState((int) 10055L),
  NonExclusiveDeviationAlarmType_SetpointNode((int) 10522L),
  NonTransparentNetworkRedundancyType_ServerNetworkGroups((int) 11948L),
  NonExclusiveDeviationAlarmType_BaseSetpointNode((int) 16776L),
  NonExclusiveRateOfChangeAlarmType_EngineeringUnits((int) 16858L),
  NonTransparentBackupRedundancyType_RedundantServerArray((int) 32413L),
  NonTransparentBackupRedundancyType_Mode((int) 32415L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableNon> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableNon value : OpcuaNodeIdServicesVariableNon.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableNon(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableNon enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
