/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableOpc {
  OpcUa_BinarySchema((int) 7617L),
  OpcUa_BinarySchema_DataTypeVersion((int) 7618L),
  OpcUa_BinarySchema_NamespaceUri((int) 7619L),
  OpcUa_BinarySchema_Argument((int) 7650L),
  OpcUa_BinarySchema_Argument_DataTypeVersion((int) 7651L),
  OpcUa_BinarySchema_Argument_DictionaryFragment((int) 7652L),
  OpcUa_BinarySchema_EnumValueType((int) 7656L),
  OpcUa_BinarySchema_EnumValueType_DataTypeVersion((int) 7657L),
  OpcUa_BinarySchema_EnumValueType_DictionaryFragment((int) 7658L),
  OpcUa_BinarySchema_StatusResult((int) 7659L),
  OpcUa_BinarySchema_StatusResult_DataTypeVersion((int) 7660L),
  OpcUa_BinarySchema_StatusResult_DictionaryFragment((int) 7661L),
  OpcUa_BinarySchema_UserTokenPolicy((int) 7662L),
  OpcUa_BinarySchema_UserTokenPolicy_DataTypeVersion((int) 7663L),
  OpcUa_BinarySchema_UserTokenPolicy_DictionaryFragment((int) 7664L),
  OpcUa_BinarySchema_ApplicationDescription((int) 7665L),
  OpcUa_BinarySchema_ApplicationDescription_DataTypeVersion((int) 7666L),
  OpcUa_BinarySchema_ApplicationDescription_DictionaryFragment((int) 7667L),
  OpcUa_BinarySchema_EndpointDescription((int) 7668L),
  OpcUa_BinarySchema_EndpointDescription_DataTypeVersion((int) 7669L),
  OpcUa_BinarySchema_EndpointDescription_DictionaryFragment((int) 7670L),
  OpcUa_BinarySchema_UserIdentityToken((int) 7671L),
  OpcUa_BinarySchema_UserIdentityToken_DataTypeVersion((int) 7672L),
  OpcUa_BinarySchema_UserIdentityToken_DictionaryFragment((int) 7673L),
  OpcUa_BinarySchema_AnonymousIdentityToken((int) 7674L),
  OpcUa_BinarySchema_AnonymousIdentityToken_DataTypeVersion((int) 7675L),
  OpcUa_BinarySchema_AnonymousIdentityToken_DictionaryFragment((int) 7676L),
  OpcUa_BinarySchema_UserNameIdentityToken((int) 7677L),
  OpcUa_BinarySchema_UserNameIdentityToken_DataTypeVersion((int) 7678L),
  OpcUa_BinarySchema_UserNameIdentityToken_DictionaryFragment((int) 7679L),
  OpcUa_BinarySchema_X509IdentityToken((int) 7680L),
  OpcUa_BinarySchema_X509IdentityToken_DataTypeVersion((int) 7681L),
  OpcUa_BinarySchema_X509IdentityToken_DictionaryFragment((int) 7682L),
  OpcUa_BinarySchema_IssuedIdentityToken((int) 7683L),
  OpcUa_BinarySchema_IssuedIdentityToken_DataTypeVersion((int) 7684L),
  OpcUa_BinarySchema_IssuedIdentityToken_DictionaryFragment((int) 7685L),
  OpcUa_BinarySchema_EndpointConfiguration((int) 7686L),
  OpcUa_BinarySchema_EndpointConfiguration_DataTypeVersion((int) 7687L),
  OpcUa_BinarySchema_EndpointConfiguration_DictionaryFragment((int) 7688L),
  OpcUa_BinarySchema_BuildInfo((int) 7692L),
  OpcUa_BinarySchema_BuildInfo_DataTypeVersion((int) 7693L),
  OpcUa_BinarySchema_BuildInfo_DictionaryFragment((int) 7694L),
  OpcUa_BinarySchema_SignedSoftwareCertificate((int) 7698L),
  OpcUa_BinarySchema_SignedSoftwareCertificate_DataTypeVersion((int) 7699L),
  OpcUa_BinarySchema_SignedSoftwareCertificate_DictionaryFragment((int) 7700L),
  OpcUa_BinarySchema_AddNodesItem((int) 7728L),
  OpcUa_BinarySchema_AddNodesItem_DataTypeVersion((int) 7729L),
  OpcUa_BinarySchema_AddNodesItem_DictionaryFragment((int) 7730L),
  OpcUa_BinarySchema_AddReferencesItem((int) 7731L),
  OpcUa_BinarySchema_AddReferencesItem_DataTypeVersion((int) 7732L),
  OpcUa_BinarySchema_AddReferencesItem_DictionaryFragment((int) 7733L),
  OpcUa_BinarySchema_DeleteNodesItem((int) 7734L),
  OpcUa_BinarySchema_DeleteNodesItem_DataTypeVersion((int) 7735L),
  OpcUa_BinarySchema_DeleteNodesItem_DictionaryFragment((int) 7736L),
  OpcUa_BinarySchema_DeleteReferencesItem((int) 7737L),
  OpcUa_BinarySchema_DeleteReferencesItem_DataTypeVersion((int) 7738L),
  OpcUa_BinarySchema_DeleteReferencesItem_DictionaryFragment((int) 7739L),
  OpcUa_BinarySchema_RegisteredServer((int) 7782L),
  OpcUa_BinarySchema_RegisteredServer_DataTypeVersion((int) 7783L),
  OpcUa_BinarySchema_RegisteredServer_DictionaryFragment((int) 7784L),
  OpcUa_BinarySchema_ContentFilterElement((int) 7929L),
  OpcUa_BinarySchema_ContentFilterElement_DataTypeVersion((int) 7930L),
  OpcUa_BinarySchema_ContentFilterElement_DictionaryFragment((int) 7931L),
  OpcUa_BinarySchema_ContentFilter((int) 7932L),
  OpcUa_BinarySchema_ContentFilter_DataTypeVersion((int) 7933L),
  OpcUa_BinarySchema_ContentFilter_DictionaryFragment((int) 7934L),
  OpcUa_BinarySchema_FilterOperand((int) 7935L),
  OpcUa_BinarySchema_FilterOperand_DataTypeVersion((int) 7936L),
  OpcUa_BinarySchema_FilterOperand_DictionaryFragment((int) 7937L),
  OpcUa_BinarySchema_ElementOperand((int) 7938L),
  OpcUa_BinarySchema_ElementOperand_DataTypeVersion((int) 7939L),
  OpcUa_BinarySchema_ElementOperand_DictionaryFragment((int) 7940L),
  OpcUa_BinarySchema_LiteralOperand((int) 7941L),
  OpcUa_BinarySchema_LiteralOperand_DataTypeVersion((int) 7942L),
  OpcUa_BinarySchema_LiteralOperand_DictionaryFragment((int) 7943L),
  OpcUa_BinarySchema_AttributeOperand((int) 7944L),
  OpcUa_BinarySchema_AttributeOperand_DataTypeVersion((int) 7945L),
  OpcUa_BinarySchema_AttributeOperand_DictionaryFragment((int) 7946L),
  OpcUa_BinarySchema_SimpleAttributeOperand((int) 7947L),
  OpcUa_BinarySchema_SimpleAttributeOperand_DataTypeVersion((int) 7948L),
  OpcUa_BinarySchema_SimpleAttributeOperand_DictionaryFragment((int) 7949L),
  OpcUa_BinarySchema_HistoryEvent((int) 8004L),
  OpcUa_BinarySchema_HistoryEvent_DataTypeVersion((int) 8005L),
  OpcUa_BinarySchema_HistoryEvent_DictionaryFragment((int) 8006L),
  OpcUa_BinarySchema_MonitoringFilter((int) 8067L),
  OpcUa_BinarySchema_MonitoringFilter_DataTypeVersion((int) 8068L),
  OpcUa_BinarySchema_MonitoringFilter_DictionaryFragment((int) 8069L),
  OpcUa_BinarySchema_EventFilter((int) 8073L),
  OpcUa_BinarySchema_EventFilter_DataTypeVersion((int) 8074L),
  OpcUa_BinarySchema_EventFilter_DictionaryFragment((int) 8075L),
  OpcUa_BinarySchema_AggregateConfiguration((int) 8076L),
  OpcUa_BinarySchema_AggregateConfiguration_DataTypeVersion((int) 8077L),
  OpcUa_BinarySchema_AggregateConfiguration_DictionaryFragment((int) 8078L),
  OpcUa_BinarySchema_HistoryEventFieldList((int) 8172L),
  OpcUa_BinarySchema_HistoryEventFieldList_DataTypeVersion((int) 8173L),
  OpcUa_BinarySchema_HistoryEventFieldList_DictionaryFragment((int) 8174L),
  OpcUa_BinarySchema_RedundantServerDataType((int) 8208L),
  OpcUa_BinarySchema_RedundantServerDataType_DataTypeVersion((int) 8209L),
  OpcUa_BinarySchema_RedundantServerDataType_DictionaryFragment((int) 8210L),
  OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType((int) 8211L),
  OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion((int) 8212L),
  OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment((int) 8213L),
  OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType((int) 8214L),
  OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DataTypeVersion((int) 8215L),
  OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DictionaryFragment((int) 8216L),
  OpcUa_BinarySchema_ServerStatusDataType((int) 8217L),
  OpcUa_BinarySchema_ServerStatusDataType_DataTypeVersion((int) 8218L),
  OpcUa_BinarySchema_ServerStatusDataType_DictionaryFragment((int) 8219L),
  OpcUa_BinarySchema_SessionDiagnosticsDataType((int) 8220L),
  OpcUa_BinarySchema_SessionDiagnosticsDataType_DataTypeVersion((int) 8221L),
  OpcUa_BinarySchema_SessionDiagnosticsDataType_DictionaryFragment((int) 8222L),
  OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType((int) 8223L),
  OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DataTypeVersion((int) 8224L),
  OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DictionaryFragment((int) 8225L),
  OpcUa_BinarySchema_ServiceCounterDataType((int) 8226L),
  OpcUa_BinarySchema_ServiceCounterDataType_DataTypeVersion((int) 8227L),
  OpcUa_BinarySchema_ServiceCounterDataType_DictionaryFragment((int) 8228L),
  OpcUa_BinarySchema_SubscriptionDiagnosticsDataType((int) 8229L),
  OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DataTypeVersion((int) 8230L),
  OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DictionaryFragment((int) 8231L),
  OpcUa_BinarySchema_ModelChangeStructureDataType((int) 8232L),
  OpcUa_BinarySchema_ModelChangeStructureDataType_DataTypeVersion((int) 8233L),
  OpcUa_BinarySchema_ModelChangeStructureDataType_DictionaryFragment((int) 8234L),
  OpcUa_BinarySchema_SemanticChangeStructureDataType((int) 8235L),
  OpcUa_BinarySchema_SemanticChangeStructureDataType_DataTypeVersion((int) 8236L),
  OpcUa_BinarySchema_SemanticChangeStructureDataType_DictionaryFragment((int) 8237L),
  OpcUa_BinarySchema_Range((int) 8238L),
  OpcUa_BinarySchema_Range_DataTypeVersion((int) 8239L),
  OpcUa_BinarySchema_Range_DictionaryFragment((int) 8240L),
  OpcUa_BinarySchema_EUInformation((int) 8241L),
  OpcUa_BinarySchema_EUInformation_DataTypeVersion((int) 8242L),
  OpcUa_BinarySchema_EUInformation_DictionaryFragment((int) 8243L),
  OpcUa_BinarySchema_Annotation((int) 8244L),
  OpcUa_BinarySchema_Annotation_DataTypeVersion((int) 8245L),
  OpcUa_BinarySchema_Annotation_DictionaryFragment((int) 8246L),
  OpcUa_BinarySchema_ProgramDiagnosticDataType((int) 8247L),
  OpcUa_BinarySchema_ProgramDiagnosticDataType_DataTypeVersion((int) 8248L),
  OpcUa_BinarySchema_ProgramDiagnosticDataType_DictionaryFragment((int) 8249L),
  OpcUa_XmlSchema((int) 8252L),
  OpcUa_XmlSchema_DataTypeVersion((int) 8253L),
  OpcUa_XmlSchema_NamespaceUri((int) 8254L),
  OpcUa_XmlSchema_Argument((int) 8285L),
  OpcUa_XmlSchema_Argument_DataTypeVersion((int) 8286L),
  OpcUa_XmlSchema_Argument_DictionaryFragment((int) 8287L),
  OpcUa_XmlSchema_EnumValueType((int) 8291L),
  OpcUa_XmlSchema_EnumValueType_DataTypeVersion((int) 8292L),
  OpcUa_XmlSchema_EnumValueType_DictionaryFragment((int) 8293L),
  OpcUa_XmlSchema_StatusResult((int) 8294L),
  OpcUa_XmlSchema_StatusResult_DataTypeVersion((int) 8295L),
  OpcUa_XmlSchema_StatusResult_DictionaryFragment((int) 8296L),
  OpcUa_XmlSchema_UserTokenPolicy((int) 8297L),
  OpcUa_XmlSchema_UserTokenPolicy_DataTypeVersion((int) 8298L),
  OpcUa_XmlSchema_UserTokenPolicy_DictionaryFragment((int) 8299L),
  OpcUa_XmlSchema_ApplicationDescription((int) 8300L),
  OpcUa_XmlSchema_ApplicationDescription_DataTypeVersion((int) 8301L),
  OpcUa_XmlSchema_ApplicationDescription_DictionaryFragment((int) 8302L),
  OpcUa_XmlSchema_EndpointDescription((int) 8303L),
  OpcUa_XmlSchema_EndpointDescription_DataTypeVersion((int) 8304L),
  OpcUa_XmlSchema_EndpointDescription_DictionaryFragment((int) 8305L),
  OpcUa_XmlSchema_UserIdentityToken((int) 8306L),
  OpcUa_XmlSchema_UserIdentityToken_DataTypeVersion((int) 8307L),
  OpcUa_XmlSchema_UserIdentityToken_DictionaryFragment((int) 8308L),
  OpcUa_XmlSchema_AnonymousIdentityToken((int) 8309L),
  OpcUa_XmlSchema_AnonymousIdentityToken_DataTypeVersion((int) 8310L),
  OpcUa_XmlSchema_AnonymousIdentityToken_DictionaryFragment((int) 8311L),
  OpcUa_XmlSchema_UserNameIdentityToken((int) 8312L),
  OpcUa_XmlSchema_UserNameIdentityToken_DataTypeVersion((int) 8313L),
  OpcUa_XmlSchema_UserNameIdentityToken_DictionaryFragment((int) 8314L),
  OpcUa_XmlSchema_X509IdentityToken((int) 8315L),
  OpcUa_XmlSchema_X509IdentityToken_DataTypeVersion((int) 8316L),
  OpcUa_XmlSchema_X509IdentityToken_DictionaryFragment((int) 8317L),
  OpcUa_XmlSchema_IssuedIdentityToken((int) 8318L),
  OpcUa_XmlSchema_IssuedIdentityToken_DataTypeVersion((int) 8319L),
  OpcUa_XmlSchema_IssuedIdentityToken_DictionaryFragment((int) 8320L),
  OpcUa_XmlSchema_EndpointConfiguration((int) 8321L),
  OpcUa_XmlSchema_EndpointConfiguration_DataTypeVersion((int) 8322L),
  OpcUa_XmlSchema_EndpointConfiguration_DictionaryFragment((int) 8323L),
  OpcUa_XmlSchema_BuildInfo((int) 8327L),
  OpcUa_XmlSchema_BuildInfo_DataTypeVersion((int) 8328L),
  OpcUa_XmlSchema_BuildInfo_DictionaryFragment((int) 8329L),
  OpcUa_XmlSchema_SignedSoftwareCertificate((int) 8333L),
  OpcUa_XmlSchema_SignedSoftwareCertificate_DataTypeVersion((int) 8334L),
  OpcUa_XmlSchema_SignedSoftwareCertificate_DictionaryFragment((int) 8335L),
  OpcUa_XmlSchema_AddNodesItem((int) 8363L),
  OpcUa_XmlSchema_AddNodesItem_DataTypeVersion((int) 8364L),
  OpcUa_XmlSchema_AddNodesItem_DictionaryFragment((int) 8365L),
  OpcUa_XmlSchema_AddReferencesItem((int) 8366L),
  OpcUa_XmlSchema_AddReferencesItem_DataTypeVersion((int) 8367L),
  OpcUa_XmlSchema_AddReferencesItem_DictionaryFragment((int) 8368L),
  OpcUa_XmlSchema_DeleteNodesItem((int) 8369L),
  OpcUa_XmlSchema_DeleteNodesItem_DataTypeVersion((int) 8370L),
  OpcUa_XmlSchema_DeleteNodesItem_DictionaryFragment((int) 8371L),
  OpcUa_XmlSchema_DeleteReferencesItem((int) 8372L),
  OpcUa_XmlSchema_DeleteReferencesItem_DataTypeVersion((int) 8373L),
  OpcUa_XmlSchema_DeleteReferencesItem_DictionaryFragment((int) 8374L),
  OpcUa_XmlSchema_RegisteredServer((int) 8417L),
  OpcUa_XmlSchema_RegisteredServer_DataTypeVersion((int) 8418L),
  OpcUa_XmlSchema_RegisteredServer_DictionaryFragment((int) 8419L),
  OpcUa_XmlSchema_ContentFilterElement((int) 8564L),
  OpcUa_XmlSchema_ContentFilterElement_DataTypeVersion((int) 8565L),
  OpcUa_XmlSchema_ContentFilterElement_DictionaryFragment((int) 8566L),
  OpcUa_XmlSchema_ContentFilter((int) 8567L),
  OpcUa_XmlSchema_ContentFilter_DataTypeVersion((int) 8568L),
  OpcUa_XmlSchema_ContentFilter_DictionaryFragment((int) 8569L),
  OpcUa_XmlSchema_FilterOperand((int) 8570L),
  OpcUa_XmlSchema_FilterOperand_DataTypeVersion((int) 8571L),
  OpcUa_XmlSchema_FilterOperand_DictionaryFragment((int) 8572L),
  OpcUa_XmlSchema_ElementOperand((int) 8573L),
  OpcUa_XmlSchema_ElementOperand_DataTypeVersion((int) 8574L),
  OpcUa_XmlSchema_ElementOperand_DictionaryFragment((int) 8575L),
  OpcUa_XmlSchema_LiteralOperand((int) 8576L),
  OpcUa_XmlSchema_LiteralOperand_DataTypeVersion((int) 8577L),
  OpcUa_XmlSchema_LiteralOperand_DictionaryFragment((int) 8578L),
  OpcUa_XmlSchema_AttributeOperand((int) 8579L),
  OpcUa_XmlSchema_AttributeOperand_DataTypeVersion((int) 8580L),
  OpcUa_XmlSchema_AttributeOperand_DictionaryFragment((int) 8581L),
  OpcUa_XmlSchema_SimpleAttributeOperand((int) 8582L),
  OpcUa_XmlSchema_SimpleAttributeOperand_DataTypeVersion((int) 8583L),
  OpcUa_XmlSchema_SimpleAttributeOperand_DictionaryFragment((int) 8584L),
  OpcUa_XmlSchema_HistoryEvent((int) 8639L),
  OpcUa_XmlSchema_HistoryEvent_DataTypeVersion((int) 8640L),
  OpcUa_XmlSchema_HistoryEvent_DictionaryFragment((int) 8641L),
  OpcUa_XmlSchema_MonitoringFilter((int) 8702L),
  OpcUa_XmlSchema_MonitoringFilter_DataTypeVersion((int) 8703L),
  OpcUa_XmlSchema_MonitoringFilter_DictionaryFragment((int) 8704L),
  OpcUa_XmlSchema_EventFilter((int) 8708L),
  OpcUa_XmlSchema_EventFilter_DataTypeVersion((int) 8709L),
  OpcUa_XmlSchema_EventFilter_DictionaryFragment((int) 8710L),
  OpcUa_XmlSchema_AggregateConfiguration((int) 8711L),
  OpcUa_XmlSchema_AggregateConfiguration_DataTypeVersion((int) 8712L),
  OpcUa_XmlSchema_AggregateConfiguration_DictionaryFragment((int) 8713L),
  OpcUa_XmlSchema_HistoryEventFieldList((int) 8807L),
  OpcUa_XmlSchema_HistoryEventFieldList_DataTypeVersion((int) 8808L),
  OpcUa_XmlSchema_HistoryEventFieldList_DictionaryFragment((int) 8809L),
  OpcUa_XmlSchema_RedundantServerDataType((int) 8843L),
  OpcUa_XmlSchema_RedundantServerDataType_DataTypeVersion((int) 8844L),
  OpcUa_XmlSchema_RedundantServerDataType_DictionaryFragment((int) 8845L),
  OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType((int) 8846L),
  OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion((int) 8847L),
  OpcUa_XmlSchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment((int) 8848L),
  OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType((int) 8849L),
  OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType_DataTypeVersion((int) 8850L),
  OpcUa_XmlSchema_ServerDiagnosticsSummaryDataType_DictionaryFragment((int) 8851L),
  OpcUa_XmlSchema_ServerStatusDataType((int) 8852L),
  OpcUa_XmlSchema_ServerStatusDataType_DataTypeVersion((int) 8853L),
  OpcUa_XmlSchema_ServerStatusDataType_DictionaryFragment((int) 8854L),
  OpcUa_XmlSchema_SessionDiagnosticsDataType((int) 8855L),
  OpcUa_XmlSchema_SessionDiagnosticsDataType_DataTypeVersion((int) 8856L),
  OpcUa_XmlSchema_SessionDiagnosticsDataType_DictionaryFragment((int) 8857L),
  OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType((int) 8858L),
  OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType_DataTypeVersion((int) 8859L),
  OpcUa_XmlSchema_SessionSecurityDiagnosticsDataType_DictionaryFragment((int) 8860L),
  OpcUa_XmlSchema_ServiceCounterDataType((int) 8861L),
  OpcUa_XmlSchema_ServiceCounterDataType_DataTypeVersion((int) 8862L),
  OpcUa_XmlSchema_ServiceCounterDataType_DictionaryFragment((int) 8863L),
  OpcUa_XmlSchema_SubscriptionDiagnosticsDataType((int) 8864L),
  OpcUa_XmlSchema_SubscriptionDiagnosticsDataType_DataTypeVersion((int) 8865L),
  OpcUa_XmlSchema_SubscriptionDiagnosticsDataType_DictionaryFragment((int) 8866L),
  OpcUa_XmlSchema_ModelChangeStructureDataType((int) 8867L),
  OpcUa_XmlSchema_ModelChangeStructureDataType_DataTypeVersion((int) 8868L),
  OpcUa_XmlSchema_ModelChangeStructureDataType_DictionaryFragment((int) 8869L),
  OpcUa_XmlSchema_SemanticChangeStructureDataType((int) 8870L),
  OpcUa_XmlSchema_SemanticChangeStructureDataType_DataTypeVersion((int) 8871L),
  OpcUa_XmlSchema_SemanticChangeStructureDataType_DictionaryFragment((int) 8872L),
  OpcUa_XmlSchema_Range((int) 8873L),
  OpcUa_XmlSchema_Range_DataTypeVersion((int) 8874L),
  OpcUa_XmlSchema_Range_DictionaryFragment((int) 8875L),
  OpcUa_XmlSchema_EUInformation((int) 8876L),
  OpcUa_XmlSchema_EUInformation_DataTypeVersion((int) 8877L),
  OpcUa_XmlSchema_EUInformation_DictionaryFragment((int) 8878L),
  OpcUa_XmlSchema_Annotation((int) 8879L),
  OpcUa_XmlSchema_Annotation_DataTypeVersion((int) 8880L),
  OpcUa_XmlSchema_Annotation_DictionaryFragment((int) 8881L),
  OpcUa_XmlSchema_ProgramDiagnosticDataType((int) 8882L),
  OpcUa_XmlSchema_ProgramDiagnosticDataType_DataTypeVersion((int) 8883L),
  OpcUa_XmlSchema_ProgramDiagnosticDataType_DictionaryFragment((int) 8884L),
  OpcUa_BinarySchema_TimeZoneDataType((int) 8914L),
  OpcUa_BinarySchema_TimeZoneDataType_DataTypeVersion((int) 8915L),
  OpcUa_BinarySchema_TimeZoneDataType_DictionaryFragment((int) 8916L),
  OpcUa_XmlSchema_TimeZoneDataType((int) 8918L),
  OpcUa_XmlSchema_TimeZoneDataType_DataTypeVersion((int) 8919L),
  OpcUa_XmlSchema_TimeZoneDataType_DictionaryFragment((int) 8920L),
  OpcUa_XmlSchema_EndpointUrlListDataType((int) 11951L),
  OpcUa_XmlSchema_EndpointUrlListDataType_DataTypeVersion((int) 11952L),
  OpcUa_XmlSchema_EndpointUrlListDataType_DictionaryFragment((int) 11953L),
  OpcUa_XmlSchema_NetworkGroupDataType((int) 11954L),
  OpcUa_XmlSchema_NetworkGroupDataType_DataTypeVersion((int) 11955L),
  OpcUa_XmlSchema_NetworkGroupDataType_DictionaryFragment((int) 11956L),
  OpcUa_BinarySchema_EndpointUrlListDataType((int) 11959L),
  OpcUa_BinarySchema_EndpointUrlListDataType_DataTypeVersion((int) 11960L),
  OpcUa_BinarySchema_EndpointUrlListDataType_DictionaryFragment((int) 11961L),
  OpcUa_BinarySchema_NetworkGroupDataType((int) 11962L),
  OpcUa_BinarySchema_NetworkGroupDataType_DataTypeVersion((int) 11963L),
  OpcUa_BinarySchema_NetworkGroupDataType_DictionaryFragment((int) 11964L),
  OpcUa_XmlSchema_AxisInformation((int) 12083L),
  OpcUa_XmlSchema_AxisInformation_DataTypeVersion((int) 12084L),
  OpcUa_XmlSchema_AxisInformation_DictionaryFragment((int) 12085L),
  OpcUa_XmlSchema_XVType((int) 12086L),
  OpcUa_XmlSchema_XVType_DataTypeVersion((int) 12087L),
  OpcUa_XmlSchema_XVType_DictionaryFragment((int) 12088L),
  OpcUa_BinarySchema_AxisInformation((int) 12091L),
  OpcUa_BinarySchema_AxisInformation_DataTypeVersion((int) 12092L),
  OpcUa_BinarySchema_AxisInformation_DictionaryFragment((int) 12093L),
  OpcUa_BinarySchema_XVType((int) 12094L),
  OpcUa_BinarySchema_XVType_DataTypeVersion((int) 12095L),
  OpcUa_BinarySchema_XVType_DictionaryFragment((int) 12096L),
  OpcUa_XmlSchema_ComplexNumberType((int) 12175L),
  OpcUa_XmlSchema_ComplexNumberType_DataTypeVersion((int) 12176L),
  OpcUa_XmlSchema_ComplexNumberType_DictionaryFragment((int) 12177L),
  OpcUa_XmlSchema_DoubleComplexNumberType((int) 12178L),
  OpcUa_XmlSchema_DoubleComplexNumberType_DataTypeVersion((int) 12179L),
  OpcUa_XmlSchema_DoubleComplexNumberType_DictionaryFragment((int) 12180L),
  OpcUa_BinarySchema_ComplexNumberType((int) 12183L),
  OpcUa_BinarySchema_ComplexNumberType_DataTypeVersion((int) 12184L),
  OpcUa_BinarySchema_ComplexNumberType_DictionaryFragment((int) 12185L),
  OpcUa_BinarySchema_DoubleComplexNumberType((int) 12186L),
  OpcUa_BinarySchema_DoubleComplexNumberType_DataTypeVersion((int) 12187L),
  OpcUa_BinarySchema_DoubleComplexNumberType_DictionaryFragment((int) 12188L),
  OpcUa_XmlSchema_ServerOnNetwork((int) 12201L),
  OpcUa_XmlSchema_ServerOnNetwork_DataTypeVersion((int) 12202L),
  OpcUa_XmlSchema_ServerOnNetwork_DictionaryFragment((int) 12203L),
  OpcUa_BinarySchema_ServerOnNetwork((int) 12213L),
  OpcUa_BinarySchema_ServerOnNetwork_DataTypeVersion((int) 12214L),
  OpcUa_BinarySchema_ServerOnNetwork_DictionaryFragment((int) 12215L),
  OpcUa_XmlSchema_TrustListDataType((int) 12677L),
  OpcUa_XmlSchema_TrustListDataType_DataTypeVersion((int) 12678L),
  OpcUa_XmlSchema_TrustListDataType_DictionaryFragment((int) 12679L),
  OpcUa_BinarySchema_TrustListDataType((int) 12681L),
  OpcUa_BinarySchema_TrustListDataType_DataTypeVersion((int) 12682L),
  OpcUa_BinarySchema_TrustListDataType_DictionaryFragment((int) 12683L),
  OpcUa_XmlSchema_RelativePathElement((int) 12712L),
  OpcUa_XmlSchema_RelativePathElement_DataTypeVersion((int) 12713L),
  OpcUa_XmlSchema_RelativePathElement_DictionaryFragment((int) 12714L),
  OpcUa_XmlSchema_RelativePath((int) 12715L),
  OpcUa_XmlSchema_RelativePath_DataTypeVersion((int) 12716L),
  OpcUa_XmlSchema_RelativePath_DictionaryFragment((int) 12717L),
  OpcUa_BinarySchema_RelativePathElement((int) 12718L),
  OpcUa_BinarySchema_RelativePathElement_DataTypeVersion((int) 12719L),
  OpcUa_BinarySchema_RelativePathElement_DictionaryFragment((int) 12720L),
  OpcUa_BinarySchema_RelativePath((int) 12721L),
  OpcUa_BinarySchema_RelativePath_DataTypeVersion((int) 12722L),
  OpcUa_BinarySchema_RelativePath_DictionaryFragment((int) 12723L),
  OpcUa_XmlSchema_OptionSet((int) 12759L),
  OpcUa_XmlSchema_OptionSet_DataTypeVersion((int) 12760L),
  OpcUa_XmlSchema_OptionSet_DictionaryFragment((int) 12761L),
  OpcUa_XmlSchema_Union((int) 12762L),
  OpcUa_XmlSchema_Union_DataTypeVersion((int) 12763L),
  OpcUa_XmlSchema_Union_DictionaryFragment((int) 12764L),
  OpcUa_BinarySchema_OptionSet((int) 12767L),
  OpcUa_BinarySchema_OptionSet_DataTypeVersion((int) 12768L),
  OpcUa_BinarySchema_OptionSet_DictionaryFragment((int) 12769L),
  OpcUa_BinarySchema_Union((int) 12770L),
  OpcUa_BinarySchema_Union_DataTypeVersion((int) 12771L),
  OpcUa_BinarySchema_Union_DictionaryFragment((int) 12772L),
  OpcUa_XmlSchema_DiscoveryConfiguration((int) 12894L),
  OpcUa_XmlSchema_DiscoveryConfiguration_DataTypeVersion((int) 12895L),
  OpcUa_XmlSchema_DiscoveryConfiguration_DictionaryFragment((int) 12896L),
  OpcUa_XmlSchema_MdnsDiscoveryConfiguration((int) 12897L),
  OpcUa_XmlSchema_MdnsDiscoveryConfiguration_DataTypeVersion((int) 12898L),
  OpcUa_XmlSchema_MdnsDiscoveryConfiguration_DictionaryFragment((int) 12899L),
  OpcUa_BinarySchema_DiscoveryConfiguration((int) 12902L),
  OpcUa_BinarySchema_DiscoveryConfiguration_DataTypeVersion((int) 12903L),
  OpcUa_BinarySchema_DiscoveryConfiguration_DictionaryFragment((int) 12904L),
  OpcUa_BinarySchema_MdnsDiscoveryConfiguration((int) 12905L),
  OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DataTypeVersion((int) 12906L),
  OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DictionaryFragment((int) 12907L),
  OpcUa_XmlSchema_PublishedVariableDataType((int) 14320L),
  OpcUa_XmlSchema_PublishedVariableDataType_DataTypeVersion((int) 14321L),
  OpcUa_XmlSchema_PublishedVariableDataType_DictionaryFragment((int) 14322L),
  OpcUa_BinarySchema_PublishedVariableDataType((int) 14324L),
  OpcUa_BinarySchema_PublishedVariableDataType_DataTypeVersion((int) 14325L),
  OpcUa_BinarySchema_PublishedVariableDataType_DictionaryFragment((int) 14326L),
  OpcUa_XmlSchema_DataSetMetaDataType((int) 14805L),
  OpcUa_XmlSchema_DataSetMetaDataType_DataTypeVersion((int) 14806L),
  OpcUa_XmlSchema_DataSetMetaDataType_DictionaryFragment((int) 14807L),
  OpcUa_XmlSchema_FieldMetaData((int) 14808L),
  OpcUa_XmlSchema_FieldMetaData_DataTypeVersion((int) 14809L),
  OpcUa_XmlSchema_FieldMetaData_DictionaryFragment((int) 14810L),
  OpcUa_XmlSchema_DataTypeDescription((int) 14811L),
  OpcUa_XmlSchema_DataTypeDescription_DataTypeVersion((int) 14812L),
  OpcUa_XmlSchema_DataTypeDescription_DictionaryFragment((int) 14813L),
  OpcUa_XmlSchema_EnumField((int) 14826L),
  OpcUa_XmlSchema_EnumField_DataTypeVersion((int) 14827L),
  OpcUa_XmlSchema_EnumField_DictionaryFragment((int) 14828L),
  OpcUa_XmlSchema_KeyValuePair((int) 14829L),
  OpcUa_XmlSchema_KeyValuePair_DataTypeVersion((int) 14830L),
  OpcUa_XmlSchema_KeyValuePair_DictionaryFragment((int) 14831L),
  OpcUa_XmlSchema_ConfigurationVersionDataType((int) 14832L),
  OpcUa_XmlSchema_ConfigurationVersionDataType_DataTypeVersion((int) 14833L),
  OpcUa_XmlSchema_ConfigurationVersionDataType_DictionaryFragment((int) 14834L),
  OpcUa_XmlSchema_FieldTargetDataType((int) 14835L),
  OpcUa_XmlSchema_FieldTargetDataType_DataTypeVersion((int) 14836L),
  OpcUa_XmlSchema_FieldTargetDataType_DictionaryFragment((int) 14837L),
  OpcUa_BinarySchema_DataSetMetaDataType((int) 14849L),
  OpcUa_BinarySchema_DataSetMetaDataType_DataTypeVersion((int) 14850L),
  OpcUa_BinarySchema_DataSetMetaDataType_DictionaryFragment((int) 14851L),
  OpcUa_BinarySchema_FieldMetaData((int) 14852L),
  OpcUa_BinarySchema_FieldMetaData_DataTypeVersion((int) 14853L),
  OpcUa_BinarySchema_FieldMetaData_DictionaryFragment((int) 14854L),
  OpcUa_BinarySchema_DataTypeDescription((int) 14855L),
  OpcUa_BinarySchema_DataTypeDescription_DataTypeVersion((int) 14856L),
  OpcUa_BinarySchema_DataTypeDescription_DictionaryFragment((int) 14857L),
  OpcUa_BinarySchema_EnumField((int) 14870L),
  OpcUa_BinarySchema_EnumField_DataTypeVersion((int) 14871L),
  OpcUa_BinarySchema_EnumField_DictionaryFragment((int) 14872L),
  OpcUa_BinarySchema_KeyValuePair((int) 14873L),
  OpcUa_BinarySchema_KeyValuePair_DataTypeVersion((int) 14874L),
  OpcUa_BinarySchema_KeyValuePair_DictionaryFragment((int) 14875L),
  OpcUa_BinarySchema_ConfigurationVersionDataType((int) 14876L),
  OpcUa_BinarySchema_ConfigurationVersionDataType_DataTypeVersion((int) 14877L),
  OpcUa_BinarySchema_ConfigurationVersionDataType_DictionaryFragment((int) 14878L),
  OpcUa_BinarySchema_FieldTargetDataType_DataTypeVersion((int) 14880L),
  OpcUa_BinarySchema_FieldTargetDataType_DictionaryFragment((int) 14881L),
  OpcUa_BinarySchema_ModificationInfo((int) 15018L),
  OpcUa_BinarySchema_ModificationInfo_DataTypeVersion((int) 15019L),
  OpcUa_BinarySchema_ModificationInfo_DictionaryFragment((int) 15020L),
  OpcUa_XmlSchema_ModificationInfo((int) 15021L),
  OpcUa_XmlSchema_ModificationInfo_DataTypeVersion((int) 15022L),
  OpcUa_XmlSchema_ModificationInfo_DictionaryFragment((int) 15023L),
  OpcUa_BinarySchema_Deprecated((int) 15037L),
  OpcUa_XmlSchema_Deprecated((int) 15039L),
  OpcUa_BinarySchema_SimpleTypeDescription((int) 15501L),
  OpcUa_BinarySchema_SimpleTypeDescription_DataTypeVersion((int) 15509L),
  OpcUa_BinarySchema_SimpleTypeDescription_DictionaryFragment((int) 15519L),
  OpcUa_BinarySchema_UABinaryFileDataType((int) 15521L),
  OpcUa_BinarySchema_UABinaryFileDataType_DataTypeVersion((int) 15522L),
  OpcUa_BinarySchema_UABinaryFileDataType_DictionaryFragment((int) 15523L),
  OpcUa_BinarySchema_BrokerConnectionTransportDataType((int) 15524L),
  OpcUa_BinarySchema_BrokerConnectionTransportDataType_DataTypeVersion((int) 15525L),
  OpcUa_BinarySchema_BrokerConnectionTransportDataType_DictionaryFragment((int) 15526L),
  OpcUa_XmlSchema_SimpleTypeDescription((int) 15585L),
  OpcUa_XmlSchema_SimpleTypeDescription_DataTypeVersion((int) 15586L),
  OpcUa_XmlSchema_SimpleTypeDescription_DictionaryFragment((int) 15587L),
  OpcUa_XmlSchema_UABinaryFileDataType((int) 15588L),
  OpcUa_XmlSchema_StructureDescription((int) 15591L),
  OpcUa_XmlSchema_StructureDescription_DataTypeVersion((int) 15592L),
  OpcUa_XmlSchema_StructureDescription_DictionaryFragment((int) 15593L),
  OpcUa_XmlSchema_EnumDescription((int) 15594L),
  OpcUa_XmlSchema_EnumDescription_DataTypeVersion((int) 15595L),
  OpcUa_XmlSchema_EnumDescription_DictionaryFragment((int) 15596L),
  OpcUa_BinarySchema_StructureDescription((int) 15599L),
  OpcUa_BinarySchema_StructureDescription_DataTypeVersion((int) 15600L),
  OpcUa_BinarySchema_StructureDescription_DictionaryFragment((int) 15601L),
  OpcUa_BinarySchema_EnumDescription((int) 15602L),
  OpcUa_BinarySchema_EnumDescription_DataTypeVersion((int) 15603L),
  OpcUa_BinarySchema_EnumDescription_DictionaryFragment((int) 15604L),
  OpcUa_XmlSchema_UABinaryFileDataType_DataTypeVersion((int) 15610L),
  OpcUa_XmlSchema_UABinaryFileDataType_DictionaryFragment((int) 15619L),
  OpcUa_XmlSchema_BrokerConnectionTransportDataType((int) 15640L),
  OpcUa_XmlSchema_BrokerConnectionTransportDataType_DataTypeVersion((int) 15666L),
  OpcUa_XmlSchema_BrokerConnectionTransportDataType_DictionaryFragment((int) 15690L),
  OpcUa_XmlSchema_IdentityMappingRuleType((int) 15730L),
  OpcUa_XmlSchema_IdentityMappingRuleType_DataTypeVersion((int) 15731L),
  OpcUa_XmlSchema_IdentityMappingRuleType_DictionaryFragment((int) 15732L),
  OpcUa_BinarySchema_EndpointType((int) 15734L),
  OpcUa_BinarySchema_EndpointType_DataTypeVersion((int) 15735L),
  OpcUa_BinarySchema_EndpointType_DictionaryFragment((int) 15737L),
  OpcUa_BinarySchema_IdentityMappingRuleType((int) 15738L),
  OpcUa_BinarySchema_IdentityMappingRuleType_DataTypeVersion((int) 15739L),
  OpcUa_BinarySchema_IdentityMappingRuleType_DictionaryFragment((int) 15740L),
  OpcUa_BinarySchema_DataTypeSchemaHeader((int) 15741L),
  OpcUa_BinarySchema_DataTypeSchemaHeader_DataTypeVersion((int) 15742L),
  OpcUa_BinarySchema_DataTypeSchemaHeader_DictionaryFragment((int) 15743L),
  OpcUa_BinarySchema_PublishedDataSetDataType((int) 15766L),
  OpcUa_BinarySchema_PublishedDataSetDataType_DataTypeVersion((int) 15767L),
  OpcUa_BinarySchema_PublishedDataSetDataType_DictionaryFragment((int) 15768L),
  OpcUa_BinarySchema_PublishedDataSetSourceDataType((int) 15769L),
  OpcUa_BinarySchema_PublishedDataSetSourceDataType_DataTypeVersion((int) 15770L),
  OpcUa_BinarySchema_PublishedDataSetSourceDataType_DictionaryFragment((int) 15771L),
  OpcUa_BinarySchema_PublishedDataItemsDataType((int) 15772L),
  OpcUa_BinarySchema_PublishedDataItemsDataType_DataTypeVersion((int) 15773L),
  OpcUa_BinarySchema_PublishedDataItemsDataType_DictionaryFragment((int) 15774L),
  OpcUa_BinarySchema_PublishedEventsDataType((int) 15775L),
  OpcUa_BinarySchema_PublishedEventsDataType_DataTypeVersion((int) 15776L),
  OpcUa_BinarySchema_PublishedEventsDataType_DictionaryFragment((int) 15777L),
  OpcUa_BinarySchema_DataSetWriterDataType((int) 15778L),
  OpcUa_BinarySchema_DataSetWriterDataType_DataTypeVersion((int) 15779L),
  OpcUa_BinarySchema_DataSetWriterDataType_DictionaryFragment((int) 15780L),
  OpcUa_BinarySchema_DataSetWriterTransportDataType((int) 15781L),
  OpcUa_BinarySchema_DataSetWriterTransportDataType_DataTypeVersion((int) 15782L),
  OpcUa_BinarySchema_DataSetWriterTransportDataType_DictionaryFragment((int) 15783L),
  OpcUa_BinarySchema_DataSetWriterMessageDataType((int) 15784L),
  OpcUa_BinarySchema_DataSetWriterMessageDataType_DataTypeVersion((int) 15785L),
  OpcUa_BinarySchema_DataSetWriterMessageDataType_DictionaryFragment((int) 15786L),
  OpcUa_BinarySchema_PubSubGroupDataType((int) 15787L),
  OpcUa_BinarySchema_PubSubGroupDataType_DataTypeVersion((int) 15788L),
  OpcUa_BinarySchema_PubSubGroupDataType_DictionaryFragment((int) 15789L),
  OpcUa_BinarySchema_WriterGroupTransportDataType((int) 15793L),
  OpcUa_BinarySchema_WriterGroupTransportDataType_DataTypeVersion((int) 15852L),
  OpcUa_BinarySchema_WriterGroupTransportDataType_DictionaryFragment((int) 15853L),
  OpcUa_BinarySchema_WriterGroupMessageDataType((int) 15854L),
  OpcUa_BinarySchema_WriterGroupMessageDataType_DataTypeVersion((int) 15855L),
  OpcUa_BinarySchema_WriterGroupMessageDataType_DictionaryFragment((int) 15856L),
  OpcUa_BinarySchema_PubSubConnectionDataType((int) 15857L),
  OpcUa_BinarySchema_PubSubConnectionDataType_DataTypeVersion((int) 15858L),
  OpcUa_BinarySchema_PubSubConnectionDataType_DictionaryFragment((int) 15859L),
  OpcUa_BinarySchema_ConnectionTransportDataType((int) 15860L),
  OpcUa_BinarySchema_ConnectionTransportDataType_DataTypeVersion((int) 15861L),
  OpcUa_BinarySchema_ConnectionTransportDataType_DictionaryFragment((int) 15862L),
  OpcUa_BinarySchema_ReaderGroupTransportDataType((int) 15866L),
  OpcUa_BinarySchema_ReaderGroupTransportDataType_DataTypeVersion((int) 15867L),
  OpcUa_BinarySchema_ReaderGroupTransportDataType_DictionaryFragment((int) 15868L),
  OpcUa_BinarySchema_ReaderGroupMessageDataType((int) 15869L),
  OpcUa_BinarySchema_ReaderGroupMessageDataType_DataTypeVersion((int) 15870L),
  OpcUa_BinarySchema_ReaderGroupMessageDataType_DictionaryFragment((int) 15871L),
  OpcUa_BinarySchema_DataSetReaderDataType((int) 15872L),
  OpcUa_BinarySchema_DataSetReaderDataType_DataTypeVersion((int) 15873L),
  OpcUa_BinarySchema_DataSetReaderDataType_DictionaryFragment((int) 15876L),
  OpcUa_BinarySchema_DataSetReaderTransportDataType((int) 15877L),
  OpcUa_BinarySchema_DataSetReaderTransportDataType_DataTypeVersion((int) 15878L),
  OpcUa_BinarySchema_DataSetReaderTransportDataType_DictionaryFragment((int) 15879L),
  OpcUa_BinarySchema_DataSetReaderMessageDataType((int) 15880L),
  OpcUa_BinarySchema_DataSetReaderMessageDataType_DataTypeVersion((int) 15881L),
  OpcUa_BinarySchema_DataSetReaderMessageDataType_DictionaryFragment((int) 15882L),
  OpcUa_BinarySchema_SubscribedDataSetDataType((int) 15883L),
  OpcUa_BinarySchema_SubscribedDataSetDataType_DataTypeVersion((int) 15884L),
  OpcUa_BinarySchema_SubscribedDataSetDataType_DictionaryFragment((int) 15885L),
  OpcUa_BinarySchema_TargetVariablesDataType((int) 15886L),
  OpcUa_BinarySchema_TargetVariablesDataType_DataTypeVersion((int) 15887L),
  OpcUa_BinarySchema_TargetVariablesDataType_DictionaryFragment((int) 15888L),
  OpcUa_BinarySchema_SubscribedDataSetMirrorDataType((int) 15889L),
  OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DataTypeVersion((int) 15890L),
  OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DictionaryFragment((int) 15891L),
  OpcUa_BinarySchema_UadpWriterGroupMessageDataType((int) 15895L),
  OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DataTypeVersion((int) 15896L),
  OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DictionaryFragment((int) 15897L),
  OpcUa_BinarySchema_UadpDataSetWriterMessageDataType((int) 15898L),
  OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DataTypeVersion((int) 15899L),
  OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DictionaryFragment((int) 15900L),
  OpcUa_BinarySchema_UadpDataSetReaderMessageDataType((int) 15919L),
  OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DataTypeVersion((int) 15920L),
  OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DictionaryFragment((int) 15921L),
  OpcUa_BinarySchema_JsonWriterGroupMessageDataType((int) 15922L),
  OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DataTypeVersion((int) 15923L),
  OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DictionaryFragment((int) 15924L),
  OpcUa_BinarySchema_JsonDataSetWriterMessageDataType((int) 15925L),
  OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DataTypeVersion((int) 15929L),
  OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DictionaryFragment((int) 15930L),
  OpcUa_BinarySchema_JsonDataSetReaderMessageDataType((int) 15931L),
  OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DataTypeVersion((int) 15935L),
  OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DictionaryFragment((int) 15936L),
  OpcUa_BinarySchema_BrokerWriterGroupTransportDataType((int) 15940L),
  OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DataTypeVersion((int) 15941L),
  OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DictionaryFragment((int) 15942L),
  OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType((int) 15943L),
  OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DataTypeVersion((int) 15944L),
  OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DictionaryFragment((int) 15945L),
  OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType((int) 15946L),
  OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DataTypeVersion((int) 15947L),
  OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DictionaryFragment((int) 15948L),
  OpcUa_XmlSchema_EndpointType((int) 16024L),
  OpcUa_XmlSchema_EndpointType_DataTypeVersion((int) 16025L),
  OpcUa_XmlSchema_EndpointType_DictionaryFragment((int) 16026L),
  OpcUa_XmlSchema_DataTypeSchemaHeader((int) 16027L),
  OpcUa_XmlSchema_DataTypeSchemaHeader_DataTypeVersion((int) 16028L),
  OpcUa_XmlSchema_DataTypeSchemaHeader_DictionaryFragment((int) 16029L),
  OpcUa_XmlSchema_PublishedDataSetDataType((int) 16030L),
  OpcUa_XmlSchema_PublishedDataSetDataType_DataTypeVersion((int) 16031L),
  OpcUa_XmlSchema_PublishedDataSetDataType_DictionaryFragment((int) 16032L),
  OpcUa_XmlSchema_PublishedDataSetSourceDataType((int) 16033L),
  OpcUa_XmlSchema_PublishedDataSetSourceDataType_DataTypeVersion((int) 16034L),
  OpcUa_XmlSchema_PublishedDataSetSourceDataType_DictionaryFragment((int) 16035L),
  OpcUa_XmlSchema_PublishedDataItemsDataType((int) 16037L),
  OpcUa_XmlSchema_PublishedDataItemsDataType_DataTypeVersion((int) 16038L),
  OpcUa_XmlSchema_PublishedDataItemsDataType_DictionaryFragment((int) 16039L),
  OpcUa_XmlSchema_PublishedEventsDataType((int) 16040L),
  OpcUa_XmlSchema_PublishedEventsDataType_DataTypeVersion((int) 16045L),
  OpcUa_XmlSchema_PublishedEventsDataType_DictionaryFragment((int) 16046L),
  OpcUa_XmlSchema_DataSetWriterDataType((int) 16047L),
  OpcUa_XmlSchema_DataSetWriterDataType_DataTypeVersion((int) 16048L),
  OpcUa_XmlSchema_DataSetWriterDataType_DictionaryFragment((int) 16049L),
  OpcUa_XmlSchema_DataSetWriterTransportDataType((int) 16050L),
  OpcUa_XmlSchema_DataSetWriterTransportDataType_DataTypeVersion((int) 16051L),
  OpcUa_XmlSchema_DataSetWriterTransportDataType_DictionaryFragment((int) 16052L),
  OpcUa_XmlSchema_DataSetWriterMessageDataType((int) 16053L),
  OpcUa_XmlSchema_DataSetWriterMessageDataType_DataTypeVersion((int) 16054L),
  OpcUa_XmlSchema_DataSetWriterMessageDataType_DictionaryFragment((int) 16055L),
  OpcUa_XmlSchema_PubSubGroupDataType((int) 16056L),
  OpcUa_XmlSchema_PubSubGroupDataType_DataTypeVersion((int) 16057L),
  OpcUa_XmlSchema_PubSubGroupDataType_DictionaryFragment((int) 16058L),
  OpcUa_XmlSchema_WriterGroupTransportDataType((int) 16062L),
  OpcUa_XmlSchema_WriterGroupTransportDataType_DataTypeVersion((int) 16063L),
  OpcUa_XmlSchema_WriterGroupTransportDataType_DictionaryFragment((int) 16064L),
  OpcUa_XmlSchema_WriterGroupMessageDataType((int) 16065L),
  OpcUa_XmlSchema_WriterGroupMessageDataType_DataTypeVersion((int) 16066L),
  OpcUa_XmlSchema_WriterGroupMessageDataType_DictionaryFragment((int) 16067L),
  OpcUa_XmlSchema_PubSubConnectionDataType((int) 16068L),
  OpcUa_XmlSchema_PubSubConnectionDataType_DataTypeVersion((int) 16069L),
  OpcUa_XmlSchema_PubSubConnectionDataType_DictionaryFragment((int) 16070L),
  OpcUa_XmlSchema_ConnectionTransportDataType((int) 16071L),
  OpcUa_XmlSchema_ConnectionTransportDataType_DataTypeVersion((int) 16072L),
  OpcUa_XmlSchema_ConnectionTransportDataType_DictionaryFragment((int) 16073L),
  OpcUa_XmlSchema_ReaderGroupTransportDataType((int) 16077L),
  OpcUa_XmlSchema_ReaderGroupTransportDataType_DataTypeVersion((int) 16078L),
  OpcUa_XmlSchema_ReaderGroupTransportDataType_DictionaryFragment((int) 16079L),
  OpcUa_XmlSchema_ReaderGroupMessageDataType((int) 16080L),
  OpcUa_XmlSchema_ReaderGroupMessageDataType_DataTypeVersion((int) 16081L),
  OpcUa_XmlSchema_ReaderGroupMessageDataType_DictionaryFragment((int) 16082L),
  OpcUa_XmlSchema_DataSetReaderDataType((int) 16083L),
  OpcUa_XmlSchema_DataSetReaderDataType_DataTypeVersion((int) 16084L),
  OpcUa_XmlSchema_DataSetReaderDataType_DictionaryFragment((int) 16085L),
  OpcUa_XmlSchema_DataSetReaderTransportDataType((int) 16086L),
  OpcUa_XmlSchema_DataSetReaderTransportDataType_DataTypeVersion((int) 16087L),
  OpcUa_XmlSchema_DataSetReaderTransportDataType_DictionaryFragment((int) 16088L),
  OpcUa_XmlSchema_DataSetReaderMessageDataType((int) 16089L),
  OpcUa_XmlSchema_DataSetReaderMessageDataType_DataTypeVersion((int) 16090L),
  OpcUa_XmlSchema_DataSetReaderMessageDataType_DictionaryFragment((int) 16091L),
  OpcUa_XmlSchema_SubscribedDataSetDataType((int) 16092L),
  OpcUa_XmlSchema_SubscribedDataSetDataType_DataTypeVersion((int) 16093L),
  OpcUa_XmlSchema_SubscribedDataSetDataType_DictionaryFragment((int) 16094L),
  OpcUa_XmlSchema_TargetVariablesDataType((int) 16095L),
  OpcUa_XmlSchema_TargetVariablesDataType_DataTypeVersion((int) 16096L),
  OpcUa_XmlSchema_TargetVariablesDataType_DictionaryFragment((int) 16097L),
  OpcUa_XmlSchema_SubscribedDataSetMirrorDataType((int) 16098L),
  OpcUa_XmlSchema_SubscribedDataSetMirrorDataType_DataTypeVersion((int) 16099L),
  OpcUa_XmlSchema_SubscribedDataSetMirrorDataType_DictionaryFragment((int) 16100L),
  OpcUa_XmlSchema_UadpWriterGroupMessageDataType((int) 16104L),
  OpcUa_XmlSchema_UadpWriterGroupMessageDataType_DataTypeVersion((int) 16105L),
  OpcUa_XmlSchema_UadpWriterGroupMessageDataType_DictionaryFragment((int) 16106L),
  OpcUa_XmlSchema_UadpDataSetWriterMessageDataType((int) 16107L),
  OpcUa_XmlSchema_UadpDataSetWriterMessageDataType_DataTypeVersion((int) 16108L),
  OpcUa_XmlSchema_UadpDataSetWriterMessageDataType_DictionaryFragment((int) 16109L),
  OpcUa_XmlSchema_UadpDataSetReaderMessageDataType((int) 16110L),
  OpcUa_XmlSchema_UadpDataSetReaderMessageDataType_DataTypeVersion((int) 16111L),
  OpcUa_XmlSchema_UadpDataSetReaderMessageDataType_DictionaryFragment((int) 16112L),
  OpcUa_XmlSchema_JsonWriterGroupMessageDataType((int) 16113L),
  OpcUa_XmlSchema_JsonWriterGroupMessageDataType_DataTypeVersion((int) 16114L),
  OpcUa_XmlSchema_JsonWriterGroupMessageDataType_DictionaryFragment((int) 16115L),
  OpcUa_XmlSchema_JsonDataSetWriterMessageDataType((int) 16116L),
  OpcUa_XmlSchema_JsonDataSetWriterMessageDataType_DataTypeVersion((int) 16117L),
  OpcUa_XmlSchema_JsonDataSetWriterMessageDataType_DictionaryFragment((int) 16118L),
  OpcUa_XmlSchema_JsonDataSetReaderMessageDataType((int) 16119L),
  OpcUa_XmlSchema_JsonDataSetReaderMessageDataType_DataTypeVersion((int) 16120L),
  OpcUa_XmlSchema_JsonDataSetReaderMessageDataType_DictionaryFragment((int) 16121L),
  OpcUa_XmlSchema_BrokerWriterGroupTransportDataType((int) 16125L),
  OpcUa_XmlSchema_RolePermissionType((int) 16127L),
  OpcUa_XmlSchema_RolePermissionType_DataTypeVersion((int) 16128L),
  OpcUa_XmlSchema_RolePermissionType_DictionaryFragment((int) 16129L),
  OpcUa_XmlSchema_BrokerWriterGroupTransportDataType_DataTypeVersion((int) 16130L),
  OpcUa_BinarySchema_RolePermissionType((int) 16131L),
  OpcUa_BinarySchema_RolePermissionType_DataTypeVersion((int) 16132L),
  OpcUa_BinarySchema_RolePermissionType_DictionaryFragment((int) 16133L),
  OpcUa_XmlSchema_BrokerWriterGroupTransportDataType_DictionaryFragment((int) 16143L),
  OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType((int) 16144L),
  OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType_DataTypeVersion((int) 16145L),
  OpcUa_XmlSchema_BrokerDataSetWriterTransportDataType_DictionaryFragment((int) 16146L),
  OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType((int) 16147L),
  OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType_DataTypeVersion((int) 16148L),
  OpcUa_XmlSchema_BrokerDataSetReaderTransportDataType_DictionaryFragment((int) 16149L),
  OpcUa_BinarySchema_DatagramConnectionTransportDataType((int) 17469L),
  OpcUa_BinarySchema_DatagramConnectionTransportDataType_DataTypeVersion((int) 17470L),
  OpcUa_BinarySchema_DatagramConnectionTransportDataType_DictionaryFragment((int) 17471L),
  OpcUa_XmlSchema_DatagramConnectionTransportDataType((int) 17473L),
  OpcUa_XmlSchema_DatagramConnectionTransportDataType_DataTypeVersion((int) 17474L),
  OpcUa_XmlSchema_DatagramConnectionTransportDataType_DictionaryFragment((int) 17475L),
  OpcUa_BinarySchema_AdditionalParametersType((int) 17538L),
  OpcUa_BinarySchema_AdditionalParametersType_DataTypeVersion((int) 17539L),
  OpcUa_BinarySchema_AdditionalParametersType_DictionaryFragment((int) 17540L),
  OpcUa_XmlSchema_AdditionalParametersType((int) 17542L),
  OpcUa_XmlSchema_AdditionalParametersType_DataTypeVersion((int) 17543L),
  OpcUa_XmlSchema_AdditionalParametersType_DictionaryFragment((int) 17544L),
  OpcUa_BinarySchema_EphemeralKeyType((int) 17550L),
  OpcUa_BinarySchema_EphemeralKeyType_DataTypeVersion((int) 17551L),
  OpcUa_BinarySchema_EphemeralKeyType_DictionaryFragment((int) 17552L),
  OpcUa_XmlSchema_EphemeralKeyType((int) 17554L),
  OpcUa_XmlSchema_EphemeralKeyType_DataTypeVersion((int) 17555L),
  OpcUa_XmlSchema_EphemeralKeyType_DictionaryFragment((int) 17556L),
  OpcUa_XmlSchema_DataTypeDefinition((int) 18166L),
  OpcUa_XmlSchema_DataTypeDefinition_DataTypeVersion((int) 18167L),
  OpcUa_XmlSchema_DataTypeDefinition_DictionaryFragment((int) 18168L),
  OpcUa_XmlSchema_StructureField((int) 18169L),
  OpcUa_XmlSchema_StructureField_DataTypeVersion((int) 18170L),
  OpcUa_XmlSchema_StructureField_DictionaryFragment((int) 18171L),
  OpcUa_XmlSchema_StructureDefinition((int) 18172L),
  OpcUa_XmlSchema_StructureDefinition_DataTypeVersion((int) 18173L),
  OpcUa_XmlSchema_StructureDefinition_DictionaryFragment((int) 18174L),
  OpcUa_XmlSchema_EnumDefinition((int) 18175L),
  OpcUa_XmlSchema_EnumDefinition_DataTypeVersion((int) 18176L),
  OpcUa_XmlSchema_EnumDefinition_DictionaryFragment((int) 18177L),
  OpcUa_BinarySchema_DataTypeDefinition((int) 18178L),
  OpcUa_BinarySchema_DataTypeDefinition_DataTypeVersion((int) 18179L),
  OpcUa_BinarySchema_DataTypeDefinition_DictionaryFragment((int) 18180L),
  OpcUa_BinarySchema_StructureField((int) 18181L),
  OpcUa_BinarySchema_StructureField_DataTypeVersion((int) 18182L),
  OpcUa_BinarySchema_StructureField_DictionaryFragment((int) 18183L),
  OpcUa_BinarySchema_StructureDefinition((int) 18184L),
  OpcUa_BinarySchema_StructureDefinition_DataTypeVersion((int) 18185L),
  OpcUa_BinarySchema_StructureDefinition_DictionaryFragment((int) 18186L),
  OpcUa_BinarySchema_EnumDefinition((int) 18187L),
  OpcUa_BinarySchema_EnumDefinition_DataTypeVersion((int) 18188L),
  OpcUa_BinarySchema_EnumDefinition_DictionaryFragment((int) 18189L),
  OpcUa_BinarySchema_RationalNumber((int) 18824L),
  OpcUa_BinarySchema_RationalNumber_DataTypeVersion((int) 18825L),
  OpcUa_BinarySchema_RationalNumber_DictionaryFragment((int) 18826L),
  OpcUa_BinarySchema_Vector((int) 18827L),
  OpcUa_BinarySchema_Vector_DataTypeVersion((int) 18828L),
  OpcUa_BinarySchema_Vector_DictionaryFragment((int) 18829L),
  OpcUa_BinarySchema_ThreeDVector((int) 18830L),
  OpcUa_BinarySchema_ThreeDVector_DataTypeVersion((int) 18831L),
  OpcUa_BinarySchema_ThreeDVector_DictionaryFragment((int) 18832L),
  OpcUa_BinarySchema_CartesianCoordinates((int) 18833L),
  OpcUa_BinarySchema_CartesianCoordinates_DataTypeVersion((int) 18834L),
  OpcUa_BinarySchema_CartesianCoordinates_DictionaryFragment((int) 18835L),
  OpcUa_BinarySchema_ThreeDCartesianCoordinates((int) 18836L),
  OpcUa_BinarySchema_ThreeDCartesianCoordinates_DataTypeVersion((int) 18837L),
  OpcUa_BinarySchema_ThreeDCartesianCoordinates_DictionaryFragment((int) 18838L),
  OpcUa_BinarySchema_Orientation((int) 18839L),
  OpcUa_BinarySchema_Orientation_DataTypeVersion((int) 18840L),
  OpcUa_BinarySchema_Orientation_DictionaryFragment((int) 18841L),
  OpcUa_BinarySchema_ThreeDOrientation((int) 18842L),
  OpcUa_BinarySchema_ThreeDOrientation_DataTypeVersion((int) 18843L),
  OpcUa_BinarySchema_ThreeDOrientation_DictionaryFragment((int) 18844L),
  OpcUa_BinarySchema_Frame((int) 18845L),
  OpcUa_BinarySchema_Frame_DataTypeVersion((int) 18846L),
  OpcUa_BinarySchema_Frame_DictionaryFragment((int) 18847L),
  OpcUa_BinarySchema_ThreeDFrame((int) 18848L),
  OpcUa_BinarySchema_ThreeDFrame_DataTypeVersion((int) 18849L),
  OpcUa_BinarySchema_ThreeDFrame_DictionaryFragment((int) 18850L),
  OpcUa_XmlSchema_RationalNumber((int) 18860L),
  OpcUa_XmlSchema_RationalNumber_DataTypeVersion((int) 18861L),
  OpcUa_XmlSchema_RationalNumber_DictionaryFragment((int) 18862L),
  OpcUa_XmlSchema_Vector((int) 18863L),
  OpcUa_XmlSchema_Vector_DataTypeVersion((int) 18864L),
  OpcUa_XmlSchema_Vector_DictionaryFragment((int) 18865L),
  OpcUa_XmlSchema_ThreeDVector((int) 18866L),
  OpcUa_XmlSchema_ThreeDVector_DataTypeVersion((int) 18867L),
  OpcUa_XmlSchema_ThreeDVector_DictionaryFragment((int) 18868L),
  OpcUa_XmlSchema_CartesianCoordinates((int) 18869L),
  OpcUa_XmlSchema_CartesianCoordinates_DataTypeVersion((int) 18870L),
  OpcUa_XmlSchema_CartesianCoordinates_DictionaryFragment((int) 19048L),
  OpcUa_XmlSchema_ThreeDCartesianCoordinates((int) 19049L),
  OpcUa_XmlSchema_ThreeDCartesianCoordinates_DataTypeVersion((int) 19050L),
  OpcUa_XmlSchema_ThreeDCartesianCoordinates_DictionaryFragment((int) 19051L),
  OpcUa_XmlSchema_Orientation((int) 19052L),
  OpcUa_XmlSchema_Orientation_DataTypeVersion((int) 19053L),
  OpcUa_XmlSchema_Orientation_DictionaryFragment((int) 19054L),
  OpcUa_XmlSchema_ThreeDOrientation((int) 19055L),
  OpcUa_XmlSchema_ThreeDOrientation_DataTypeVersion((int) 19056L),
  OpcUa_XmlSchema_ThreeDOrientation_DictionaryFragment((int) 19057L),
  OpcUa_XmlSchema_Frame((int) 19058L),
  OpcUa_XmlSchema_Frame_DataTypeVersion((int) 19059L),
  OpcUa_XmlSchema_Frame_DictionaryFragment((int) 19060L),
  OpcUa_XmlSchema_ThreeDFrame((int) 19061L),
  OpcUa_XmlSchema_ThreeDFrame_DataTypeVersion((int) 19062L),
  OpcUa_XmlSchema_ThreeDFrame_DictionaryFragment((int) 19063L),
  OpcUa_BinarySchema_FieldTargetDataType((int) 21002L),
  OpcUa_BinarySchema_WriterGroupDataType((int) 21156L),
  OpcUa_BinarySchema_WriterGroupDataType_DataTypeVersion((int) 21157L),
  OpcUa_BinarySchema_WriterGroupDataType_DictionaryFragment((int) 21158L),
  OpcUa_BinarySchema_NetworkAddressDataType((int) 21159L),
  OpcUa_BinarySchema_NetworkAddressDataType_DataTypeVersion((int) 21160L),
  OpcUa_BinarySchema_NetworkAddressDataType_DictionaryFragment((int) 21161L),
  OpcUa_BinarySchema_NetworkAddressUrlDataType((int) 21162L),
  OpcUa_BinarySchema_NetworkAddressUrlDataType_DataTypeVersion((int) 21163L),
  OpcUa_BinarySchema_NetworkAddressUrlDataType_DictionaryFragment((int) 21164L),
  OpcUa_BinarySchema_ReaderGroupDataType((int) 21165L),
  OpcUa_BinarySchema_ReaderGroupDataType_DataTypeVersion((int) 21166L),
  OpcUa_BinarySchema_ReaderGroupDataType_DictionaryFragment((int) 21167L),
  OpcUa_BinarySchema_PubSubConfigurationDataType((int) 21168L),
  OpcUa_BinarySchema_PubSubConfigurationDataType_DataTypeVersion((int) 21169L),
  OpcUa_BinarySchema_PubSubConfigurationDataType_DictionaryFragment((int) 21170L),
  OpcUa_BinarySchema_DatagramWriterGroupTransportDataType((int) 21171L),
  OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DataTypeVersion((int) 21172L),
  OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DictionaryFragment((int) 21173L),
  OpcUa_XmlSchema_WriterGroupDataType((int) 21180L),
  OpcUa_XmlSchema_WriterGroupDataType_DataTypeVersion((int) 21181L),
  OpcUa_XmlSchema_WriterGroupDataType_DictionaryFragment((int) 21182L),
  OpcUa_XmlSchema_NetworkAddressDataType((int) 21183L),
  OpcUa_XmlSchema_NetworkAddressDataType_DataTypeVersion((int) 21184L),
  OpcUa_XmlSchema_NetworkAddressDataType_DictionaryFragment((int) 21185L),
  OpcUa_XmlSchema_NetworkAddressUrlDataType((int) 21186L),
  OpcUa_XmlSchema_NetworkAddressUrlDataType_DataTypeVersion((int) 21187L),
  OpcUa_XmlSchema_NetworkAddressUrlDataType_DictionaryFragment((int) 21188L),
  OpcUa_XmlSchema_ReaderGroupDataType((int) 21189L),
  OpcUa_XmlSchema_ReaderGroupDataType_DataTypeVersion((int) 21190L),
  OpcUa_XmlSchema_ReaderGroupDataType_DictionaryFragment((int) 21191L),
  OpcUa_XmlSchema_PubSubConfigurationDataType((int) 21192L),
  OpcUa_XmlSchema_PubSubConfigurationDataType_DataTypeVersion((int) 21193L),
  OpcUa_XmlSchema_PubSubConfigurationDataType_DictionaryFragment((int) 21194L),
  OpcUa_XmlSchema_DatagramWriterGroupTransportDataType((int) 21195L),
  OpcUa_XmlSchema_DatagramWriterGroupTransportDataType_DataTypeVersion((int) 21196L),
  OpcUa_XmlSchema_DatagramWriterGroupTransportDataType_DictionaryFragment((int) 21197L),
  OpcUa_BinarySchema_AliasNameDataType((int) 23502L),
  OpcUa_BinarySchema_AliasNameDataType_DataTypeVersion((int) 23503L),
  OpcUa_BinarySchema_AliasNameDataType_DictionaryFragment((int) 23504L),
  OpcUa_XmlSchema_AliasNameDataType((int) 23508L),
  OpcUa_XmlSchema_AliasNameDataType_DataTypeVersion((int) 23509L),
  OpcUa_XmlSchema_AliasNameDataType_DictionaryFragment((int) 23510L),
  OpcUa_BinarySchema_CurrencyUnitType((int) 23514L),
  OpcUa_BinarySchema_CurrencyUnitType_DataTypeVersion((int) 23515L),
  OpcUa_BinarySchema_CurrencyUnitType_DictionaryFragment((int) 23516L),
  OpcUa_XmlSchema_CurrencyUnitType((int) 23522L),
  OpcUa_XmlSchema_CurrencyUnitType_DataTypeVersion((int) 23523L),
  OpcUa_XmlSchema_CurrencyUnitType_DictionaryFragment((int) 23524L),
  OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType((int) 23870L),
  OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType_DataTypeVersion((int) 23871L),
  OpcUa_BinarySchema_StandaloneSubscribedDataSetRefDataType_DictionaryFragment((int) 23872L),
  OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType((int) 23873L),
  OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType_DataTypeVersion((int) 23874L),
  OpcUa_BinarySchema_StandaloneSubscribedDataSetDataType_DictionaryFragment((int) 23875L),
  OpcUa_BinarySchema_SecurityGroupDataType((int) 23876L),
  OpcUa_BinarySchema_SecurityGroupDataType_DataTypeVersion((int) 23877L),
  OpcUa_BinarySchema_SecurityGroupDataType_DictionaryFragment((int) 23878L),
  OpcUa_BinarySchema_PubSubConfiguration2DataType((int) 23879L),
  OpcUa_BinarySchema_PubSubConfiguration2DataType_DataTypeVersion((int) 23880L),
  OpcUa_BinarySchema_PubSubConfiguration2DataType_DictionaryFragment((int) 23881L),
  OpcUa_BinarySchema_QosDataType((int) 23882L),
  OpcUa_BinarySchema_QosDataType_DataTypeVersion((int) 23883L),
  OpcUa_BinarySchema_QosDataType_DictionaryFragment((int) 23884L),
  OpcUa_BinarySchema_TransmitQosDataType((int) 23885L),
  OpcUa_BinarySchema_TransmitQosDataType_DataTypeVersion((int) 23886L),
  OpcUa_BinarySchema_TransmitQosDataType_DictionaryFragment((int) 23887L),
  OpcUa_BinarySchema_TransmitQosPriorityDataType((int) 23888L),
  OpcUa_BinarySchema_TransmitQosPriorityDataType_DataTypeVersion((int) 23889L),
  OpcUa_BinarySchema_TransmitQosPriorityDataType_DictionaryFragment((int) 23890L),
  OpcUa_BinarySchema_ReceiveQosDataType((int) 23897L),
  OpcUa_BinarySchema_ReceiveQosDataType_DataTypeVersion((int) 23898L),
  OpcUa_BinarySchema_ReceiveQosDataType_DictionaryFragment((int) 23899L),
  OpcUa_BinarySchema_ReceiveQosPriorityDataType((int) 23900L),
  OpcUa_BinarySchema_ReceiveQosPriorityDataType_DataTypeVersion((int) 23901L),
  OpcUa_BinarySchema_ReceiveQosPriorityDataType_DictionaryFragment((int) 23902L),
  OpcUa_BinarySchema_DatagramConnectionTransport2DataType((int) 23909L),
  OpcUa_BinarySchema_DatagramConnectionTransport2DataType_DataTypeVersion((int) 23910L),
  OpcUa_BinarySchema_DatagramConnectionTransport2DataType_DictionaryFragment((int) 23911L),
  OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType((int) 23912L),
  OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType_DataTypeVersion((int) 23913L),
  OpcUa_BinarySchema_DatagramWriterGroupTransport2DataType_DictionaryFragment((int) 23914L),
  OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType((int) 23915L),
  OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType_DataTypeVersion((int) 23916L),
  OpcUa_BinarySchema_DatagramDataSetReaderTransportDataType_DictionaryFragment((int) 23917L),
  OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType((int) 23938L),
  OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType_DataTypeVersion((int) 23939L),
  OpcUa_XmlSchema_StandaloneSubscribedDataSetRefDataType_DictionaryFragment((int) 23940L),
  OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType((int) 23941L),
  OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType_DataTypeVersion((int) 23942L),
  OpcUa_XmlSchema_StandaloneSubscribedDataSetDataType_DictionaryFragment((int) 23943L),
  OpcUa_XmlSchema_SecurityGroupDataType((int) 23944L),
  OpcUa_XmlSchema_SecurityGroupDataType_DataTypeVersion((int) 23945L),
  OpcUa_XmlSchema_SecurityGroupDataType_DictionaryFragment((int) 23946L),
  OpcUa_XmlSchema_PubSubConfiguration2DataType((int) 23947L),
  OpcUa_XmlSchema_PubSubConfiguration2DataType_DataTypeVersion((int) 23948L),
  OpcUa_XmlSchema_PubSubConfiguration2DataType_DictionaryFragment((int) 23949L),
  OpcUa_XmlSchema_QosDataType((int) 23950L),
  OpcUa_XmlSchema_QosDataType_DataTypeVersion((int) 23951L),
  OpcUa_XmlSchema_QosDataType_DictionaryFragment((int) 23952L),
  OpcUa_XmlSchema_TransmitQosDataType((int) 23953L),
  OpcUa_XmlSchema_TransmitQosDataType_DataTypeVersion((int) 23954L),
  OpcUa_XmlSchema_TransmitQosDataType_DictionaryFragment((int) 23955L),
  OpcUa_XmlSchema_TransmitQosPriorityDataType((int) 23956L),
  OpcUa_XmlSchema_TransmitQosPriorityDataType_DataTypeVersion((int) 23957L),
  OpcUa_XmlSchema_TransmitQosPriorityDataType_DictionaryFragment((int) 23958L),
  OpcUa_XmlSchema_ReceiveQosDataType((int) 23965L),
  OpcUa_XmlSchema_ReceiveQosDataType_DataTypeVersion((int) 23966L),
  OpcUa_XmlSchema_ReceiveQosDataType_DictionaryFragment((int) 23967L),
  OpcUa_XmlSchema_ReceiveQosPriorityDataType((int) 23968L),
  OpcUa_XmlSchema_ReceiveQosPriorityDataType_DataTypeVersion((int) 23969L),
  OpcUa_XmlSchema_ReceiveQosPriorityDataType_DictionaryFragment((int) 23970L),
  OpcUa_XmlSchema_DatagramConnectionTransport2DataType((int) 23977L),
  OpcUa_XmlSchema_DatagramConnectionTransport2DataType_DataTypeVersion((int) 23978L),
  OpcUa_XmlSchema_DatagramConnectionTransport2DataType_DictionaryFragment((int) 23979L),
  OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType((int) 23980L),
  OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType_DataTypeVersion((int) 23981L),
  OpcUa_XmlSchema_DatagramWriterGroupTransport2DataType_DictionaryFragment((int) 23982L),
  OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType((int) 23983L),
  OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType_DataTypeVersion((int) 23984L),
  OpcUa_XmlSchema_DatagramDataSetReaderTransportDataType_DictionaryFragment((int) 23985L),
  OpcUa_BinarySchema_ProgramDiagnostic2DataType((int) 24035L),
  OpcUa_BinarySchema_ProgramDiagnostic2DataType_DataTypeVersion((int) 24036L),
  OpcUa_BinarySchema_ProgramDiagnostic2DataType_DictionaryFragment((int) 24037L),
  OpcUa_XmlSchema_ProgramDiagnostic2DataType((int) 24039L),
  OpcUa_XmlSchema_ProgramDiagnostic2DataType_DataTypeVersion((int) 24040L),
  OpcUa_XmlSchema_ProgramDiagnostic2DataType_DictionaryFragment((int) 24041L),
  OpcUa_BinarySchema_PortableQualifiedName((int) 24111L),
  OpcUa_BinarySchema_PortableQualifiedName_DataTypeVersion((int) 24112L),
  OpcUa_BinarySchema_PortableQualifiedName_DictionaryFragment((int) 24113L),
  OpcUa_BinarySchema_PortableNodeId((int) 24114L),
  OpcUa_BinarySchema_PortableNodeId_DataTypeVersion((int) 24115L),
  OpcUa_BinarySchema_PortableNodeId_DictionaryFragment((int) 24116L),
  OpcUa_BinarySchema_UnsignedRationalNumber((int) 24117L),
  OpcUa_BinarySchema_UnsignedRationalNumber_DataTypeVersion((int) 24118L),
  OpcUa_BinarySchema_UnsignedRationalNumber_DictionaryFragment((int) 24119L),
  OpcUa_XmlSchema_PortableQualifiedName((int) 24123L),
  OpcUa_XmlSchema_PortableQualifiedName_DataTypeVersion((int) 24124L),
  OpcUa_XmlSchema_PortableQualifiedName_DictionaryFragment((int) 24125L),
  OpcUa_XmlSchema_PortableNodeId((int) 24126L),
  OpcUa_XmlSchema_PortableNodeId_DataTypeVersion((int) 24127L),
  OpcUa_XmlSchema_PortableNodeId_DictionaryFragment((int) 24128L),
  OpcUa_XmlSchema_UnsignedRationalNumber((int) 24129L),
  OpcUa_XmlSchema_UnsignedRationalNumber_DataTypeVersion((int) 24130L),
  OpcUa_XmlSchema_UnsignedRationalNumber_DictionaryFragment((int) 24131L),
  OpcUa_BinarySchema_UserManagementDataType((int) 24293L),
  OpcUa_BinarySchema_UserManagementDataType_DataTypeVersion((int) 24294L),
  OpcUa_BinarySchema_UserManagementDataType_DictionaryFragment((int) 24295L),
  OpcUa_XmlSchema_UserManagementDataType((int) 24297L),
  OpcUa_XmlSchema_UserManagementDataType_DataTypeVersion((int) 24298L),
  OpcUa_XmlSchema_UserManagementDataType_DictionaryFragment((int) 24299L),
  OpcUa_BinarySchema_PriorityMappingEntryType((int) 25240L),
  OpcUa_BinarySchema_PriorityMappingEntryType_DataTypeVersion((int) 25241L),
  OpcUa_BinarySchema_PriorityMappingEntryType_DictionaryFragment((int) 25242L),
  OpcUa_XmlSchema_PriorityMappingEntryType((int) 25244L),
  OpcUa_XmlSchema_PriorityMappingEntryType_DataTypeVersion((int) 25245L),
  OpcUa_XmlSchema_PriorityMappingEntryType_DictionaryFragment((int) 25246L),
  OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType((int) 25533L),
  OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType_DataTypeVersion((int) 25534L),
  OpcUa_BinarySchema_PublishedDataSetCustomSourceDataType_DictionaryFragment((int) 25535L),
  OpcUa_BinarySchema_PubSubKeyPushTargetDataType((int) 25536L),
  OpcUa_BinarySchema_PubSubKeyPushTargetDataType_DataTypeVersion((int) 25537L),
  OpcUa_BinarySchema_PubSubKeyPushTargetDataType_DictionaryFragment((int) 25538L),
  OpcUa_BinarySchema_PubSubConfigurationRefDataType((int) 25539L),
  OpcUa_BinarySchema_PubSubConfigurationRefDataType_DataTypeVersion((int) 25540L),
  OpcUa_BinarySchema_PubSubConfigurationRefDataType_DictionaryFragment((int) 25541L),
  OpcUa_BinarySchema_PubSubConfigurationValueDataType((int) 25542L),
  OpcUa_BinarySchema_PubSubConfigurationValueDataType_DataTypeVersion((int) 25543L),
  OpcUa_BinarySchema_PubSubConfigurationValueDataType_DictionaryFragment((int) 25544L),
  OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType((int) 25549L),
  OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType_DataTypeVersion((int) 25550L),
  OpcUa_XmlSchema_PublishedDataSetCustomSourceDataType_DictionaryFragment((int) 25551L),
  OpcUa_XmlSchema_PubSubKeyPushTargetDataType((int) 25552L),
  OpcUa_XmlSchema_PubSubKeyPushTargetDataType_DataTypeVersion((int) 25553L),
  OpcUa_XmlSchema_PubSubKeyPushTargetDataType_DictionaryFragment((int) 25554L),
  OpcUa_XmlSchema_PubSubConfigurationRefDataType((int) 25555L),
  OpcUa_XmlSchema_PubSubConfigurationRefDataType_DataTypeVersion((int) 25556L),
  OpcUa_XmlSchema_PubSubConfigurationRefDataType_DictionaryFragment((int) 25557L),
  OpcUa_XmlSchema_PubSubConfigurationValueDataType((int) 25558L),
  OpcUa_XmlSchema_PubSubConfigurationValueDataType_DataTypeVersion((int) 25559L),
  OpcUa_XmlSchema_PubSubConfigurationValueDataType_DictionaryFragment((int) 25560L),
  OpcUa_BinarySchema_TransactionErrorType((int) 32383L),
  OpcUa_BinarySchema_TransactionErrorType_DataTypeVersion((int) 32384L),
  OpcUa_BinarySchema_TransactionErrorType_DictionaryFragment((int) 32385L),
  OpcUa_XmlSchema_TransactionErrorType((int) 32387L),
  OpcUa_XmlSchema_TransactionErrorType_DataTypeVersion((int) 32388L),
  OpcUa_XmlSchema_TransactionErrorType_DictionaryFragment((int) 32389L),
  OpcUa_BinarySchema_BitFieldDefinition((int) 32423L),
  OpcUa_BinarySchema_BitFieldDefinition_DataTypeVersion((int) 32424L),
  OpcUa_BinarySchema_BitFieldDefinition_DictionaryFragment((int) 32425L),
  OpcUa_XmlSchema_BitFieldDefinition((int) 32427L),
  OpcUa_XmlSchema_BitFieldDefinition_DataTypeVersion((int) 32428L),
  OpcUa_XmlSchema_BitFieldDefinition_DictionaryFragment((int) 32429L),
  OpcUa_BinarySchema_AnnotationDataType((int) 32563L),
  OpcUa_BinarySchema_AnnotationDataType_DataTypeVersion((int) 32564L),
  OpcUa_BinarySchema_AnnotationDataType_DictionaryFragment((int) 32565L),
  OpcUa_BinarySchema_LinearConversionDataType((int) 32566L),
  OpcUa_BinarySchema_LinearConversionDataType_DataTypeVersion((int) 32567L),
  OpcUa_BinarySchema_LinearConversionDataType_DictionaryFragment((int) 32568L),
  OpcUa_BinarySchema_QuantityDimension((int) 32569L),
  OpcUa_BinarySchema_QuantityDimension_DataTypeVersion((int) 32570L),
  OpcUa_BinarySchema_QuantityDimension_DictionaryFragment((int) 32571L),
  OpcUa_XmlSchema_AnnotationDataType((int) 32575L),
  OpcUa_XmlSchema_AnnotationDataType_DataTypeVersion((int) 32576L),
  OpcUa_XmlSchema_AnnotationDataType_DictionaryFragment((int) 32577L),
  OpcUa_XmlSchema_LinearConversionDataType((int) 32578L),
  OpcUa_XmlSchema_LinearConversionDataType_DataTypeVersion((int) 32579L),
  OpcUa_XmlSchema_LinearConversionDataType_DictionaryFragment((int) 32580L),
  OpcUa_XmlSchema_QuantityDimension((int) 32581L),
  OpcUa_XmlSchema_QuantityDimension_DataTypeVersion((int) 32582L),
  OpcUa_XmlSchema_QuantityDimension_DictionaryFragment((int) 32583L),
  OpcUa_BinarySchema_ReferenceDescriptionDataType((int) 32663L),
  OpcUa_BinarySchema_ReferenceDescriptionDataType_DataTypeVersion((int) 32664L),
  OpcUa_BinarySchema_ReferenceDescriptionDataType_DictionaryFragment((int) 32665L),
  OpcUa_BinarySchema_ReferenceListEntryDataType((int) 32666L),
  OpcUa_BinarySchema_ReferenceListEntryDataType_DataTypeVersion((int) 32667L),
  OpcUa_BinarySchema_ReferenceListEntryDataType_DictionaryFragment((int) 32668L),
  OpcUa_XmlSchema_ReferenceDescriptionDataType((int) 32671L),
  OpcUa_XmlSchema_ReferenceDescriptionDataType_DataTypeVersion((int) 32672L),
  OpcUa_XmlSchema_ReferenceDescriptionDataType_DictionaryFragment((int) 32673L),
  OpcUa_XmlSchema_ReferenceListEntryDataType((int) 32674L),
  OpcUa_XmlSchema_ReferenceListEntryDataType_DataTypeVersion((int) 32675L),
  OpcUa_XmlSchema_ReferenceListEntryDataType_DictionaryFragment((int) 32676L),
  OpcUa_BinarySchema_HistoryModifiedEvent((int) 32826L),
  OpcUa_BinarySchema_HistoryModifiedEvent_DataTypeVersion((int) 32827L),
  OpcUa_BinarySchema_HistoryModifiedEvent_DictionaryFragment((int) 32828L),
  OpcUa_XmlSchema_HistoryModifiedEvent((int) 32830L),
  OpcUa_XmlSchema_HistoryModifiedEvent_DataTypeVersion((int) 32831L),
  OpcUa_XmlSchema_HistoryModifiedEvent_DictionaryFragment((int) 32832L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableOpc> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableOpc value : OpcuaNodeIdServicesVariableOpc.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableOpc(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableOpc enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
