/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableSession {
  SessionDiagnosticsObjectType_SessionDiagnostics((int) 2030L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics((int) 2031L),
  SessionDiagnosticsObjectType_SubscriptionDiagnosticsArray((int) 2032L),
  SessionDiagnosticsVariableType_SessionId((int) 2198L),
  SessionDiagnosticsVariableType_SessionName((int) 2199L),
  SessionDiagnosticsVariableType_ClientDescription((int) 2200L),
  SessionDiagnosticsVariableType_ServerUri((int) 2201L),
  SessionDiagnosticsVariableType_EndpointUrl((int) 2202L),
  SessionDiagnosticsVariableType_LocaleIds((int) 2203L),
  SessionDiagnosticsVariableType_ActualSessionTimeout((int) 2204L),
  SessionDiagnosticsVariableType_ClientConnectionTime((int) 2205L),
  SessionDiagnosticsVariableType_ClientLastContactTime((int) 2206L),
  SessionDiagnosticsVariableType_CurrentSubscriptionsCount((int) 2207L),
  SessionDiagnosticsVariableType_CurrentMonitoredItemsCount((int) 2208L),
  SessionDiagnosticsVariableType_CurrentPublishRequestsInQueue((int) 2209L),
  SessionDiagnosticsVariableType_ReadCount((int) 2217L),
  SessionDiagnosticsVariableType_HistoryReadCount((int) 2218L),
  SessionDiagnosticsVariableType_WriteCount((int) 2219L),
  SessionDiagnosticsVariableType_HistoryUpdateCount((int) 2220L),
  SessionDiagnosticsVariableType_CallCount((int) 2221L),
  SessionDiagnosticsVariableType_CreateMonitoredItemsCount((int) 2222L),
  SessionDiagnosticsVariableType_ModifyMonitoredItemsCount((int) 2223L),
  SessionDiagnosticsVariableType_SetMonitoringModeCount((int) 2224L),
  SessionDiagnosticsVariableType_SetTriggeringCount((int) 2225L),
  SessionDiagnosticsVariableType_DeleteMonitoredItemsCount((int) 2226L),
  SessionDiagnosticsVariableType_CreateSubscriptionCount((int) 2227L),
  SessionDiagnosticsVariableType_ModifySubscriptionCount((int) 2228L),
  SessionDiagnosticsVariableType_SetPublishingModeCount((int) 2229L),
  SessionDiagnosticsVariableType_PublishCount((int) 2230L),
  SessionDiagnosticsVariableType_RepublishCount((int) 2231L),
  SessionDiagnosticsVariableType_TransferSubscriptionsCount((int) 2232L),
  SessionDiagnosticsVariableType_DeleteSubscriptionsCount((int) 2233L),
  SessionDiagnosticsVariableType_AddNodesCount((int) 2234L),
  SessionDiagnosticsVariableType_AddReferencesCount((int) 2235L),
  SessionDiagnosticsVariableType_DeleteNodesCount((int) 2236L),
  SessionDiagnosticsVariableType_DeleteReferencesCount((int) 2237L),
  SessionDiagnosticsVariableType_BrowseCount((int) 2238L),
  SessionDiagnosticsVariableType_BrowseNextCount((int) 2239L),
  SessionDiagnosticsVariableType_TranslateBrowsePathsToNodeIdsCount((int) 2240L),
  SessionDiagnosticsVariableType_QueryFirstCount((int) 2241L),
  SessionDiagnosticsVariableType_QueryNextCount((int) 2242L),
  SessionSecurityDiagnosticsType_SessionId((int) 2245L),
  SessionSecurityDiagnosticsType_ClientUserIdOfSession((int) 2246L),
  SessionSecurityDiagnosticsType_ClientUserIdHistory((int) 2247L),
  SessionSecurityDiagnosticsType_AuthenticationMechanism((int) 2248L),
  SessionSecurityDiagnosticsType_Encoding((int) 2249L),
  SessionSecurityDiagnosticsType_TransportProtocol((int) 2250L),
  SessionSecurityDiagnosticsType_SecurityMode((int) 2251L),
  SessionSecurityDiagnosticsType_SecurityPolicyUri((int) 2252L),
  SessionDiagnosticsVariableType_RegisterNodesCount((int) 2730L),
  SessionDiagnosticsVariableType_UnregisterNodesCount((int) 2731L),
  SessionDiagnosticsVariableType_MaxResponseMessageSize((int) 3050L),
  SessionSecurityDiagnosticsType_ClientCertificate((int) 3058L),
  SessionDiagnosticsObjectType_SessionDiagnostics_SessionId((int) 3131L),
  SessionDiagnosticsObjectType_SessionDiagnostics_SessionName((int) 3132L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ClientDescription((int) 3133L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ServerUri((int) 3134L),
  SessionDiagnosticsObjectType_SessionDiagnostics_EndpointUrl((int) 3135L),
  SessionDiagnosticsObjectType_SessionDiagnostics_LocaleIds((int) 3136L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ActualSessionTimeout((int) 3137L),
  SessionDiagnosticsObjectType_SessionDiagnostics_MaxResponseMessageSize((int) 3138L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ClientConnectionTime((int) 3139L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ClientLastContactTime((int) 3140L),
  SessionDiagnosticsObjectType_SessionDiagnostics_CurrentSubscriptionsCount((int) 3141L),
  SessionDiagnosticsObjectType_SessionDiagnostics_CurrentMonitoredItemsCount((int) 3142L),
  SessionDiagnosticsObjectType_SessionDiagnostics_CurrentPublishRequestsInQueue((int) 3143L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ReadCount((int) 3151L),
  SessionDiagnosticsObjectType_SessionDiagnostics_HistoryReadCount((int) 3152L),
  SessionDiagnosticsObjectType_SessionDiagnostics_WriteCount((int) 3153L),
  SessionDiagnosticsObjectType_SessionDiagnostics_HistoryUpdateCount((int) 3154L),
  SessionDiagnosticsObjectType_SessionDiagnostics_CallCount((int) 3155L),
  SessionDiagnosticsObjectType_SessionDiagnostics_CreateMonitoredItemsCount((int) 3156L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ModifyMonitoredItemsCount((int) 3157L),
  SessionDiagnosticsObjectType_SessionDiagnostics_SetMonitoringModeCount((int) 3158L),
  SessionDiagnosticsObjectType_SessionDiagnostics_SetTriggeringCount((int) 3159L),
  SessionDiagnosticsObjectType_SessionDiagnostics_DeleteMonitoredItemsCount((int) 3160L),
  SessionDiagnosticsObjectType_SessionDiagnostics_CreateSubscriptionCount((int) 3161L),
  SessionDiagnosticsObjectType_SessionDiagnostics_ModifySubscriptionCount((int) 3162L),
  SessionDiagnosticsObjectType_SessionDiagnostics_SetPublishingModeCount((int) 3163L),
  SessionDiagnosticsObjectType_SessionDiagnostics_PublishCount((int) 3164L),
  SessionDiagnosticsObjectType_SessionDiagnostics_RepublishCount((int) 3165L),
  SessionDiagnosticsObjectType_SessionDiagnostics_TransferSubscriptionsCount((int) 3166L),
  SessionDiagnosticsObjectType_SessionDiagnostics_DeleteSubscriptionsCount((int) 3167L),
  SessionDiagnosticsObjectType_SessionDiagnostics_AddNodesCount((int) 3168L),
  SessionDiagnosticsObjectType_SessionDiagnostics_AddReferencesCount((int) 3169L),
  SessionDiagnosticsObjectType_SessionDiagnostics_DeleteNodesCount((int) 3170L),
  SessionDiagnosticsObjectType_SessionDiagnostics_DeleteReferencesCount((int) 3171L),
  SessionDiagnosticsObjectType_SessionDiagnostics_BrowseCount((int) 3172L),
  SessionDiagnosticsObjectType_SessionDiagnostics_BrowseNextCount((int) 3173L),
  SessionDiagnosticsObjectType_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount((int) 3174L),
  SessionDiagnosticsObjectType_SessionDiagnostics_QueryFirstCount((int) 3175L),
  SessionDiagnosticsObjectType_SessionDiagnostics_QueryNextCount((int) 3176L),
  SessionDiagnosticsObjectType_SessionDiagnostics_RegisterNodesCount((int) 3177L),
  SessionDiagnosticsObjectType_SessionDiagnostics_UnregisterNodesCount((int) 3178L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SessionId((int) 3179L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientUserIdOfSession((int) 3180L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientUserIdHistory((int) 3181L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_AuthenticationMechanism((int) 3182L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_Encoding((int) 3183L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_TransportProtocol((int) 3184L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SecurityMode((int) 3185L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SecurityPolicyUri((int) 3186L),
  SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientCertificate((int) 3187L),
  SessionDiagnosticsObjectType_SessionDiagnostics_TotalRequestCount((int) 8898L),
  SessionDiagnosticsVariableType_TotalRequestCount((int) 8900L),
  SessionDiagnosticsObjectType_SessionDiagnostics_UnauthorizedRequestCount((int) 11891L),
  SessionDiagnosticsVariableType_UnauthorizedRequestCount((int) 11892L),
  SessionDiagnosticsArrayType_SessionDiagnostics((int) 12816L),
  SessionDiagnosticsArrayType_SessionDiagnostics_SessionId((int) 12817L),
  SessionDiagnosticsArrayType_SessionDiagnostics_SessionName((int) 12818L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ClientDescription((int) 12819L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ServerUri((int) 12820L),
  SessionDiagnosticsArrayType_SessionDiagnostics_EndpointUrl((int) 12821L),
  SessionDiagnosticsArrayType_SessionDiagnostics_LocaleIds((int) 12822L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ActualSessionTimeout((int) 12823L),
  SessionDiagnosticsArrayType_SessionDiagnostics_MaxResponseMessageSize((int) 12824L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ClientConnectionTime((int) 12825L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ClientLastContactTime((int) 12826L),
  SessionDiagnosticsArrayType_SessionDiagnostics_CurrentSubscriptionsCount((int) 12827L),
  SessionDiagnosticsArrayType_SessionDiagnostics_CurrentMonitoredItemsCount((int) 12828L),
  SessionDiagnosticsArrayType_SessionDiagnostics_CurrentPublishRequestsInQueue((int) 12829L),
  SessionDiagnosticsArrayType_SessionDiagnostics_TotalRequestCount((int) 12830L),
  SessionDiagnosticsArrayType_SessionDiagnostics_UnauthorizedRequestCount((int) 12831L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ReadCount((int) 12832L),
  SessionDiagnosticsArrayType_SessionDiagnostics_HistoryReadCount((int) 12833L),
  SessionDiagnosticsArrayType_SessionDiagnostics_WriteCount((int) 12834L),
  SessionDiagnosticsArrayType_SessionDiagnostics_HistoryUpdateCount((int) 12835L),
  SessionDiagnosticsArrayType_SessionDiagnostics_CallCount((int) 12836L),
  SessionDiagnosticsArrayType_SessionDiagnostics_CreateMonitoredItemsCount((int) 12837L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ModifyMonitoredItemsCount((int) 12838L),
  SessionDiagnosticsArrayType_SessionDiagnostics_SetMonitoringModeCount((int) 12839L),
  SessionDiagnosticsArrayType_SessionDiagnostics_SetTriggeringCount((int) 12840L),
  SessionDiagnosticsArrayType_SessionDiagnostics_DeleteMonitoredItemsCount((int) 12841L),
  SessionDiagnosticsArrayType_SessionDiagnostics_CreateSubscriptionCount((int) 12842L),
  SessionDiagnosticsArrayType_SessionDiagnostics_ModifySubscriptionCount((int) 12843L),
  SessionDiagnosticsArrayType_SessionDiagnostics_SetPublishingModeCount((int) 12844L),
  SessionDiagnosticsArrayType_SessionDiagnostics_PublishCount((int) 12845L),
  SessionDiagnosticsArrayType_SessionDiagnostics_RepublishCount((int) 12846L),
  SessionDiagnosticsArrayType_SessionDiagnostics_TransferSubscriptionsCount((int) 12847L),
  SessionDiagnosticsArrayType_SessionDiagnostics_DeleteSubscriptionsCount((int) 12848L),
  SessionDiagnosticsArrayType_SessionDiagnostics_AddNodesCount((int) 12849L),
  SessionDiagnosticsArrayType_SessionDiagnostics_AddReferencesCount((int) 12850L),
  SessionDiagnosticsArrayType_SessionDiagnostics_DeleteNodesCount((int) 12851L),
  SessionDiagnosticsArrayType_SessionDiagnostics_DeleteReferencesCount((int) 12852L),
  SessionDiagnosticsArrayType_SessionDiagnostics_BrowseCount((int) 12853L),
  SessionDiagnosticsArrayType_SessionDiagnostics_BrowseNextCount((int) 12854L),
  SessionDiagnosticsArrayType_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount((int) 12855L),
  SessionDiagnosticsArrayType_SessionDiagnostics_QueryFirstCount((int) 12856L),
  SessionDiagnosticsArrayType_SessionDiagnostics_QueryNextCount((int) 12857L),
  SessionDiagnosticsArrayType_SessionDiagnostics_RegisterNodesCount((int) 12858L),
  SessionDiagnosticsArrayType_SessionDiagnostics_UnregisterNodesCount((int) 12859L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics((int) 12860L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SessionId((int) 12861L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientUserIdOfSession(
      (int) 12862L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientUserIdHistory((int) 12863L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_AuthenticationMechanism(
      (int) 12864L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_Encoding((int) 12865L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_TransportProtocol((int) 12866L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SecurityMode((int) 12867L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SecurityPolicyUri((int) 12868L),
  SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientCertificate((int) 12869L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableSession> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableSession value : OpcuaNodeIdServicesVariableSession.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableSession(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableSession enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
