/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableState {
  StateType_StateNumber((int) 2308L),
  StateVariableType_Id((int) 2756L),
  StateVariableType_Name((int) 2757L),
  StateVariableType_Number((int) 2758L),
  StateVariableType_EffectiveDisplayName((int) 2759L),
  StateMachineType_CurrentState((int) 2769L),
  StateMachineType_LastTransition((int) 2770L),
  StateMachineType_CurrentState_Id((int) 3720L),
  StateMachineType_CurrentState_Name((int) 3721L),
  StateMachineType_CurrentState_Number((int) 3722L),
  StateMachineType_CurrentState_EffectiveDisplayName((int) 3723L),
  StateMachineType_LastTransition_Id((int) 3724L),
  StateMachineType_LastTransition_Name((int) 3725L),
  StateMachineType_LastTransition_Number((int) 3726L),
  StateMachineType_LastTransition_TransitionTime((int) 3727L),
  StateMachineType_LastTransition_EffectiveTransitionTime((int) 11458L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableState> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableState value : OpcuaNodeIdServicesVariableState.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableState(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableState enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
