/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableTrust {
  TrustListType_LastUpdateTime((int) 12542L),
  TrustListType_OpenWithMasks_InputArguments((int) 12544L),
  TrustListType_OpenWithMasks_OutputArguments((int) 12545L),
  TrustListType_CloseAndUpdate_OutputArguments((int) 12547L),
  TrustListType_AddCertificate_InputArguments((int) 12549L),
  TrustListType_RemoveCertificate_InputArguments((int) 12551L),
  TrustListMasks_EnumValues((int) 12553L),
  TrustListType_CloseAndUpdate_InputArguments((int) 12705L),
  TrustListType_UpdateFrequency((int) 19296L),
  TrustListOutOfDateAlarmType_TrustListId((int) 19446L),
  TrustListOutOfDateAlarmType_LastUpdateTime((int) 19447L),
  TrustListOutOfDateAlarmType_UpdateFrequency((int) 19448L),
  TrustListType_DefaultValidationOptions((int) 23563L),
  TrustListValidationOptions_OptionSetValues((int) 23565L),
  TrustListType_ActivityTimeout((int) 32254L),
  TrustListUpdatedAuditEventType_TrustListId((int) 32281L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableTrust> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableTrust value : OpcuaNodeIdServicesVariableTrust.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableTrust(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableTrust enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
